package nxm.audio.lib;

import java.io.InputStream;
import java.io.IOException;

public class AudioInputStream extends InputStream{

  protected AudioFormat format = null;
  protected long frameLength = 0;
  protected long framePos = 0;
  protected int frameSize = 0;
  InputStream stream = null;

  public AudioInputStream(InputStream stream, AudioFormat format, long length) {
    this.stream = stream;
    this.format = format;
    this.frameLength = length;
    this.framePos = 0;
    this.frameSize = format.getFrameSize();
  }

  public int available() throws IOException {
    return stream.available();
  }

  public void close() throws IOException {
    stream.close();
  }

  public AudioFormat getFormat() {
    return format;
  }

  public long getFrameLength() {
    return frameLength;
  }

  public void mark(int readlimit) {
    stream.mark(readlimit);
  }

  public boolean markSupported() {
    return stream.markSupported();
  }

  public int read() throws IOException {
    return stream.read();
  }

  public int read(byte [] b) throws IOException {
    return stream.read(b);
  }

  public int read(byte [] b, int off, int len) throws IOException {
    return stream.read(b, off, len);
  }

  public void reset() throws IOException {
    stream.reset();
  }

  public long skip(long n) throws IOException {
    return stream.skip(n);
  }

}

