package nxm.audio.lib;

import java.io.IOException;
import java.io.ByteArrayInputStream;
import java.io.File;

public class AudioWriter {

  private AudioWriter() {}

  public static void write(String filename, boolean mulaw_f, byte [] data, float rate,int size) throws IOException {
    AudioFormat af = new AudioFormat(rate,size,1,true,false);
    ByteArrayInputStream bais = new ByteArrayInputStream(data);
    AudioInputStream ais = new AudioInputStream(bais, af, data.length);
    AudioSystem.write(ais, AudioFileFormat.Type.AU, new File(filename),mulaw_f);
  }

  /** Default size of 8 */
  public static void write(String filename, boolean mulaw_f, byte [] data, float rate) throws IOException {
    write(filename, mulaw_f, data, rate, 8);
  }
}

