package nxm.audio.prim;

import nxm.sys.lib.MidasException;
import nxm.sys.lib.Primitive;
import nxm.sys.lib.DataFile;
import java.io.FileInputStream;
import java.io.IOException;
import nxm.audio.lib.AudioWriter;

/** 
  Converts a AU file into BLUE format.

  @author Wayne G. Dengel II
  @version $Id: blue2au_g2.java,v 1.4 2007/09/04 23:47:02 jph Exp $
*/
public class blue2au_g2 extends Primitive {

  public int open() {
    DataFile      inHcb = MA.getDataFile("INFILE");
    String        fname = MA.getS("OUTFILE");
    boolean       mulaw = MA.isPresent("/MULAW");
    FileInputStream fos = null;

    String aux_write  = (String)MR.get("AUX.WRITE");	
    String write_path = (String)MR.get("AUX."+aux_write);	
    String user       = (String)MR.get("ENV.USER");

    int badchar = write_path.indexOf('+');
    if(badchar != -1) {
      write_path = new String(write_path.substring(0,badchar)+user+"/");
    }
    String outFile = new String(write_path+fname);

    inHcb.open();
    if (!inHcb.isOpen) return FINISH;

    int data_avail=0;
    try {
      data_avail = (int)inHcb.avail();
      if (data_avail==0) {
        M.info("No data to read");
        return FINISH;
      }
      data_avail = data_avail*(int)inHcb.getBPE();
    }
    catch(Exception e) {
      throw new MidasException("Exception on AVAIL", e);
      // NTN: The line below discards any nested exception and makes debugging difficult.
      //      Additionally the code below M.error(..) is never executed.
      // M.error("Exception on AVAIL "+e);
      // return (FINISH);
    }
    byte data[] = new byte[data_avail];
    int got=0;
    try {
      got=inHcb.read(data,0,data_avail);
      AudioWriter.write(outFile.toLowerCase(),mulaw,data,(float)8000.0);
    }
    catch (IOException e) {
      M.error(e);
      return FINISH;
    }		
    return FINISH;
  }
}
