package nxm.nmpostlegacy.prim;

import nxm.sys.inc.*;
import nxm.sys.lib.*;
import nxm.sys.intr.Sedit;
import java.util.StringTokenizer;

/**
 @version $Id: convbg.java,v 1.2 2013/01/07 21:10:21 ntn Exp $
 */
public class convbg extends Primitive {

  private static final String XmlInnerTableDuplicateDelim = "__";

  public int open() {

    //String conv = MA.getS("CONV");
    //if (conv.equals("XML2TBL")) convertXMLText2Table();
    //else M.error ("Unsupported conversion: "+conv);

    return NORMAL;
  }

  public int process() {
    convertXMLText2Table();
    return FINISH;
  }

//KEEP
  /* Convert an XML text file into a Midas table */
  private int convertXMLText2Table() {
    Table output, out;
    TextFile tf    = MA.getTextFile("IN");
    String mainKey = MA.getS("/XMLKEY","XML");
    String tout    = MA.getU("OUT");

    output = convertXMLText2Table (tf);
    out = output.getTable(mainKey);


    if (out != null){
      out.put("NAME",tout);
      MQ.put("CONVBG",0,(Object)out,"MAIN");
    }
    return NORMAL;
  }

//KEEP
  /* Convert an XML text file object into a table object */
  private Table convertXMLText2Table(TextFile tf) {
    Table output;
    String line;
    StringBuffer data = new StringBuffer();

    output = new Table();
    try {
      tf.open(TextFile.INPUT|TextFile.NOABORT);
      while (tf.isOpen() && (line=tf.read())!=null) {
        data.append(line.trim());
      }
      tf.close();
    } catch (Exception e) {
      throw new MidasException("File open exception.", e);
    }

    String xmlString = data.toString();
    if (xmlString.indexOf ("<XML") <  0) {
      M.warning ("No XML tag, will attempt to convert anyway");
    }
    fromXML(xmlString, output);
    return output;
  }



//KEEP
  /** de-serialize from an XML format */
  private void fromXML(String bufferString, Table output) {
    String tableName = "";
    String newName = "";
    StringTokenizer lineST;

    StringTokenizer mainST = new StringTokenizer(bufferString,"<>",false);
    String line,nextline;

    while (mainST.hasMoreTokens()) {
      line = mainST.nextToken();

      // Single line entry with "name" and multiple key=value pairs
      // Example:  <GEO GMODE="4" GTHR="1" />
      if (line.endsWith("/")) {
        line = line.substring(0,line.length()-1);
        lineST = new StringTokenizer(line);
        tableName = lineST.nextToken();
        newName = output.getUniqueKey(tableName, XmlInnerTableDuplicateDelim);
        output.put(newName,makeXMLTableFromLine(lineST));

        // Handle multi-line entries
      } else {
        lineST = new StringTokenizer(line);
        if (lineST.countTokens() > 1) {
          tableName = lineST.nextToken();
          newName = output.getUniqueKey(tableName,XmlInnerTableDuplicateDelim);
          output.put(newName,makeXMLTableFromLine(lineST));
        } else {
          tableName = lineST.nextToken();
          newName = output.getUniqueKey(tableName);
          if (!tableName.equals("/XML")) output.addTable(newName);
        }

        String endtable="/"+tableName;
        boolean foundEnd = false;
        StringBuffer innerTable = new StringBuffer();
        while (mainST.hasMoreTokens() && !foundEnd) {
          line = mainST.nextToken();
          if (line.equals(endtable))
            foundEnd = true;
          else
            innerTable.append(line).append("<");
        }
        if (innerTable.length()>0 && foundEnd) {
          fromXML((innerTable.toString()),output.getTable(newName));
        }
      }
    }
  }

//KEEP
  private Table makeXMLTableFromLine(StringTokenizer st) {
    String ss = "{";
    if (st.hasMoreTokens()) {
      String nt = st.nextToken();
      ss = ss.concat(nt);
    }
    while (st.hasMoreTokens()) {
      String nt = st.nextToken();
      if (nt.indexOf('=') > 0)
        ss = ss.concat(",");
      else
        ss = ss.concat(" ");
      ss = ss.concat(nt);
    }
    ss=ss.concat("}");

    Table newtable = new Table(ss);
    newtable.enumeration();  //Sets the table size
    return newtable;
  }

  /** Get a String object containing the table information as XML attributes */
  public String getXMLAttributes (Table t) {
    StringBuffer sb = new StringBuffer();
    t.enumeration();
    while (t.more()) {
      String keyval = t.next();
      Object obj = t.getKey(keyval);
      if (obj instanceof Table) ;
      //jph -- 24jul02 -- the cast to String did not work
      //else sb.append(keyval).append("=").append('"').append((String)obj).append('"').append(" ");
      else sb.append(keyval).append("=").append('"').append(""+obj).append('"').append(" ");
    }
    return sb.toString();
  }

}
