package nxm.nmpostlegacy.prim;

import nxm.sys.inc.*;
import nxm.sys.lib.*;
import nxm.nmpostlegacy.lib.*;
import java.util.Vector;

/**
 * @author        ?
 * @version $Id: ftpfile.java,v 1.4 2013/01/08 21:55:26 ntn Exp $
 */
public class ftpfile extends Primitive implements FtpClient_cb {
  private Vector<FtpClient> ftpVector = new Vector<FtpClient>();
  private String uPath = null;
  public int open() {
    String aux_write = MR.getS("AUX.WRITE");                   // Find AUX Write
    uPath            = MR.getS("AUX."+aux_write);              // Get HARD Path
    String user      = MR.getS("ENV.USER");                    // Get the USER name
    int badchar      = uPath.indexOf('+');                     // IF the path has a /+/ then we
    if (badchar != -1) {                                       // need to insert the USERNAME in place of
      uPath = new String(uPath.substring(0,badchar)+user+"/"); // the +,
    }
    return NORMAL;
  }

  public synchronized int processMessage (Message msg) {       // Process MESSAGEs
    if (!thisIsMe()) { MQ.put(msg); return 0; }                // If our message, ignore
    if (msg.name.startsWith("GETFILE")) {
      Table dataTbl = (Table)msg.data;
      String filename = dataTbl.getS("FILENAME");
      String host     = dataTbl.getS("HOST");
      String name     = dataTbl.getS("NAME");
      String pass     = dataTbl.getS("PASS");
      //M.info("File is  "+filename);
      //M.info("host is  "+host);
      //M.info("name is  "+name);
      //M.info("pass is  "+pass);
      //M.info("upath is "+uPath);
      filename = filename.toLowerCase();
      FtpClient ftp = new FtpClient(true, // QUIET Flag for FTP/Debug messages
          host,                           // FTP Target Host
          uPath,                          // Path to place the target file.
          filename.trim(),                // The file to get.  FULL target directory, or must be in LOGIN
          name.trim(),                    // FTP account
          pass.trim(),                    // FTP account password
          this);                          // Object that implements the Callbacks.  (FtpClient_cb)
      ftpVector.add(ftp);
    }
    return NORMAL;
  }

  public int process() {
    return NOOP;
  }

  public synchronized void FTPStatus(int status,FtpClient client) {
    //M.info("FTPStatus is "+status);
    switch(status){
      case FtpClient.XFER_COMPLETE:     ftpVector.remove(client);  MQ.put("FTPCOMPLETE",0,client.filename,"MAIN"); break;
      case FtpClient.NO_FILE_FOUND:     ftpVector.remove(client);  MQ.put("FTPFAILURE", 0,client.filename,"MAIN"); break;
      case FtpClient.UNKNOWN_EXCEPTION: ftpVector.remove(client);  MQ.put("FTPFAILURE", 0,client.filename,"MAIN"); break;
    }
  }

  public synchronized void FTPPercent(double percent,FtpClient client){
    //M.info(client.filename+" Percent is "+percent);
    MQ.put("FTPPERCENT",(int)percent,client.filename,"MAIN");
  }
}
