package nxm.nmpostlegacy.prim;

import nxm.sys.lib.*;
import nxm.nmpostlegacy.lib.*;

/**
  <p>Title:       nmpost</p>
  <p>Description: This primitive accepts POSTS from a WEB or whatever. </p>
  <P>             It expects the POSTS to be in the format below.     </p>
  <P>             Format is for MESSAGES.  NMPOST turns post into MSG, and places in QUEUE </p>
  <p>Company:     Zeta Associates</p>
  @author         Wayne G. Dengel II
  @version $Id: nmpost.java,v 1.4 2013/01/08 21:53:00 ntn Exp $
 */
public class nmpost extends Primitive {
  private PostServer  ps         = null;
  private boolean     reportMain = false;

  public int open () {
    boolean deBug   = MA.isPresent("/DEBUG");
    int     port    = MA.getL("PORT",5000);
    int     maxp    = MA.getL("/MAX",50);
    String  uPath   = MA.getS("PATH",null);
    reportMain      = MA.isPresent("/REPORTMAIN");
    if (uPath==null) {
      String aux_write = (String)MR.get("AUX.WRITE");            // Find AUX Write
      uPath = (String)MR.get("AUX."+aux_write);                  // Get HARD Path
      String user = (String)MR.get("ENV.USER");                  // Get the USER name
      int badchar = uPath.indexOf('+');                          // IF the path has a /+/ then we
      if (badchar != -1){                                         // need to insert the USERNAME in place of
        uPath = new String(uPath.substring(0,badchar)+user+"/"); // the +,
      }
      if (deBug) M.info("User didn't specify path, using "+uPath);
    }
    try {
      ps = new PostServer(MQ,MR,deBug,port,maxp,uPath,reportMain,null);
    } catch(Exception ex){
      M.info("Could not start PostServer");
      return FINISH;
    }
    return NORMAL;
  }

  public int close () {
    // BUG 1996 - nmpost should close out port on exit
    if (ps!=null) {
      ps.stop(MA.getL("/WAITONCLOSE",1)); // max wait in seconds when closing
    }
    return NORMAL;
  }

  /** Get server listen port.
      @return return HTTP server's listen port (>= 0 on error)
      @since NMPOST 0.0.4
   */
  public int getPort () {
    if (ps != null) {
      return ps.getPort();
    }
    return -1;
  }
}
