package nxm.nmpostlegacy.prim;

import nxm.sys.inc.*;
import nxm.sys.lib.*;
import nxm.nmpostlegacy.lib.*;

/**
   <p>Title:        testsend</p>
   <p>Description: This Primitive is a example of how to use SEMDMSG, and SENDFILE</p>
   <p>Company:    Zeta Associates</p>
   @author        Wayne G. Dengel II
   @version 1.0
 */
/*
<XML>
 <MSG NAME="WAYNE">                            <--- Message NAME
  <INFO="10"/>                              <--- Message INFO Field
  <TO="MAIN"/>                              <--- Who gets this message
  <FROM="WEB"/>                              <--- Who sent this message
  <DATAFMT="S,S,2A,D,L"/>                        <--- NOT USED AT THIS TIME.....
  <DATA>                                <--- Data Space....
   TUNER=RFSC24,DEMOD=FM,TEST=WAYNEDENGELasdfg,MYD=1.123456,MYL=90243  <--- Data
  </DATA>
 </MSG>
</XML>
 */
public class sendfile extends Primitive implements SendFile_cb {

  private SendFile sf     = null;
  private int      sfstat = 0;

  public int open() {
    String node = MA.getS("HOST");
    int    port = MA.getL("PORT");
    String file = MA.getS("FILE").toLowerCase();

    //M.info("SendFile test/example primitive");
    //M.info("Send data to ::");
    //M.info("    Node = "+node);
    //M.info("    Port = "+port);
    //M.info("    File = "+file);

    sf = new SendFile(M,node,port,file,null,this);
    return NORMAL;
  }

  public void sfStatus(int i){
    //M.info("sfStatus = "+i);
    sfstat = i;
  }

  public int process() {
    if (sfstat==SendFile.COMPLETE) return FINISH;
    if ((sfstat!=SendFile.COMPLETE) && (sfstat!=0)) {
      M.info("Error in SendFile...");
      return FINISH;
    }
    sf=null;
    return NORMAL;
  }
}
