package nxm.nmpostlegacy.prim;

import nxm.sys.inc.*;
import nxm.sys.lib.*;
import nxm.nmpostlegacy.lib.*;

/**
 * <p>Title:        testsend</p>
 * <p>Description: This Primitive is a example of how to use SEMDMSG, and SENDFILE</p>
 * <p>Company:    Zeta Associates</p>
 * @author        Wayne G. Dengel II
 * @version 1.0
 */
/*
<XML>
 <MSG NAME="WAYNE">                                                    <--- Message NAME
  <INFO="10"/>                                                         <--- Message INFO Field
  <TO="MAIN"/>                                                         <--- Who gets this message
  <FROM="WEB"/>                                                        <--- Who sent this message
  <DATAFMT="S,S,2A,D,L"/>                                              <--- NOT USED AT THIS TIME.....
  <DATA>                                                               <--- Data Space....
   TUNER=RFSC24,DEMOD=FM,TEST=WAYNEDENGELasdfg,MYD=1.123456,MYL=90243  <--- Data
  </DATA>
 </MSG>
</XML>
 */
public class sendmessage extends Primitive implements SendMsg_cb {
  private SendMsg   sm    = null;

  private int    sfstat = 0;
  private int    smstat = 0;

  public int open() {
    String node = MA.getS("HOST");
    int    port = MA.getL("PORT");
    Table  tbl = MA.getTable("TABLE");

    Table msgD = new Table();
    Table msgM = new Table();
    msgM.put("NAME","POST");
    msgM.put("TO","MAIN");
    msgM.put("FROM","MYSELF");
    msgM.put("INFO","5000");
    msgD.put("TYPE","GEORES");
    msgD.put("FILENAME","file.tmp");
    msgM.put("DATA",msgD);

    sm = new SendMsg(node,port,tbl,this);

    return NORMAL;
  }

  public void smStatus(int i) {
    // M.info("smStatus = "+i);
    smstat = i;
  }

  public int process() {
    if (smstat==SendMsg.COMPLETE) return FINISH;
    if ((smstat!=SendMsg.COMPLETE) && ((smstat!=0)&&(smstat!=50))){
      M.info("Error in SendMsg..."+smstat);
      return FINISH;
    }
    return NORMAL;
  }
}
