c************
c  Description: HOST code for XRTPLOT primitive
c
c  Author:      SES   1/11/94
c
c  $Revision: 1.5 $
c  $Modtime:   17 Oct 1996 06:19:58  $
c
c************
#define _HOSTVERSION
	program XRTDISPLAY
c
	include 'xrtdisplay.inc'
	include 'midas.inc'
	integer*4 status

	character cmd*(L_cmd_chars)
	integer*4 nparm, nprim, idp, lc, junk
	real*4 pause, time, elapsed
	integer*4 ncolors,nmap
	common /xrtdisplay/ Mx,Gx,nparm,nprim,pause,idp,lc
c
	call M$CHECKIN()	! map to shared memory
c old	call MDF$XRTDISPLAY()	! get command line parameters/switches
	call MDFH$XRTDISPLAY()	! get command line parameters/switches
	cmd = Mc.command_string(1:lc)
	call MX$OPEN('X-RTDisplay') ! open window and get its id before M$SYNC

c Allocate colors
	ncolors = 8	! 8 colors
	nmap = 4	! map = ramp
	call MX$COLORMAP(Mc.colormap(nmap),ncolors)  ! Allocate
	
	call M$SYNC()		! end of preamble
c
	call XRTDISPLAY_INIT(Mx, Gx, nparm, cmd(1:lc) )
c
	status = 0
	do while (status.ne.-1 .and. 
     &	    (Gx.nobrk .or. (.not. Mc.break .and. Mc.count.ge.nprim)) )
	  time = SECNDS(0.0)
	  call XRTDISPLAY_RUN (Mx, Gx, status) ! get msg/event/data
	  elapsed = SECNDS(time)
	  if (idp.ne.0) junk = M$FWGET(idp, pause)
	  ! break out of loop if we get an event or its time to shut down
	  do while (elapsed.lt.pause .and. MX$QUEUED().le.0 .and.
     &	    (Gx.nobrk .or. (.not. Mc.break .and. Mc.count.ge.nprim)) )
	    call M$PAUSE(min(0.1,pause-elapsed))
	    if (idp.ne.0) junk = M$FWGET(idp, pause)
	    elapsed = SECNDS(time)
	  enddo
	enddo
c
	call XRTDISPLAY_END(Mx, Gx, nparm)
	call M$RETURN()
c
	end

	integer*4 function MD$BUFRES (bufid, nelem, itype)
	implicit none
	include 'types.inc'
	integer*4 bufid, nelem, itype, tbuf
	call M$MALLOC (M$NPT(CHAR(itype))*nelem, tbuf)
	MD$BUFRES = tbuf
	return
	end
c************
c  Description: DSEF for XRTDISPLAY routine
c
c  Author:	JGS   4/1/91
c
c  $Revision: 1.4 $
c  $Modtime:   01 May 1996 14:28:34  $
c  
c************
#if _HOSTVERSION
	subroutine MDFH$XRTDISPLAY
#else
	subroutine MDF$XRTDISPLAY
#endif
c
	include 'xrtdisplay.inc'
	include 'midas.inc'
	include 'dseftypes.inc'
	character*8 ctmp
	character*40 pstring
	integer*4 lc, i, idw, ls, idp, nparm, nprim
	real*4 pause

#if _HOSTVERSION
	common /xrtdisplay/ Mx,Gx,nparm,nprim,pause,idp,lc
#endif

c
c just pass the command line to the DSES
	nparm = Mc.number_parameters
	lc = Mc.command_length
c
c create widgets here and change command line to reflect it
	i = 1
	do while (i.lt.lc)
	  if (Mc.command_string(i:i+1).eq.'W_') then
	    ctmp = Mc.command_string(i+2:i+2)
	    if (ctmp.eq.','.or.ctmp.eq.'/') then
	      idw = M$DWINIT ('W_',0.d0,1.d0,-1.d0,1.d0)
	      ls = M$L2A(idw,ctmp)
	      Mc.command_string(i+2:) = ctmp(1:ls)//Mc.command_string(i+2:)
	      lc = lc + ls
	    endif
	  endif
	  i = i+1
	enddo
c
c get the autoexit mode, primitive count and noexit switch
	nprim = Mc.count
	if (Mc.mode.eq.0 .or. M$GET_PSWITCH('STAY')) nprim = -999
c
c get characters per line switch
        Gx.cpl = M$GET_SWITCH('CPL')
        if (Gx.cpl.le.0) Gx.cpl = 32
c
c get pause switch
	pause = M$GET_DSWITCH_DEF('PAUSE',0.5d0)
	if (M$GET_PSWITCH('PAUSE')) then
	  idp = M$FWINIT ('PAUSE',pause,0.0,10.0,0.05)
	else
	  idp = 0
	endif
c
c get shell file behavior
	Gx.shellfile = .not. M$GET_PSWITCH('REOPEN')
	Gx.flush = M$GET_PSWITCH ('FLUSH')
	Gx.nobrk = M$GET_PSWITCH('NOBRK')
c
c get msgid and msgmask
	Gx.msgid = M$GET_SWITCH('MSGID')
	Gx.msgmask = M$GET_SWITCH('MASK')

#if _HOSTVERSION
c
c init the graphics setup
	call MX$GRAPHICSINIT ()
	call MXF$SETUP (Mx, -300, -20*nparm-5)

#else

c
c init the graphics setup
	call MDX$SETUP (Mx, -300, -20*nparm-5)
c
c initialize dataflow structure counters
	call MD$INIT ()
	call MD$LPARAMETER(nparm,0)
	call MD$LPARAMETER(nprim,0)
	call MD$FPARAMETER(pause,idp)
c
c build block data structure
	call MD$BBLOCK (Mx,L_Mx)
	call MD$BBLOCK (Gx,L_Gx)
	call MD$ABLOCK (Mc.command_string(1:lc))
c
c build results structures
	! no results
c
c submit the structure
	call MD$SUBMIT (MD_NODATA)
#endif
c
	return
	end


c************
c  Description: Host DSES for XRTDISPLAY routine
c
c  Author:	JGS   4/1/91
c
c  $Revision: 1.6 $
c  $Modtime:   01 May 1996 14:32:22  $
c  
c Sun FORTRAN compiler optimizer has problems with this module when >= O2
c #_SUN OPTIMIZATION -O1
c
c************

#if !_HOSTVERSION
	subroutine MDS$XRTDISPLAY
c
	include 'xrtdisplay.inc'
	include 'midas.inc'
	include 'dsestypes.inc'
c
	integer*4 invoke,lc,status
	integer*4 nparm, nprim, lcmd
	record /M_PTR/ lMx, lGx
	real*4 pause,time
	character cmd*(L_cmd_chars)
	pointer (Mx_ptr,Mx),(Gx_ptr,Gx),(cmd_ptr,cmd)

	common/md$context_rtdisplay/ BOC,nparm,nprim,pause,EOP,
     +			   lMx,lGx,time,EOC
c
	invoke = MD$CHECKIN(BOC,EOC)
c
	Mx_ptr = lMx.p
	Gx_ptr = lGx.p
c
	if (invoke.eq.0) then

	  Mx_ptr = MD$BLOCKDATA(1,lc)	  
	  Gx_ptr = MD$BLOCKDATA(2,lc)
	  cmd_ptr = MD$BLOCKDATA(3,lcmd)
	  call MX$SETCONTEXT(Mx)
	  call XRTDISPLAY_INIT(Mx,Gx,nparm,cmd(1:lcmd))
	  time = SECNDS(0.0)
	  lMx.p = Mx_ptr
	  lGx.p = Gx_ptr

	elseif (invoke.gt.0 .and. SECNDS(time).gt.pause) then

	  call MX$SETCONTEXT(Mx)
	  call XRTDISPLAY_RUN(Mx,Gx,status)
	  if (status.eq.-1) then	! interactive/msg exit
	    call XRTDISPLAY_END(Mx,Gx,nparm)
	    call MD$PEBMODE(0)
	  elseif (status.eq.0) then	! nothing done
	    call MD$PEBMODE(-2)
	  endif
	  time = SECNDS(0.0)

	elseif ((Mc.count.lt.nprim .or. invoke.eq.-1) .and. nparm.ge.0) then

	  call MX$SETCONTEXT(Mx)
	  call XRTDISPLAY_END(Mx,Gx,nparm)
	  call MD$PEBMODE(0)

	else	! nothing done - flag this

	  call MD$PEBMODE(-2)

	endif
c
	return
	end

#endif


	subroutine XRTDISPLAY_INIT (Mx, Gx, nres, cmd)
c
	include 'xrtdisplay.inc'
	include 'midas.inc'
	include 'headers.inc'
	include 'parameters.inc'
	include 'dsestypes.inc'
	integer*4 nres
	character cmd*(*)
c
	integer*4 n, i, j, il, isl, ip, ipp, idw, flag
	character file_name*40, s*80
	logical*4 oldwarn, oldverbose
	integer*4 isl2,ip2
c
c Allocate the Rx(*) array and parse the command line parameters in cmd to fill
c it.  NRES is passed in to this routine to initialize Gx.nres.  
	Gx.nres = nres
	Gx.R.p = MD$BUFRES(1, nres*L_Rx, MP_BYTE)
	R_ptr = Gx.R.p
	Gx.shellfiles_pre = Mu.shellfiles
c
c loop through parameters
	do n = 1, Gx.nres 
	  il = M$PARSE (cmd, n+1, s)
c
c get the label to identify the result (delimitted by a /)
	  isl = M$SEARCH(s,'/')
	  if (isl.eq.0) then		! No label specified - use default
	    R(n).lab_name = s
	    R(n).llab = il
	    R(n).sep_str = ' ==> '	! separator string
	    R(n).lsep = 5		! Length of sep string
	    R(n).res_name = s(1:il)
	  else				! Label specified - shave it off
	    R(n).res_name = s(1:isl-1)
	    isl2 = M$SEARCH(s(isl+1:),'//')   ! check for //
	    ip = 0
	    if (s(isl+1:isl+1).eq.'"') ip = 1	! check for quotes
	    if (isl2 .eq. 0) then		! // not found
	      R(n).lab_name = s(isl+1+ip:)
	      R(n).llab = min(40,il-isl-2*ip)
	      s(isl:) = ' '
	      R(n).sep_str = ' ==> '	! separator string
	      R(n).lsep = 5		! Length of sep string
	      il = isl-1		! Adjust length for later use
	    else			! A separator string is specified
	      isl2 = isl + isl2		! ref to start of string
	      if (ip .gt. 0) then	! if leading "
	        R(n).lab_name = s(isl+2:isl2-2)
		R(n).llab = min(40,isl2-isl-3)
	      else
	        R(n).lab_name = s(isl+1:isl2-1)
		R(n).llab = min(40,isl2-isl-1)
	      endif
	      if (s(isl2+2:isl2+2) .eq. '"') then  ! if quoted
	        R(n).sep_str = s(isl2+3:il-1)	! Separator string
	        R(n).lsep = il-isl2-3   	! Len of sep string
	      else
	        R(n).sep_str = s(isl2+2:il)	! Separator string
	        R(n).lsep = il-isl2-1   	! Len of sep string
	      endif  
	      il = isl-1		! Adjust length for later use
	    endif
	  endif
c
c if this is a file, open as a shell file for speed-up
	  ip = M$SEARCH(s,'(')
	  if (ip.ne.0 .and. Gx.shellfile) then	! This is a result file
	    ipp = M$SEARCH(s,')')
	    file_name = s(1:ip-1)//s(ipp+1:il)
	    oldwarn = Mu.warn
	    oldverbose = Mu.verbose
	    Mu.warn = .false.
	    Mu.verbose = .false.
	    flag = HCBF_INPUT
	    if (Gx.flush) flag = flag + HCBF_FLUSH
	    call M$OPEN_SHELLFILE (file_name, flag)
	    Mu.warn = oldwarn 
	    Mu.verbose = oldverbose 
	  endif	
c
c init the run-time book-keeping fields
	  R(n).lres = il	! length of the result name
	  R(n).lvalue = 0	! length of the result value 
	  R(n).lstring = 0	! length of the result value string
	  R(n).type = ' '	! mark type as undefined until the first pass
	  R(n).value.p = 0	! results buffer
	  R(n).icd = 8 		! Color of display string
	  R(n).icv = 8 		! Color of value string
	  R(n).blink = 0	! Blink flag
	enddo

	Gx.shellfiles_post = Mu.shellfiles

c
c open the graphics screen and draw the screen
#if !_HOSTVERSION
	call MX$DOPEN(Mx, 'X-RTDisplay')
#endif
	Mx.text_w = min(9,Mx.width/Gx.cpl)
	call MX$SETFONT(Mx.text_w)
	call XRTDISPLAY_REFRESH(Mx, Gx, 1)

	return
	end


	subroutine XRTDISPLAY_RUN (Mx, Gx, status)
	include 'xrtdisplay.inc'
	integer*4 status

	status = 0
	call XRTDISPLAY_REFRESH (Mx, Gx, 0)
	call XRTDISPLAY_MSG (Mx, Gx)
	call XRTDISPLAY_EVENT (Mx, Gx)
	status = Gx.status
	return
	end

	subroutine XRTDISPLAY_REFRESH (Mx, Gx, mode)
	include 'xrtdisplay.inc'
	include 'dsestypes.inc'
	include 'resmasks.inc'
	integer*4 mode
	integer*4 n, il, lv, ls, llr, attrmask, L_bbuf
	logical*4 redraw,evensec
	character*80 dspstr,valstr
	integer*4 i,ic,icv,ld,bgi,fgi,isec

	parameter (L_bbuf=L_max_ascii)
	include 'buffers.inc'
	record /BUFFER/ value 

	R_ptr = Gx.R.p

	if (mode.eq.1) call MX$CLEAR_WINDOW()

c Check the time for use in blinking result values
	isec = int(2*secnds(0.0))
	evensec = mod(isec,2) .eq. 0  ! Even if seconds divides by 2
c
c loop through parameters
	do n = 1, Gx.nres

	  il = R(n).lres
	  lv = M$GET_RESULT (R(n).res_name(1:il), value, L_bbuf, 
     &			RM_NORGOOD, type, attrmask)

	  if (mode .eq. 1) then
	    redraw = .true.
	  elseif (R(n).type .eq. type .and. R(n).lvalue .eq. lv) then
	    redraw = (M$CHK(%val(R(n).value.p),value,lv) .ne. 1) .or.
     &	      (R(n).blink .gt. 0)
	  else
	    redraw = .true.
	  endif

	  if (redraw) then
	    R(n).type = type 
	    if (R(n).lvalue .ne. lv) then
	      call M$REMALLOC (lv, R(n).value.p)
	      R(n).lvalue = lv
	    endif
	    if (lv.gt.0) then
	      call M$MOVE (value, %val(R(n).value.p), lv)
	      if (type.eq.'A') then
		ls = lv		! string is already in buffer
	      elseif (type.eq.'D' .and. lv.eq.8) then
		ls = M$D2A (%val(R(n).value.p),value.sbuf)
	      elseif (type.eq.'L' .and. lv.eq.4) then
		ls = M$L2A (%val(R(n).value.p),value.sbuf)
	      else
		ls = M$RECAST (%val(R(n).value.p),type,lv, 
     &			value,'A',L_bbuf)
	      endif
	    else
	      ls = 0
	    endif
	    if (ls.gt.R(n).lstring) then
	      llr = ls
	    else
	      llr = R(n).lstring
	      value.sbuf(ls+1:llr) = ' '	
	    endif
	    il = R(n).llab
c Write the display string text
	    dspstr = R(n).lab_name(1:il)//R(n).sep_str(1:R(n).lsep)  
	    ld = il + R(n).lsep
	    if (R(n).icd .ge. 0) then		! Normal color
	      ic = R(n).icd
	    else				! Inverted color
	      bgi = -R(n).icd			! BG index
	      if ( bgi .eq. 3 .or. bgi .eq. 4 .or.
     +             bgi .eq. 5 .or. bgi .eq. 6 ) then	! dark backgrounds...
	        fgi = 8 				! ...Text in white
	      else if ( bgi .eq. 7 ) then		! Yellow background...
	        fgi = 0 				! ...text in black
	      else					! Otherwise...
	        fgi = 6 				! ...text in red
	      endif
	      ic = 1000*bgi + fgi
	    endif
#if _HOSTVERSION
	    call MX$COLORTEXT(ic,Mx.text_w,n*Mx.text_h,dspstr(1:ld))
#else
	    call MX$TEXT(Mx.text_w,n*Mx.text_h,dspstr(1:ld))
#endif

     
c figure out if we will invert to value string from its spec based on 
c the time and the blink setting of this result 
	    icv = R(n).icv		! Current setting
ccc	    type *,'blink,evensec = ',R(n).blink,evensec
	    if (R(n).blink .gt. 0) then	 
	      if (evensec) then
	        icv = R(n).icv
	      else
	        icv = -R(n).icv
	      endif
	    endif   

c Write the value text
	    valstr = value.sbuf(1:llr)
cc	    type *,'Writing: ',value.sbuf(1:llr),R(n).ic,Mx.pixel(R(n).ic)
	    if (icv .ge. 0) then		! Normal color
	      ic = icv
	    else				! Inverted color
	      bgi = -icv			! BG index
	      if ( bgi .eq. 3 .or. bgi .eq. 4 .or.
     +             bgi .eq. 5 .or. bgi .eq. 6 ) then
	        fgi = 8
	      else if ( bgi .eq. 7 ) then
	        fgi = 0
	      else
	        fgi = 6
	      endif
	      ic = 1000*bgi + fgi
	    endif
#if _HOSTVERSION
	    call MX$COLORTEXT(ic,(1+ld)*Mx.text_w,
     +	    		n*Mx.text_h,valstr(1:llr))
#else
	    call MX$TEXT((1+ld)*Mx.text_w,n*Mx.text_h,valstr(1:llr))
#endif

	    R(n).lstring = ls
	    Gx.status = Gx.status + 1
	  endif

	enddo

	return
	end

	subroutine XRTDISPLAY_EVENT (Mx,Gx)
	include 'xrtdisplay.inc'
	include 'midas.inc'
	integer*4 item,i,n
c
c handle events
	do while (Gx.status.ge.0 .and. MX$IFEVENT())
	  Gx.status = Gx.status + 1
	  if (Mx.button_press.eq.2 .or. Mx.key_upchar.eq.'M') then
	    item = MX$MENU(0,'Refresh,Font Size,Exit')
	    if (item.eq.1) then
	      call XRTDISPLAY_REFRESH(Mx,Gx,1)
	    elseif (item.eq.2) then
	      i = Mx.text_w
	      call MX$LPROMPT ('Font Width: ', i)
	      if (iabs(i).le.1) then
		if (i.ge.0) Mx.text_size_lock = 1
		if (i.lt.0) Mx.text_size_lock = -1
		Mx.resize = .true.
	      elseif (Mx.text_size_lock.ge.0) then
		Mx.text_size_lock = 1
		call MX$SETFONT(i)
		Mx.text_size_lock = Mx.text_w
		Mx.exposure = .true.
	      else
		Mx.text_size_lock = -1
		call MX$SETFONT(i)
		Mx.text_size_lock = -Mx.text_w
		Mx.exposure = .true.
	      endif
	    elseif (item.eq.3) then
	      if (Mx.noexit.le.1) Gx.status = -1
	      if (Mx.noexit.gt.1) call MX$MESSAGE ('Exit disabled', 1.0)
	    endif
          elseif (Mx.key_press.eq.13) then
	    if (Mx.noexit.le.0) Gx.status = -1
	  elseif (Mx.breakflag) then
	    Gx.status = -1
	  endif
	  if (Gx.status.ge.0 .and. (Mx.resize .or. Mx.exposure)) then
	    if (Mx.resize) then
	      Mx.text_w = min(9,Mx.width/Gx.cpl)
	      call MX$SETFONT (Mx.text_w)
	    endif
	    call XRTDISPLAY_REFRESH(Mx, Gx, 1)
          endif
	enddo

	return
	end


        subroutine XRTDISPLAY_MSGDO (Mx, Gx, bit, iarg)
        include 'xrtdisplay.inc'
        integer*4 bit, iarg
        if (Gx.msgid.ge.0 .and. BTEST(Gx.msgmask,bit))
     +          call XRTDISPLAY_INFOMSG (Mx, Gx, bit, iarg, Gx.msgid)
        return
        end

        subroutine XRTDISPLAY_INFOMSG (Mx, Gx, bit, iarg, rid)
        include 'xrtdisplay.inc'
	include 'msgmask.inc'
        include 'qmessdef.inc'
        integer*4 iarg, rid, bit
	record /MQH_EXITINFO/ MQH_EXITINFO
	record /MQ_DATA/ MQD
        if (bit.eq.MSK_EXIT) then
	  call M$SEND_MSG (MQH_EXITINFO, MQD, rid, 0)
	endif
	return
	end


	subroutine XRTDISPLAY_MSG (Mx,Gx)
	include 'xrtdisplay.inc'
	include 'qmessdef.inc'
	include 'qmessdecl.inc'
	integer*4 i, info, ln
	
	R_ptr = Gx.R.p

	do while (Gx.status.ge.0 .and.
     +            M$GET_MSG(MQH,MQD,L_mqd,0.0,0).eq.1) 

	  Gx.status = Gx.status + 1
	  info = MQH.info
	  
	  if (MX$GRAPHICS_MSG(Mx,MQH,MQD,i,i).ne.0) then
	    if (Mx.breakflag) Gx.status = -1

	  elseif (MQH.name .eq. MQH_HARDCOPY.name) then

	    if (MX$HARDCOPY_OPEN(MQD.HARDCOPY.file, info)) then
	      call XRTDISPLAY_REFRESH (Mx,Gx,1)
	      call MX$HARDCOPY_CLOSE ()
	    endif

	  elseif (MQH.name .eq. MQH_REFRESH.name .or.
     +		  MQH.name .eq. MQH_REREAD.name) then
	    call XRTDISPLAY_REFRESH (Mx,Gx,1)

	  elseif (MQH.name .eq. MQH_SET.name) then
	    if (MQD.SET.object .eq. 'CPL') then
	      info = max (1, info)
	      Mx.resize = Gx.cpl .ne. info
	      if (Mx.resize) then
		Gx.cpl = info
		i = Mx.text_w
		Mx.text_w = min(9,Mx.width/Gx.cpl)
		call MX$SETFONT (Mx.text_w)
	        if (i.ne.Mx.text_w) call XRTDISPLAY_REFRESH (Mx,Gx,1)
	      endif
	    endif

c Change color of a result value display
	  elseif (MQH.name .eq. MQH_DISPCOLR.name) then
	    ln = M$LENGTH(MQD.dispcolr.label)	! Length of label
	    do i = 1, Gx.nres
	      if (ln .eq. R(i).lres) then
     	        if (R(i).res_name(1:ln) .eq. MQD.dispcolr.label(1:ln)) then
		  R(i).icd = MQD.dispcolr.icd
		  R(i).icv = MQD.dispcolr.icv
		  R(i).blink = MQD.dispcolr.blink
		  
c .. Do some limit checking & refresh display
		  R(i).icd = max(-8,R(i).icd)	! Not less than -8
		  R(i).icd = min(8,R(i).icd)	! Not more than 8
		  R(i).icv = max(-8,R(i).icv)
		  R(i).icv = min(8,R(i).icv)
		  call XRTDISPLAY_REFRESH (Mx,Gx,1)
		endif
	      endif
	    enddo

	  endif

	enddo

	return
	end

	subroutine XRTDISPLAY_END (Mx, Gx, nres)
	include 'xrtdisplay.inc'
	include 'midas.inc'
	include 'headers.inc'
	include 'msgmask.inc'
	integer*4 nres, n

	R_ptr = Gx.R.p
	call MX$CLOSE()
	do n = Gx.shellfiles_pre+1, Gx.shellfiles_post
	  call M$CLOSE( %val(Mu.shellfileptr(n)) )
	  call M$STMFREE( L_header_size, Mu.shellfileptr(n) )
	enddo
	Mu.shellfiles = Gx.shellfiles_pre
	do n = 1, Gx.nres
	  if (R(n).value.p .ne. 0) call M$FREE(R(n).value.p)
	enddo
	if (Gx.status.eq.-1) call XRTDISPLAY_MSGDO (Mx, Gx, MSK_EXIT, 0)
	Gx.nres = -1
	nres = Gx.nres
	return
	end

