package nxm.sys.inc;

import java.lang.annotation.*;

/** Marker annotation for Java code that is for <b>INTERNAL USE ONLY</b>. Any
    code so marked may be changed or removed at any time and may have
    dangerous un-checked and/or un-documented behavior if used incorrectly.
    @author  Neon Ngo
    @since   NeXtMidas 3.3.0
    @version $Id: InternalUseOnly.java,v 1.2 2012/12/05 00:31:16 jxc Exp $
 */
@Documented
@Inherited
@Retention(RetentionPolicy.RUNTIME)
//@Target is specifically omitted as omitting it permits all targets
@InternalUseOnly
public @interface InternalUseOnly {
}
