package nxm.sys.inc;

import nxm.sys.lib.Message;

/** Interface Definitions for Message Handlers. Note that every NeXtMidas command implements this
    interface (see {@link nxm.sys.lib.Command#processMessage(Message)}).
 
    @see Message
  
    @author Jeff Schoen
    @version $Id: MessageHandler.java,v 1.7 2007/03/16 22:54:04 jxc Exp $
 */
public interface MessageHandler {
  /** Processes a message.
      @param msg The message.
      @return {@link Commandable#NORMAL} after processing the message or {@link Commandable#NOOP}
              if the message is not processed.
   */
  public int processMessage (Message msg);
}
