package nxm.sys.inc;

/** Numerical equivalent definitions of special Unicode characters. <br>
    <br>
    Use the <code>{@link UnicodeMap}.<font color="blue">NAME</font></code> syntax when accessing
    the definitions in this class.
 
    @see AsciiMap
 
    @author  J. Czechowski IV
    @version $Id: UnicodeMap.java,v 1.3 2007/05/17 22:44:50 jxc Exp $
    @since   NeXtMidas 1.9.5
 */
public final class UnicodeMap implements AsciiMap {
  ////// Official Unicode Names ////////////////////////////////////////////////////////////////////
  /** Unicode DEGREE SIGN.       */
  public static final char DEGREE_SIGN       = '\u00B0';
  /** Unicode PLUS-MINUS SIGN.   */
  public static final char PLUS_MINUS_SIGN   = '\u00B1';
  /** Unicode SUPERSCRIPT TWO.   */
  public static final char SUPERSCRIPT_TWO   = '\u00B2';
  /** Unicode SUPERSCRIPT THREE. */
  public static final char SUPERSCRIPT_THREE = '\u00B3';
  
  /** Unicode MICRO SIGN.        */
  public static final char MICRO_SIGN        = '\u00B5';
  
  /** Unicode MIDDLE DOT.        */
  public static final char MIDDLE_DOT        = '\u00B7';
  
  
  /** Unicode SUPERSCRIPT ONE.   */
  public static final char SUPERSCRIPT_ONE   = '\u00B9';
  
  /** Unicode INFINITY.   */
  public static final char INFINITY          = '\u221E';
  
  ////// Common Names //////////////////////////////////////////////////////////////////////////////
  
  /** The squared sign (same as {@link #SUPERSCRIPT_TWO}). */
  public static final char SQUARED = SUPERSCRIPT_TWO;
  
  /** The cubed sign (same as {@link #SUPERSCRIPT_THREE}). */
  public static final char CUBED = SUPERSCRIPT_THREE;
}
