package nxm.sys.inc;

import nxm.sys.libg.GWidget;

/**
  Interface Definitions for Widget Panels.

  @author Jeff Schoen
  @version $Id: WidgetPanel.java,v 1.5 2010/01/20 18:08:51 jwb Exp $
*/
public interface WidgetPanel {

  /** Adds a widget to the panel. <br>
      <b>Note:</b> To avoid a possible race condition, this method should always be called
      by the EDT. 
   
      @param obj The widget to add.
   
      @return <code>obj</code> after it has been added.
   */
  public Object addWidget (GWidget obj);

  /** Layout widget panel.
   
      @param obj The widget to layout in the panel.
   */
  public void layoutWidget (GWidget obj);

}
