package nxm.sys.intr;

import nxm.sys.lib.*;

/**
  Handle a block ENDFOR control statement.

  @author Jeff Schoen
  @version $Id: Endfor.java,v 1.7 2007/08/30 22:15:41 ntn Exp $

  @see Foreach
*/
public class Endfor extends Intrinsic {
  /** The top-level for. */
  private nxm.sys.intr.Foreach top=null;

  public int process() {
    // NTN: if we are not in a foreach loop, then display warning message
    //      and return otherwise we will get NPE
    if (top==null && M.macro == null) {
      M.warning("Not in FOREACH loop");
      return FINISH;
    }

    if (top==null) {

      top = (Foreach)M.macro.lines[nextIndex].cmd;
    }

    if (top.doNext()) {
      M.macro.nextIndex = nextIndex+1;
    }

    return FINISH;
  }

}
