package nxm.sys.intr;

import nxm.sys.lib.*;

/**
  Handles the creation of a Feature object.

  @author Jeff Schoen
  @version $Id: Feature.java,v 1.6 2007/08/30 22:15:41 ntn Exp $
*/
public class Feature extends Intrinsic {
  public int process() {
    nxm.sys.lib.Table    table   = null;
    nxm.sys.libg.Feature feature = null;

    // Get parameters
    String name  = MA.getS("NAME");
    String label = MA.getU("LABEL");
    String plotid = MA.getU("PLOT");
    table = MA.getTable("TABLE");

    if (name.indexOf(".")<0) name = "nxm.sys.libg.Feature"+name;

    try {
      feature = (nxm.sys.libg.Feature)Class.forName(name).newInstance();
      feature.setRef(M);
    }
    catch (Exception e) { M.error(e); }

    if (table!=null) KeyObject.setKeys (feature,table,args,0);

    MR.put(label,feature, args);

    if (plotid!=null && plotid.length()>0) {
      nxm.sys.prim.plot plot = (nxm.sys.prim.plot)M.registry.get(plotid);
      if (plot!=null) plot.MP.addFeature(feature);
    }
    return FINISH;
  }
}
