package nxm.sys.intr;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Utility for generating file names in a system-independent manner.

  @author Jeff Schoen
  @version $Id: Fname.java,v 1.12 2009/08/18 13:15:23 jwb Exp $

*/
public class Fname extends Intrinsic {

  String label,fname,area,name,ext,opt;

  public int process() {

    if (MA.getState("/PARSE")) {
      label = MA.getCS("LABEL");
      area  = MA.getU("AREA");
      name  = MA.getU("NAME");
      ext   = MA.getU("EXT");
      FileName fn = new FileName(label);
      MR.put (area,fn.getPath());
      MR.put (name,fn.getRoot());
      MR.put (ext,fn.getExt());
    } 
    else {
      label = MA.getU("LABEL");
      area  = MA.getS("AREA");
      name  = MA.getCS("NAME");
      ext   = MA.getCS("EXT");
      opt   = MA.getS("OPT");
      fname = M.io.name (area,name,ext,opt);
      if (label.length()==0) M.terminal.writeln ("Filename := "+fname);
      else if (label.length()>1 && label.charAt(1)==':') MR.put (label,fname);
      else MR.put ("S:"+label,fname);
    }
    return (FINISH);
  }

}
