package nxm.sys.intr;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Handles the creation of a Layer object.

  @author Jeff Schoen
  @version $Id: Layer.java,v 1.8 2007/04/11 20:14:15 ntn Exp $

*/
public class Layer extends Intrinsic {
  public int open() {
    nxm.sys.lib.Table  table = null;
    nxm.sys.libg.Layer layer = null;

    // Get parameters
    String name   = MA.getCS("NAME");
    String label  = MA.getU("LABEL");
    String plotid = MA.getU("PLOT");
    table = MA.getTable("TABLE");
    if (name.indexOf(".")<0) name = "nxm.sys.libg.Layer"+name;

    try {
      layer = (nxm.sys.libg.Layer)Class.forName(name).newInstance();
      layer.setRef(M);
    }
    catch (Exception e) { M.error(e); }

    if (table!=null) KeyObject.setKeys(layer,table,args,0);

    MR.put(label,layer,args);

    if (plotid!=null && plotid.length()>0) {
      nxm.sys.prim.plot plot = (nxm.sys.prim.plot)M.registry.get(plotid);
      if (plot!=null) plot.MP.addLayer(layer);
    }
    return (FINISH);
  }
}
