package nxm.sys.intr;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
   sends an operating system command to the OS

  @author Jeff Schoen
  @author Neon Ngo 2011-07-21 Added support to capture standard output and error to results
                              via /STDOUT=<out_resname> and /STDERR=<err_resname>, but they
                              must come right after this command (otherwise they are picked up
                              and used to run as part of OS command line).
  @version $Id: Os.java,v 1.5 2011/07/21 20:48:21 ntn Exp $
*/
public class Os extends Intrinsic {

  public int process () {
    String cmdline = MA.getRawArgs();
    String resname_stdout = MA.getU("/STDOUT", null); // since 3.0.0 for BUG 1357
    String resname_stderr = MA.getU("/STDERR", null); // since 3.0.0 for BUG 1357
    nxm.sys.lib.Foreign.runInternal(M, cmdline, false, resname_stdout, resname_stderr);
    return FINISH;
  }

}
