package nxm.sys.intr;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/** Pauses for specified time.

    @author Jeff Schoen
    @version $Id: Pause.java,v 1.6 2009/08/14 14:35:59 jmm Exp $
 */
public class Pause extends Intrinsic {

  /** {@inheritDoc} */
  public int process() {

    // get parameters
    double sec = MA.getD("TIME");
    verbose = verbose || M.macro==null;
    
    // implement pause
    if (sec > 0.0) {
      if (verbose) {
        MT.write("Pausing "+sec+" seconds ");
        for (;sec>=1.0;sec-=1.0) { 
          Time.pause(1.0);
          MT.write("."); 
        }
        if (sec>0.0) Time.sleep(sec); 
        MT.write(" done\n");
      }
      else {
        /* Do the (non-verbose) waiting all-at-once since the cumulative overhead of each call to
           Time.wait(..) makes the above code much less accurate.  */
        Time.pause(sec);
      }
    }
    else if (sec == -1) {
      if (M.macro==null) M.error("Indefinite PAUSE only functions in a macro");
      M.macro.suspend=1;
    }
    else if (sec == -2) {
      MT.getInput("Press return to continue...","",Terminal.INPUT_RETURN);
    }
    else {
      M.warning("Unsupport sleep value: "+sec);
    }

    return (FINISH);
  }
}
