package nxm.sys.intr;

import nxm.sys.lib.*;

/**
  Reports INFO/WARNING/ERROR messages to a display and/or file.

  Also converts reports to different presentations.

  @author Jeff Schoen
  @version $Id: Report.java,v 1.1 2004/01/07 21:23:14 jgs Exp $

*/
public class Report extends Intrinsic {

  public int process() {

    // get parameters
    String func = MA.getU("FUNC");

    if (func.equals("ON")) {
      FileName fname = MA.getFileName("FILE");
      if (M.logger!=null) M.logger.close();
      M.logger = new Logger(M);
      M.logger.open (fname);
    }
    else if (func.equals("FLUSH")) {
      if (M.logger==null) return (FINISH);
      M.logger.flush();
    }
    else if (func.equals("OFF")) {
      if (M.logger==null) return (FINISH);
      M.logger.close();
      M.logger = null;
    }
    else if (func.equals("AUTOSAVE")) {
      Logger.setAutoSave( MA.getState("FILE",true) );
    }
    else if (func.equals("SAVEOFF")) {
      if (M.logger==null) return (FINISH);
      M.logger.close();
      M.logger.saveOff();
      M.logger = null;
    }
    else M.error("Unsupported LOGGER function: "+func);

    return (FINISH);
  }
}
