package nxm.sys.intr;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Implements various timer functions 

  @author Jeff Schoen
  @version $Id: Timer.java,v 1.6 2009/08/18 13:15:23 jwb Exp $

*/
public class Timer extends Intrinsic {

  String func,label;

  public int process() {

    // Get parameters
    func  = MA.getU("FUNC");
    label = MA.getU("LABEL");

    if (func.equals("ON"))
      M.timer = System.currentTimeMillis();
    else if (func.equals("OFF"))
      M.timer = 0;
    else if (func.equals("SET"))
      M.elapse = System.currentTimeMillis();
    else if (func.startsWith("ELAPSE")) {
      double time = 1.e-3 * (double)(System.currentTimeMillis()-M.elapse);
      if (label.length()>0) M.results.put(label,new Data(time));
      else M.terminal.writeln("Elapsed time = "+time+" seconds");
    }
    else M.warning("Bad argument to timer: "+func);

    return (FINISH);
  }

}
