package nxm.sys.intr;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Handle a block WHILE control statement.

  @author Jeff Schoen
  @version $Id: While.java,v 1.6 2006/09/20 13:05:25 jgs Exp $
  
  @see Endwhile
*/
public class While extends Intrinsic {

  /** {@inheritDoc} */
  public int process() {

    if (M.macro == null) {
      Macrofunc.enterMacroText(M,"%while",MA.getRaw(),"endwhile");
      Shell.runCommand(M,"%while");
      return FINISH;
    }

    boolean test = MA.logicalTest();
    
    if (!test) {
      // jump to one past the endwhile
      M.macro.nextIndex = nextIndex+1;
    }

    return (FINISH);
  }

}
