package nxm.sys.libg;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

import java.awt.*;
import java.awt.image.*;

/**
  A class to hold and plot an image.

  @author Jeff Schoen
  @version $Id: LayerImage.java,v 1.6 2010/06/17 19:33:54 ntn Exp $

*/
public class LayerImage extends Layer {

  BufferedImage bi;

  /* Constructors */
  public LayerImage () {
    super();
    name = "Image";
    typeClass = 7;
  }

  /** setup the file input - if necessary */
  public boolean setFile (PlotFile pf, Table tab, Args MA) {
    setFile(pf);
    ImageFile imf = (ImageFile)pf;
    bi = imf.readImage();
    size = imf.getYFrame();
    frame = imf.getXFrame();
    xstart = imf.getXStart();
    xdelta = imf.getXDelta();
    ystart = imf.getYStart();
    ydelta = imf.getYDelta();
    return true;
  }

  /** process the plot data for this frame */
  public void process () {
  }

  /* find layer bounds */
  public void findRange () {
    x1 = xstart - xdelta/2;
    x2 = x1 + frame*xdelta;
    if (x1>x2) { double t=x1; x1=x2; x2=t; }
    y1 = ystart - ydelta/2;
    y2 = y1 + size*ydelta;
    if (y1>y2) { double t=y1; y1=y2; y2=t; }
    z1 = 0; z2 = 1;
  }

  public void findFullRange () { findFullRange(pf); }

  public void draw (int flag) {
    super.draw(flag);
    // moved into MPlot class to be shared by LayerGMap and LayerMToc
    MP.drawImage (bi,null,false, xstart,xdelta,frame, ystart,ydelta,size);
  }

  public BufferedImage getBufferedImage () { return bi; }

  @Override
  public void invertColorMap () {
    short[] invert = new short[256];
    for (int ii = 0; ii < 256; ii++) { invert[ii] = (short)(255 - ii); }
    BufferedImageOp invertOp = new LookupOp(new ShortLookupTable(0, invert), null);
    invertOp.filter(bi, bi); // apply color inversion directly back onto BufferedImage
    refresh();
  }

}
