package nxm.sys.libg;

import java.awt.*;
import java.awt.event.*;

/** A class to handle a text field. Extends TextField to allow right mouse exit.
    @deprecated Since NeXtMidas 2.7.1, should use MJTextField instead
    @author Jeff Schoen
    @version $Id: MTextField.java,v 1.9 2012/02/09 17:07:04 ntn Exp $
*/
@Deprecated public class MTextField extends TextField {
  /** NOTE: this should be changed if the structure/fields of this class changes. */
  private static final long serialVersionUID = 2012020940311L; // for Serializable interface

  /** Creates a new TextField initialized with the specified text to be displayed, and wide enough
      to display the number of columns indicated.
      @param seed The text to be displayed.
      @param columns The number of columns.
  */
  public MTextField (String seed, int columns) {
    super(seed,columns);
    /* Specify the events of interest */
    enableEvents(AWTEvent.MOUSE_EVENT_MASK);
    enableEvents(AWTEvent.KEY_EVENT_MASK);
  }

  /** Overrides <CODE>java.awt.ProcessEvent(AWTEvent e)</CODE> in order to allow a right mouse exit.
      @param e The event.
  */
  public void processEvent (AWTEvent e) {
    if (e.getID()==MouseEvent.MOUSE_RELEASED &&
            (((InputEvent)e).getModifiers()&MouseEvent.BUTTON3_MASK)!=0) {
        processActionEvent(new ActionEvent(this,0,"EXIT"));
    }
    super.processEvent(e);
  }

  /** Method to override TextField.  This is here because of a bug in Java 5.0
      where the caret position is not valid after a setText invocation.
      @param str The input string
   */
  public void setText(String str) {
    // JPH -- This is a workaround for a JDK 5 bug where the caret position
    // can be greater than the length of the string causing
    //     Exception in thread "AWT-EventQueue-0" java.lang.IllegalArgumentException: bad position: ...
    // The check is because JDK 1.4 does not have this problem but does not allow setting
    // the caret position but instead complains with
    //    java.awt.IllegalComponentStateException: Cannot set caret position until after the peer has been created
    super.setText(str);
    if (nxm.sys.lib.StringUtil.compareVersions("1.5.0", nxm.sys.lib.Shell.getJavaVersion()) <= 0) {
      super.setCaretPosition(str.length());
    }
  }
}
