package nxm.sys.libg;

import nxm.sys.inc.*;

import java.awt.*;

/** A class to handle a MJText area in its own MWindow
    @author  Jeff Schoen
    @version $Id: MWText.java,v 1.6 2009/05/21 18:45:33 jwb Exp $
*/
public class MWText extends MWindow {

  public MJText mtext;

  /** Creates a new instance.
      @param name   The name of the window.
      @param parent The window's message handler.
   */
  public MWText (String name, int lines, int rows, int cols, int fontsize, 
      int flags, MessageHandler parent) {
    super(name,parent);
    setupText(lines,rows,cols,fontsize,flags);
  }
  
  /** Setup the MJText */
  private void setupText (int lines, int rows, int cols, int fontsize,
      int flags) {
    mtext = new MJText(lines,rows,cols,fontsize,Theme.global(),flags);
    panel = (Container)mtext;
    setSize (mtext.getWidth(),mtext.getHeight());
    mtext.setMWindow(this);
  }
  
  public void setTheme (Theme theme) {
    super.setTheme(theme);
    if (mtext!=null) mtext.setTheme(theme);
  }

}

