/***********************************/
/* THIS IS AN AUTO-GENERATED CLASS */
/*       !!! DO NOT EDIT !!!       */
/***********************************/
package nxm.sys.libm;

import nxm.sys.inc.*;

/**
   Performs the ArcCosine operation on arrays. <br>
   See {@link Operator} for a description of the available I/O Modes.
   @author  Auto-Generated by the {@link Generate} class.
   @see     Operator
*/
@SuppressWarnings("cast")
public final class ArcCosine extends Operator implements Constants {

  /** Create a new instance. */
  public ArcCosine() {
    super();
  }

  /** Create a new instance.
      @param flags The processing flags to use.
   */
  public ArcCosine (int flags) {
    super(flags);
  }

  /** Create a new instance.
      @param scale The scale factor to use.
   */
  public ArcCosine (double scale) {
    super(scale);
  }

  /** Create a new instance.
      @param flags The processing flags to use.
      @param scale The scale factor to use.
   */
  public ArcCosine (int flags, double scale) {
    super(flags,scale);
  }

  public final int validate (char type, int n, int mode) {
    switch (mode) {
      case SS: return n;
      default: return NOSUPPORT;
    }
  }

  public final int process (double[][] v, int n, int mode) {
    switch (mode) { 
      case SS: SS(v[0],v[1],n, scale); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (double[][] v, int n, int mode, double scale) {
    switch (mode) { 
      case SS: SS(v[0],v[1],n, scale); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#SS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @param scale The scale factor.
      @see #process(double[][],int,int,double)
   */
  public static final void SS (double[] a, double[] b, int n, double scale) {
      for (int i=0; i<n; i++) {
        b[i]=(double)(scale*Math.acos((double)a[i]));
      }
  }

  public final int process (float[][] v, int n, int mode) {
    switch (mode) { 
      case SS: SS(v[0],v[1],n, scale); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (float[][] v, int n, int mode, double scale) {
    switch (mode) { 
      case SS: SS(v[0],v[1],n, scale); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#SS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @param scale The scale factor.
      @see #process(float[][],int,int,double)
   */
  public static final void SS (float[] a, float[] b, int n, double scale) {
      for (int i=0; i<n; i++) {
        b[i]=(float)(scale*Math.acos((double)a[i]));
      }
  }

  public final int process (int[][] v, int n, int mode) {
    switch (mode) { 
      case SS: SS(v[0],v[1],n, scale); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (int[][] v, int n, int mode, double scale) {
    switch (mode) { 
      case SS: SS(v[0],v[1],n, scale); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#SS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @param scale The scale factor.
      @see #process(int[][],int,int,double)
   */
  public static final void SS (int[] a, int[] b, int n, double scale) {
      for (int i=0; i<n; i++) {
        b[i]=(int)(scale*Math.acos((double)a[i]));
      }
  }

  public int getInputs() { return 1; }
  public int getOutputs() { return 1; }
}
