/***********************************/
/* THIS IS AN AUTO-GENERATED CLASS */
/*       !!! DO NOT EDIT !!!       */
/***********************************/
package nxm.sys.libm;

import nxm.sys.inc.*;

/**
   Performs the Clip operation on arrays. <br>
   CLIP value to within a MAX <br>
   See {@link Operator} for a description of the available I/O Modes.
   @author  Auto-Generated by the {@link Generate} class.
   @see     Operator
*/
@SuppressWarnings("cast")
public final class Clip extends Operator implements Constants {

  /** Create a new instance. */
  public Clip() {
    super();
  }

  /** Create a new instance.
      @param flags The processing flags to use.
   */
  public Clip (int flags) {
    super(flags);
  }

  /** Create a new instance.
      @param scale The scale factor to use.
   */
  public Clip (double scale) {
    super(scale);
  }

  /** Create a new instance.
      @param flags The processing flags to use.
      @param scale The scale factor to use.
   */
  public Clip (int flags, double scale) {
    super(flags,scale);
  }

  public final int validate (char type, int n, int mode) {
    switch (mode) {
      case SSSS: return n;
      default: return NOSUPPORT;
    }
  }

  public final int process (double[][] v, int n, int mode) {
    switch (mode) { 
      case SSSS: SSSS(v[0],v[1],v[2],v[3],n); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (double[][] v, int n, int mode, double scale) {
    switch (mode) { 
      case SSSS: SSSS(v[0],v[1],v[2],v[3],n); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#SSSS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param c     The third  operand.
      @param d     The fourth  operand.
      @param n     The number of elements to operate on.
      @see #process(double[][],int,int)
   */
  public static final void SSSS (double[] a, double[] b, double[] c, double[] d, int n) {
    if (c.length == 1) {
      for (int i=0; i<n; i++) {
        d[i]=Math.min(b[i],Math.max(c[0],a[i]));
      }
    } else if (b.length == 1) {
      for (int i=0; i<n; i++) {
        d[i]=Math.min(b[0],Math.max(c[i],a[i]));
      }
    } else if (a.length == 1) {
      for (int i=0; i<n; i++) {
        d[i]=Math.min(b[i],Math.max(c[i],a[0]));
      }
    } else {
      for (int i=0; i<n; i++) {
        d[i]=Math.min(b[i],Math.max(c[i],a[i]));
      }
    }
  }

  public final int process (float[][] v, int n, int mode) {
    switch (mode) { 
      case SSSS: SSSS(v[0],v[1],v[2],v[3],n); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (float[][] v, int n, int mode, double scale) {
    switch (mode) { 
      case SSSS: SSSS(v[0],v[1],v[2],v[3],n); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#SSSS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param c     The third  operand.
      @param d     The fourth  operand.
      @param n     The number of elements to operate on.
      @see #process(float[][],int,int)
   */
  public static final void SSSS (float[] a, float[] b, float[] c, float[] d, int n) {
    if (c.length == 1) {
      for (int i=0; i<n; i++) {
        d[i]=Math.min(b[i],Math.max(c[0],a[i]));
      }
    } else if (b.length == 1) {
      for (int i=0; i<n; i++) {
        d[i]=Math.min(b[0],Math.max(c[i],a[i]));
      }
    } else if (a.length == 1) {
      for (int i=0; i<n; i++) {
        d[i]=Math.min(b[i],Math.max(c[i],a[0]));
      }
    } else {
      for (int i=0; i<n; i++) {
        d[i]=Math.min(b[i],Math.max(c[i],a[i]));
      }
    }
  }

  public final int process (int[][] v, int n, int mode) {
    switch (mode) { 
      case SSSS: SSSS(v[0],v[1],v[2],v[3],n); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (int[][] v, int n, int mode, double scale) {
    switch (mode) { 
      case SSSS: SSSS(v[0],v[1],v[2],v[3],n); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#SSSS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param c     The third  operand.
      @param d     The fourth  operand.
      @param n     The number of elements to operate on.
      @see #process(int[][],int,int)
   */
  public static final void SSSS (int[] a, int[] b, int[] c, int[] d, int n) {
    if (c.length == 1) {
      for (int i=0; i<n; i++) {
        d[i]=Math.min(b[i],Math.max(c[0],a[i]));
      }
    } else if (b.length == 1) {
      for (int i=0; i<n; i++) {
        d[i]=Math.min(b[0],Math.max(c[i],a[i]));
      }
    } else if (a.length == 1) {
      for (int i=0; i<n; i++) {
        d[i]=Math.min(b[i],Math.max(c[i],a[0]));
      }
    } else {
      for (int i=0; i<n; i++) {
        d[i]=Math.min(b[i],Math.max(c[i],a[i]));
      }
    }
  }

  public int getInputs() { return 3; }
  public int getOutputs() { return 1; }
}
