/***********************************/
/* THIS IS AN AUTO-GENERATED CLASS */
/*       !!! DO NOT EDIT !!!       */
/***********************************/
package nxm.sys.libm;

import nxm.sys.inc.*;

/**
   Performs the Square operation on arrays. <br>
   See {@link Operator} for a description of the available I/O Modes.
   @author  Auto-Generated by the {@link Generate} class.
   @see     Operator
*/
@SuppressWarnings("cast")
public final class Square extends Operator implements Constants {

  /** Create a new instance. */
  public Square() {
    super();
  }

  /** Create a new instance.
      @param flags The processing flags to use.
   */
  public Square (int flags) {
    super(flags);
  }

  /** Create a new instance.
      @param scale The scale factor to use.
   */
  public Square (double scale) {
    super(scale);
  }

  /** Create a new instance.
      @param flags The processing flags to use.
      @param scale The scale factor to use.
   */
  public Square (int flags, double scale) {
    super(flags,scale);
  }

  public final int validate (char type, int n, int mode) {
    switch (mode) {
      case SS: return n;
      case CC: return n;
      default: return NOSUPPORT;
    }
  }

  public final int process (double[][] v, int n, int mode) {
    switch (mode) { 
      case SS: SS(v[0],v[1],n); return n;
      case CC: CC(v[0],v[1],n); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (double[][] v, int n, int mode, double scale) {
    switch (mode) { 
      case SS: SS(v[0],v[1],n); return n;
      case CC: CC(v[0],v[1],n); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#SS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(double[][],int,int)
   */
  public static final void SS (double[] a, double[] b, int n) {
      for (int i=0; i<n; i++) {
        b[i]=a[i]*a[i];
      }
  }

  /** Apply this operator to mode {@link Operator#CC} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(double[][],int,int)
   */
  public static final void CC (double[] a, double[] b, int n) {
      for (int i=0,j=0; i<n; i++,j+=2) {
        double t=a[j]*a[j]-a[j+1]*a[j+1]; b[j+1]=2*a[j+1]*a[j]; b[j]=t;
      }
  }

  public final int process (float[][] v, int n, int mode) {
    switch (mode) { 
      case SS: SS(v[0],v[1],n); return n;
      case CC: CC(v[0],v[1],n); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (float[][] v, int n, int mode, double scale) {
    switch (mode) { 
      case SS: SS(v[0],v[1],n); return n;
      case CC: CC(v[0],v[1],n); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#SS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(float[][],int,int)
   */
  public static final void SS (float[] a, float[] b, int n) {
      for (int i=0; i<n; i++) {
        b[i]=a[i]*a[i];
      }
  }

  /** Apply this operator to mode {@link Operator#CC} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(float[][],int,int)
   */
  public static final void CC (float[] a, float[] b, int n) {
      for (int i=0,j=0; i<n; i++,j+=2) {
        float t=a[j]*a[j]-a[j+1]*a[j+1]; b[j+1]=2*a[j+1]*a[j]; b[j]=t;
      }
  }

  public final int process (int[][] v, int n, int mode) {
    switch (mode) { 
      case SS: SS(v[0],v[1],n); return n;
      case CC: CC(v[0],v[1],n); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (int[][] v, int n, int mode, double scale) {
    switch (mode) { 
      case SS: SS(v[0],v[1],n); return n;
      case CC: CC(v[0],v[1],n); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#SS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(int[][],int,int)
   */
  public static final void SS (int[] a, int[] b, int n) {
      for (int i=0; i<n; i++) {
        b[i]=a[i]*a[i];
      }
  }

  /** Apply this operator to mode {@link Operator#CC} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param n     The number of elements to operate on.
      @see #process(int[][],int,int)
   */
  public static final void CC (int[] a, int[] b, int n) {
      for (int i=0,j=0; i<n; i++,j+=2) {
        int t=a[j]*a[j]-a[j+1]*a[j+1]; b[j+1]=2*a[j+1]*a[j]; b[j]=t;
      }
  }

  public int getInputs() { return 1; }
  public int getOutputs() { return 1; }
}
