// <BBMakeDefs>
// <HPtr size="8">
//     0, int                 , getP                   , setP                   , ""
//     ~, int                 , getFill                , setFill                , ""
// </HPtr>
// <PkthdStruct size="8">
//     0, int                 , getCateg               , setCateg               , "Packet category"
//     ~, int                 , getLen                 , setLen                 , "Packet length"
// </PkthdStruct>
// <PktStruct size="(8*L_MAX_PKT_REG)+120">
//     0, Boolean(int)        , getPacketized          , setPacketized          , "Flag for packet data"
//     ~, int                 , getFlags               , setFlags               , "Packet handling flags"
//     ~, HPtr                , getBufPtr              , setBufPtr              , "Pointer to packet buffer"
//     ~, Boolean(int)        , getSendNewPkt          , setSendNewPkt          , "flag new to send"
//     ~, Boolean(int)        , getGetNewPkt           , setGetNewPkt           , "flag to look for new pkt"
//     ~, Boolean(int)        , getRcvdNewPkt          , setRcvdNewPkt          , "New meta-data pkt has arrived"
//     ~, int                 , getElmRem              , setElmRem              , "Elements remaining in data pkt."
//     ~, int                 , getByteCount           , setByteCount           , "bytes read/written of non-Midas data"
//     ~, int                 , getRegCount            , setRegCount            , "number of HOUTs registered"
//     ~, Boolean(int)        , getHcbmod              , setHcbmod              , "Flag that HCB modified in last GRAB"
//     ~, Boolean(int)        , getHcbchg              , setHcbchg              , "HCB changed since start of file"
//     ~, double              , getByteOffset          , setByteOffset          , "Offset in to file in bytes"
//     ~, double              , getHcbOffsetSave       , setHcbOffsetSave       , "Save hcb.offset"
//     ~, double              , getAbsElmOffset        , setAbsElmOffset        , "Absolute Logical Element offset"
//     ~, double              , getAbsElmSeek          , setAbsElmSeek          , "Abs. Logical element to seek to"
//     ~, double              , getFirstElm            , setFirstElm            , "First element in file"
//     ~, double              , getLastElm             , setLastElm             , "Last element in file"
//     ~, HPtr[L_MAX_PKT_REG] , getRegOutPtr           , setRegOutPtr           , "Pointers to reg'd HOUTs"
//     ~, FortranString(4)    , getBrdgXcmp            , setBrdgXcmp            , "Bridge exception compare type"
//     ~, int                 , getBrdgXv1             , setBrdgXv1             , "Bridge exception value 1"
//     ~, int                 , getBrdgXv2             , setBrdgXv2             , "Bridge exception value 2"
//     ~, FortranString(4)    , getPropXcmp            , setPropXcmp            , "Prop. exception compare type"
//     ~, int                 , getPropXv1             , setPropXv1             , "Prop. exception value 1"
//     ~, int                 , getPropXv2             , setPropXv2             , "Prop. exception value 2"
// </PktStruct>
// <SubrecStruct size="8">
//     0, FortranString(4)    , getName                , setName                , ""
//     ~, FortranString(2)    , getFormat              , setFormat              , ""
//     ~, short               , getOffset              , setOffset              , ""
// </SubrecStruct>
// <CompStruct size="8">
//     0, FortranString(4)    , getName                , setName                , ""
//     ~, FortranString(2)    , getFormat              , setFormat              , ""
//     ~, byte                , getType                , setType                , ""
//     ~, byte                , getUnits               , setUnits               , ""
// </CompStruct>
// <MAIN>
//     0, FortranString(512)  , getMain                , setMain                , ""
//     0, FortranString(4)    , getVersion             , setVersion             , "Header version"
//     ~, FortranString(4)    , getHeadRep             , setHeadRep             , "Header representation"
//     ~, FortranString(4)    , getDataRep             , setDataRep             , "Data representation"
//     ~, int                 , getDetached            , setDetached            , "detached header"
//     ~, int                 , getProtected           , setProtected           , "protected from overwrite"
//     ~, int                 , getPipe                , setPipe                , "pipe mode"
//     ~, int                 , getExtStart            , setExtStart            , "extended header start block"
//     ~, int                 , getExtSize             , setExtSize             , "extended header size bytes"
//     ~, double              , getDataStart           , setDataStart           , "data start in bytes"
//     ~, double              , getDataSize            , setDataSize            , "data size in bytes"
//     ~, int                 , getType                , setType                , "file type code"
//     ~, FortranString(2)    , getFormat              , setFormat              , "data format code"
//     ~, short               , getFlagmask            , setFlagmask            , "16 bit flag mask (1=flagbit)"
//     ~, double              , getTimecode            , setTimecode            , "time code field"
//     ~, short               , getInlet               , setInlet               , "inlet owner"
//     ~, short               , getOutlets             , setOutlets             , "number outlets"
//     ~, int                 , getOutmask             , setOutmask             , "outlet async mask"
//     ~, int                 , getPipeloc             , setPipeloc             , "pipe location"
//     ~, int                 , getPipesize            , setPipesize            , "pipe size in bytes"
//     ~, double              , getInByte              , setInByte              , "next input byte"
//     ~, double              , getOutByte             , setOutByte             , "next out byte (cumulative)"
//     ~, double[L_OUTLETS]   , getOutBytes            , setOutBytes            , "next out byte (each outlet)"
//     ~, int                 , getKeylength           , setKeylength           , "length of keyword string"
//     ~, FortranString(L_KEYWORDS), getKeywords       , setKeywords            , "user defined keyword string"
//     0, FortranString(256)  , getFill1               , setFill1               , ""
//     ~, double              , getXstart              , setXstart              , "abscissa start"
//     ~, double              , getXdelta              , setXdelta              , "abscissa delta"
//     ~, int                 , getXunits              , setXunits              , "abscissa units"
//     ~, int                 , getSubsize             , setSubsize             , "element size (type 2000)"
//     ~, double              , getYstart              , setYstart              , "secondary start"
//     ~, double              , getYdelta              , setYdelta              , "secondary delta"
//     ~, int                 , getYunits              , setYunits              , "secondary units"
//     ~, int                 , getBid                 , setBid                 , "avl dr# 5349 TMS buffer id"
//     0, FortranString(256)  , getFill2               , setFill2               , ""
//     ~, double              , getRstart              , setRstart              , "abscissa start"
//     ~, double              , getRdelta              , setRdelta              , "abscissa delta"
//     ~, int                 , getRunits              , setRunits              , "abscissa units"
//     ~, int                 , getSubrecords          , setSubrecords          , "# subrecords per record"
//     ~, double              , getR2start             , setR2start             , "abscissa 2 start"
//     ~, double              , getR2delta             , setR2delta             , "abscissa 2 delta"
//     ~, int                 , getR2units             , setR2units             , "abscissa 2 units"
//     ~, int                 , getRecordLength        , setRecordLength        , "record length in bytes"
//     ~, SubrecStruct[L_SUBRECORDS], getSubr          , setSubr                , ""
//     0, FortranString(256)  , getFill3               , setFill3               , ""
//     ~, double              , getVrstart             , setVrstart             , "abscissa start"
//     ~, double              , getVrdelta             , setVrdelta             , "abscissa delta"
//     ~, int                 , getVrunits             , setVrunits             , "abscissa units"
//     ~, int                 , getNrecords            , setNrecords            , "# records in file"
//     ~, double              , getVr2start            , setVr2start            , "abscissa 2 start"
//     ~, double              , getVr2delta            , setVr2delta            , "abscissa 2 delta"
//     ~, int                 , getVr2units            , setVr2units            , "abscissa 2 units"
//     ~, int                 , getVrecordLength       , setVrecordLength       , "record length in bytes"
//     0, FortranString(256)  , getFill4               , setFill4               , ""
//     ~, double              , getTstart              , setTstart              , "abscissa start"
//     ~, double              , getTdelta              , setTdelta              , "abscissa delta"
//     ~, int                 , getTunits              , setTunits              , "abscissa units"
//     ~, int                 , getComponents          , setComponents          , "# components per record"
//     ~, double              , getT2start             , setT2start             , "abscissa 2 start"
//     ~, double              , getT2delta             , setT2delta             , "abscissa 2 delta"
//     ~, int                 , getT2units             , setT2units             , "abscissa 2 units"
//     ~, int                 , getRecordLen           , setRecordLen           , "record length in bytes"
//     ~, CompStruct[L_COMPONENTS], getComp            , setComp                , ""
//     ~, double[L_QUADWORDS] , getQuadwords           , setQuadwords           , "systems modelling frame info"
//     0, FortranString(416)  , getFill5               , setFill5               , ""
//     ~, FortranString(8)    , getFrameOfRef          , setFrameOfRef          , "coordinate reference frame"
//     ~, double              , getAltitude            , setAltitude            , "altitude (meters) for topocent"
//     ~, double              , getLatitude            , setLatitude            , "latitude (deg) for topocentric"
//     ~, double              , getLongitude           , setLongitude           , "latitude (deg) for topocentric"
//     ~, double              , getAzimuth             , setAzimuth             , "azimuth (deg) for topocentric"
//     ~, double              , getElevation           , setElevation           , "elevation (deg) for topocentric"
//     ~, double              , getRoll                , setRoll                , "roll (deg) for topocentric"
//     ~, double              , getNotused1            , setNotused1            , ""
//     ~, double              , getNotused2            , setNotused2            , ""
//     ~, double              , getEpochYear           , setEpochYear           , "year of epoch for ECI"
//     ~, double              , getEpochSeconds        , setEpochSeconds        , "seconds of epoch for ECI"
//     ~, double              , getHourAngle           , setHourAngle           , "GW angle (rad) at epoch f ECI"
//     0, FortranString(416)  , getFill6               , setFill6               , ""
//     ~, FortranString(96)   , getQuads               , setQuads               , ""
//     0, FortranString(416)  , getFill7               , setFill7               , ""
//     ~, double[L_QUADWORDS] , getQuad                , setQuad                , ""
//  Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))), FortranString(1024), getInternals, setInternals, ""
//  Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))), FortranString(80), getFileName, setFileName, "file name to/from M$ALLOCATE"
//     ~, FortranString(80)   , getDetachName          , setDetachName          , "file name for .DET file"
//     ~, FortranString(40)   , getTypeAllow           , setTypeAllow           , "string of allowable type codes"
//     ~, FortranString(40)   , getFormatAllow         , setFormatAllow         , "string of allow format codes"
//     ~, FortranString(120)  , getQualifier           , setQualifier           , "qualifier string"
//     ~, FortranString(20)   , getLabel               , setLabel               , "filename result label"
//     ~, FortranString(12)   , getRtype               , setRtype               , "file record type"
//     ~, FortranString(8)    , getSwitch              , setSwitch              , "switch string"
//     ~, FortranString(4)    , getExtension           , setExtension           , "filename extension field"
//     ~, int                 , getQualifierlen        , setQualifierlen        , "qualifier string length"
//     ~, int                 , getFileLu              , setFileLu              , "file logical unit"
//     ~, int                 , getHeadLu              , setHeadLu              , "file logical unit"
//     ~, Boolean(int)        , getExist               , setExist               , "file existence flag"
//     ~, Boolean(int)        , getOpen                , setOpen                , "file open flag"
//     ~, Boolean(int)        , getOutput              , setOutput              , "open for output/input"
//     ~, int                 , getTypeClass           , setTypeClass           , "type code class (type/1000)"
//     ~, double              , getDbpe                , setDbpe                , "DP bytes per element"
//     ~, double              , getSize                , setSize                , "file size in log elements"
//     ~, double              , getOffset              , setOffset              , "file read offset in log elem"
//     ~, double              , getSaveOffset          , setSaveOffset          , "byte offset of saved"
//     ~, double              , getFirstByte           , setFirstByte           , "data read first byte"
//     ~, double              , getLastByte            , setLastByte            , "data write last byte"
//     ~, int                 , getBps                 , setBps                 , "bytes per scalar"
//     ~, int                 , getSpa                 , setSpa                 , "scalars per atom"
//     ~, int                 , getBpa                 , setBpa                 , "bytes per atom"
//     ~, int                 , getBpe                 , setBpe                 , "bytes per element"
//     ~, int                 , getApe                 , setApe                 , "atoms per element"
//     ~, int                 , getSaveSize            , setSaveSize            , "# elements in saved"
//     ~, int                 , getSavebufLoc          , setSavebufLoc          , "save buffer location (GRABX)"
//     ~, int                 , getSavebufLen          , setSavebufLen          , "save buffer size in bytes"
//     ~, int                 , getXferLen             , setXferLen             , "transfer length"
//     ~, int                 , getConsLen             , setConsLen             , "consume length"
//     ~, FortranString(2)    , getScrFormat           , setScrFormat           , "scratch format"
//     ~, AsciiChar           , getBufMode             , setBufMode             , "buffer format mode"
//     ~, AsciiChar           , getBufType             , setBufType             , "buffer format type"
//     ~, Boolean(byte)       , getReadonly            , setReadonly            , "open for read only ?"
//     ~, Boolean(byte)       , getOverwrite           , setOverwrite           , "open for over write ?"
//     ~, Boolean(byte)       , getContiguous          , setContiguous          , "open contiguous disk file ?"
//     ~, Boolean(byte)       , getFlush               , setFlush               , "keep output flushed to disk ?"
//     ~, int                 , getOutlet              , setOutlet              , "pipe outlet number"
//     ~, int                 , getDiskBlk             , setDiskBlk             , "disk address of file data"
//     ~, int                 , getDiskBlkHdr          , setDiskBlkHdr          , "disk address of file header"
//     ~, int                 , getDiskBlkAlloc        , setDiskBlkAlloc        , "disk allocation of data"
//     ~, int                 , getDiskAddress         , setDiskAddress         , "disk addr data in bytes"
//     ~, int                 , getExtLoc              , setExtLoc              , "ext header mem location"
//     ~, int                 , getExtAlloc            , setExtAlloc            , "ext header mem allocated"
//     ~, int                 , getExtScopeStart       , setExtScopeStart       , "ext header scope start"
//     ~, int                 , getExtScopeEnd         , setExtScopeEnd         , "ext header scope end"
//     ~, int                 , getExtNext             , setExtNext             , "ext next"
//     ~, short               , getLastBits            , setLastBits            , "bits in save_bits byte"
//     ~, byte                , getSaveBits            , setSaveBits            , "holds packed offset byte"
//     ~, byte                , getAux                 , setAux                 , "aux disk"
//     ~, int                 , getLph                 , setLph                 , "location of pipe header"
//     ~, int                 , getBlk                 , setBlk                 , "DS disk block size"
//     ~, int                 , getStatus              , setStatus              , "DS status flag"
//     ~, byte                , getMode                , setMode                , "DS IO mode"
//     ~, byte                , getEngine              , setEngine              , "DS engine #"
//     ~, byte                , getActive              , setActive              , "DS active"
//     ~, byte                , getDsfill              , setDsfill              , "DS filler"
//     ~, int                 , getT6subrLoc           , setT6subrLoc           , "T6 subrecords mem location"
//     ~, int                 , getT6subrAlloc         , setT6subrAlloc         , "T6 subrecords mem allocated"
//     ~, int                 , getFiller              , setFiller              , "force 8 byte alignment"
//     ~, PkthdStruct         , getPkthd               , setPkthd               , "size = 8 bytes"
//     ~, PktStruct           , getPkt                 , setPkt                 , "size = L_pkt_struct_size"
//     ~, long                , getBufferBlock         , setBufferBlock         , "block # of data in header buf"
//     ~, byte[32]            , getIhdrfill            , setIhdrfill            , "fill internal header to 1024"
//  Math.max(512, Math.max(Math.max(Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416)), ((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+1024)), ((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+(8*L_MAX_PKT_REG)+768))), byte[512], getBuffer, setBuffer, "primitive data buffer"
// </MAIN>
// </BBMakeDefs>
package nxm.sys.libxm;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import nxm.sys.lib.Shell;


/** A class that wraps the native HEADER structure for null; this is an automatically generated class. DO NOT EDIT!!! */
class Header {
  /** The byte buffer to use. */
  private final ByteBuffer byteBuffer;
  
  /** Creates a new instance.
      @param byteBuffer The byte buffer to use.
   */
  public Header(ByteBuffer byteBuffer) {
    this.byteBuffer = byteBuffer;
  }
  
  /** Gets the byte buffer.
      @return The byte buffer.
   */
  public ByteBuffer getByteBuffer() {
    return byteBuffer;
  }
  /** unknown */
  public static final int L_QUADWORDS = 12;
  
  /** unknown */
  public static final int L_COMPONENTS = 14;
  
  /** unknown */
  public static final int L_SUBRECORDS = 26;
  
  /** unknown */
  public static final int L_OUTLETS = 8;
  
  /** unknown */
  public static final int L_KEYWORDS = 92;
  
  /** unknown */
  public static final int L_HEADER_SIZE = 2048;
  
  /** length of T6 subr&#46; def&#46; string */
  public static final int L_T6SUBR_STR_LEN = 96;
  
  /** size of T6 subr&#46; def&#46; table */
  public static final int L_T6SUBR_LEN = 64;
  
  /** unknown */
  public static final int L_MAX_PKT_SIZE = 2048;
  
  /** unknown */
  public static final int L_PKT_STRUCT_SIZE = 376;
  
  /** unknown */
  public static final int L_MAX_PKT_REG = 32;
  
  /** unknown */
  public static final int L_PKT_HD_SIZE = 8;
  
  /** Do not bridge across meta-data for xfers */
  public static final int PK_NOBRIDGE = 1;
  
  /** Do not propagate meta-data packets */
  public static final int PK_NOPROP = 2;
  
  /** Flag to put M$GRABX in SEEK mode */
  public static final int PK_SEEK = 4;
  
  /** Flag for libs to mod HCB */
  public static final int PK_HDRMOD = 8;
  
  /** unknown */
  public static final int T6O_NAME = 0;
  
  /** unknown */
  public static final int T6O_MINVAL = 24;
  
  /** unknown */
  public static final int T6O_MAXVAL = 32;
  
  /** unknown */
  public static final int T6O_OFFSET = 40;
  
  /** unknown */
  public static final int T6O_NUM_ELTS = 44;
  
  /** unknown */
  public static final int T6O_UNITS = 48;
  
  /** unknown */
  public static final int T6O_UPREFIX = 52;
  
  /** unknown */
  public static final int T6O_FORMAT = 56;
  
  /** size of vrb header */
  public static final int L_VRBHEAD = 24;
  
  /** size of key header */
  public static final int L_KEYHEAD = 8;
  
  /** unknown */
  public static final int MK_NORMAL = 0;
  
  /** unknown */
  public static final int MK_MAIN = 1;
  
  /** unknown */
  public static final int MK_EXT = 2;
  
  /** unknown */
  public static final int MK_NOSCOPE = 4;
  
  /** unknown */
  public static final int MK_NEXT = 8;
  
  /** unknown */
  public static final int MK_TYPEASIS = 16;
  
  /** unknown */
  public static final int MK_TYPETAG = 32;
  
  /** unknown */
  public static final int MK_REPLACE = 64;
  
  /** unknown */
  public static final int MK_INDEX = 128;
  
  /** unknown */
  public static final int MK_NEXTMATCH = 256;
  
  /** unknown */
  public static final int MK_LAST = 512;
  
  /** unknown */
  public static final int BK_MAIN = 0;
  
  /** unknown */
  public static final int BK_EXT = 1;
  
  /** unknown */
  public static final int BK_NOSCOPE = 2;
  
  /** unknown */
  public static final int BK_NEXT = 3;
  
  /** unknown */
  public static final int BK_TYPEASIS = 4;
  
  /** unknown */
  public static final int BK_TYPETAG = 5;
  
  /** unknown */
  public static final int BK_REPLACE = 6;
  
  /** unknown */
  public static final int BK_INDEX = 7;
  
  /** unknown */
  public static final int BK_NEXTMATCH = 8;
  
  /** unknown */
  public static final int BK_LAST = 9;
  
  /** unknown */
  public static final int VRB_INIT = 1;
  
  /** unknown */
  public static final int VRB_OFFSET = 2;
  
  /** unknown */
  public static final int VRB_READ = 3;
  
  /** unknown */
  public static final int VRB_WRITE = 4;
  
  /** unknown */
  public static final int HCBF_CTG = 1;
  
  /** unknown */
  public static final int HCBF_AUX = 2;
  
  /** unknown */
  public static final int HCBF_SAM = 4;
  
  /** unknown */
  public static final int HCBF_FLUSH = 8;
  
  /** unknown */
  public static final int HCBF_APPEND = 16;
  
  /** unknown */
  public static final int HCBF_REOPEN = 32;
  
  /** unknown */
  public static final int HCBF_LASTBYTE = 64;
  
  /** unknown */
  public static final int HCBF_DETACH = 128;
  
  /** unknown */
  public static final int HCBF_INPUT = 256;
  
  /** unknown */
  public static final int HCBF_OUTPUT = 512;
  
  /** unknown */
  public static final int HCBF_HCBMOD = 1024;
  
  /** unknown */
  public static final int HCBF_OPTIONAL = 2048;
  
  /** unknown */
  public static final int HCBF_NOABORT = 4096;
  
  /** unknown */
  public static final int HCBF_PRESERVE = 8192;
  
  /** unknown */
  public static final int HCBF_WAIT = 16384;
  
  /** unknown */
  public static final int HCBF_EOF = 32768;
  
  /** unknown */
  public static final int HCBF_AVAIL = 65536;
  
  /** unknown */
  public static final int HCBF_SKIP = 131072;
  
  /** unknown */
  public static final int HCBF_PS = 262144;
  
  // <BBMakeGenCode>//GEN-BEGIN:BBMakeGenCode
  /* This next section of code generated by BBDEF2JAVA in CONVERT.
     DO NOT EDIT THIS CODE, it will be re-written every time
     BBDEF2JAVA is run and any changes will be lost.
   */
  //   <editor-fold defaultstate="collapsed" desc=" Generated Code ">
  /** Gets the unknown.
      @return The unknown.
   */
  public String getMain() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 512; i++) {
      char letter = (char)getByteBuffer().get((0)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public void setMain(String val) {
    for (int i = 0; i < 512; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((0)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((0)+i, (byte)' ');
      }
    }
  }

  /** Gets the Header version.
      @return The Header version.
   */
  public String getVersion() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get((0)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the Header version.
      @param val The Header version.
   */
  public void setVersion(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((0)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((0)+i, (byte)' ');
      }
    }
  }

  /** Gets the Header representation.
      @return The Header representation.
   */
  public String getHeadRep() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get((4)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the Header representation.
      @param val The Header representation.
   */
  public void setHeadRep(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((4)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((4)+i, (byte)' ');
      }
    }
  }

  /** Gets the Data representation.
      @return The Data representation.
   */
  public String getDataRep() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get((8)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the Data representation.
      @param val The Data representation.
   */
  public void setDataRep(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((8)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((8)+i, (byte)' ');
      }
    }
  }

  /** Gets the detached header.
      @return The detached header.
   */
  public int getDetached() {
    return getByteBuffer().getInt(12);
  }

  /** Sets the detached header.
      @param val The detached header.
   */
  public void setDetached(int val) {
    getByteBuffer().putInt(12, val);
  }

  /** Gets the protected from overwrite.
      @return The protected from overwrite.
   */
  public int getProtected() {
    return getByteBuffer().getInt(16);
  }

  /** Sets the protected from overwrite.
      @param val The protected from overwrite.
   */
  public void setProtected(int val) {
    getByteBuffer().putInt(16, val);
  }

  /** Gets the pipe mode.
      @return The pipe mode.
   */
  public int getPipe() {
    return getByteBuffer().getInt(20);
  }

  /** Sets the pipe mode.
      @param val The pipe mode.
   */
  public void setPipe(int val) {
    getByteBuffer().putInt(20, val);
  }

  /** Gets the extended header start block.
      @return The extended header start block.
   */
  public int getExtStart() {
    return getByteBuffer().getInt(24);
  }

  /** Sets the extended header start block.
      @param val The extended header start block.
   */
  public void setExtStart(int val) {
    getByteBuffer().putInt(24, val);
  }

  /** Gets the extended header size bytes.
      @return The extended header size bytes.
   */
  public int getExtSize() {
    return getByteBuffer().getInt(28);
  }

  /** Sets the extended header size bytes.
      @param val The extended header size bytes.
   */
  public void setExtSize(int val) {
    getByteBuffer().putInt(28, val);
  }

  /** Gets the data start in bytes.
      @return The data start in bytes.
   */
  public double getDataStart() {
    return getByteBuffer().getDouble(32);
  }

  /** Sets the data start in bytes.
      @param val The data start in bytes.
   */
  public void setDataStart(double val) {
    getByteBuffer().putDouble(32, val);
  }

  /** Gets the data size in bytes.
      @return The data size in bytes.
   */
  public double getDataSize() {
    return getByteBuffer().getDouble(40);
  }

  /** Sets the data size in bytes.
      @param val The data size in bytes.
   */
  public void setDataSize(double val) {
    getByteBuffer().putDouble(40, val);
  }

  /** Gets the file type code.
      @return The file type code.
   */
  public int getType() {
    return getByteBuffer().getInt(48);
  }

  /** Sets the file type code.
      @param val The file type code.
   */
  public void setType(int val) {
    getByteBuffer().putInt(48, val);
  }

  /** Gets the data format code.
      @return The data format code.
   */
  public String getFormat() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 2; i++) {
      char letter = (char)getByteBuffer().get((52)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the data format code.
      @param val The data format code.
   */
  public void setFormat(String val) {
    for (int i = 0; i < 2; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((52)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((52)+i, (byte)' ');
      }
    }
  }

  /** Gets the 16 bit flag mask (1=flagbit).
      @return The 16 bit flag mask (1=flagbit).
   */
  public short getFlagmask() {
    return getByteBuffer().getShort(54);
  }

  /** Sets the 16 bit flag mask (1=flagbit).
      @param val The 16 bit flag mask (1=flagbit).
   */
  public void setFlagmask(short val) {
    getByteBuffer().putShort(54, val);
  }

  /** Gets the time code field.
      @return The time code field.
   */
  public double getTimecode() {
    return getByteBuffer().getDouble(56);
  }

  /** Sets the time code field.
      @param val The time code field.
   */
  public void setTimecode(double val) {
    getByteBuffer().putDouble(56, val);
  }

  /** Gets the inlet owner.
      @return The inlet owner.
   */
  public short getInlet() {
    return getByteBuffer().getShort(64);
  }

  /** Sets the inlet owner.
      @param val The inlet owner.
   */
  public void setInlet(short val) {
    getByteBuffer().putShort(64, val);
  }

  /** Gets the number outlets.
      @return The number outlets.
   */
  public short getOutlets() {
    return getByteBuffer().getShort(66);
  }

  /** Sets the number outlets.
      @param val The number outlets.
   */
  public void setOutlets(short val) {
    getByteBuffer().putShort(66, val);
  }

  /** Gets the outlet async mask.
      @return The outlet async mask.
   */
  public int getOutmask() {
    return getByteBuffer().getInt(68);
  }

  /** Sets the outlet async mask.
      @param val The outlet async mask.
   */
  public void setOutmask(int val) {
    getByteBuffer().putInt(68, val);
  }

  /** Gets the pipe location.
      @return The pipe location.
   */
  public int getPipeloc() {
    return getByteBuffer().getInt(72);
  }

  /** Sets the pipe location.
      @param val The pipe location.
   */
  public void setPipeloc(int val) {
    getByteBuffer().putInt(72, val);
  }

  /** Gets the pipe size in bytes.
      @return The pipe size in bytes.
   */
  public int getPipesize() {
    return getByteBuffer().getInt(76);
  }

  /** Sets the pipe size in bytes.
      @param val The pipe size in bytes.
   */
  public void setPipesize(int val) {
    getByteBuffer().putInt(76, val);
  }

  /** Gets the next input byte.
      @return The next input byte.
   */
  public double getInByte() {
    return getByteBuffer().getDouble(80);
  }

  /** Sets the next input byte.
      @param val The next input byte.
   */
  public void setInByte(double val) {
    getByteBuffer().putDouble(80, val);
  }

  /** Gets the next out byte (cumulative).
      @return The next out byte (cumulative).
   */
  public double getOutByte() {
    return getByteBuffer().getDouble(88);
  }

  /** Sets the next out byte (cumulative).
      @param val The next out byte (cumulative).
   */
  public void setOutByte(double val) {
    getByteBuffer().putDouble(88, val);
  }

  /** gets the next out byte (each outlet).
      @return The next out byte (each outlet) (an array of size L_OUTLETS).
   */
  public double[] getOutBytes() {
    double[] val = new double[L_OUTLETS];
    for (int i = 0; i < val.length; i++) {
      int off = i * 8;
      val[i] = getByteBuffer().getDouble((96)+off);
    }
    return val;
  }
  /** Gets the next out byte (each outlet) at the specified index.
      @return The next out byte (each outlet) at the specified index.
   */
  public double getOutBytesAt(int index) {
    int off = index * 8;
    double val = getByteBuffer().getDouble((96)+off);
    return val;
  }
  /** Sets the next out byte (each outlet).
      @param val The next out byte (each outlet) (must be an array of size L_OUTLETS).
   */
  public void setOutBytes(double[] val) {
    if (val.length != L_OUTLETS) {
      throw new IllegalArgumentException("setOutBytes: expected array of"
        + "length L_OUTLETS, given array of length "+val.length+".");
    }
    for (int i = 0; i < val.length; i++) {
      int off = i * 8;
      getByteBuffer().putDouble((96)+off, val[i]);
    }
  }
  /** Sets the next out byte (each outlet) at the specified index.
      @param val The next out byte (each outlet) at the specified index.
   */
  public void setOutBytesAt(int index, double val) {
    if (index >= L_OUTLETS) {
      throw new IllegalArgumentException("setOutBytes: index ["+index+"] is out of range ["+L_OUTLETS+"]");
    }
    int off = index * 8;
    getByteBuffer().putDouble((96)+off, val);
  }

  /** Gets the length of keyword string.
      @return The length of keyword string.
   */
  public int getKeylength() {
    return getByteBuffer().getInt((8*L_OUTLETS)+96);
  }

  /** Sets the length of keyword string.
      @param val The length of keyword string.
   */
  public void setKeylength(int val) {
    getByteBuffer().putInt((8*L_OUTLETS)+96, val);
  }

  /** Gets the user defined keyword string.
      @return The user defined keyword string.
   */
  public String getKeywords() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < L_KEYWORDS; i++) {
      char letter = (char)getByteBuffer().get(((8*L_OUTLETS)+100)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the user defined keyword string.
      @param val The user defined keyword string.
   */
  public void setKeywords(String val) {
    for (int i = 0; i < L_KEYWORDS; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((8*L_OUTLETS)+100)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((8*L_OUTLETS)+100)+i, (byte)' ');
      }
    }
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public String getFill1() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 256; i++) {
      char letter = (char)getByteBuffer().get((0)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public void setFill1(String val) {
    for (int i = 0; i < 256; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((0)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((0)+i, (byte)' ');
      }
    }
  }

  /** Gets the abscissa start.
      @return The abscissa start.
   */
  public double getXstart() {
    return getByteBuffer().getDouble(256);
  }

  /** Sets the abscissa start.
      @param val The abscissa start.
   */
  public void setXstart(double val) {
    getByteBuffer().putDouble(256, val);
  }

  /** Gets the abscissa delta.
      @return The abscissa delta.
   */
  public double getXdelta() {
    return getByteBuffer().getDouble(264);
  }

  /** Sets the abscissa delta.
      @param val The abscissa delta.
   */
  public void setXdelta(double val) {
    getByteBuffer().putDouble(264, val);
  }

  /** Gets the abscissa units.
      @return The abscissa units.
   */
  public int getXunits() {
    return getByteBuffer().getInt(272);
  }

  /** Sets the abscissa units.
      @param val The abscissa units.
   */
  public void setXunits(int val) {
    getByteBuffer().putInt(272, val);
  }

  /** Gets the element size (type 2000).
      @return The element size (type 2000).
   */
  public int getSubsize() {
    return getByteBuffer().getInt(276);
  }

  /** Sets the element size (type 2000).
      @param val The element size (type 2000).
   */
  public void setSubsize(int val) {
    getByteBuffer().putInt(276, val);
  }

  /** Gets the secondary start.
      @return The secondary start.
   */
  public double getYstart() {
    return getByteBuffer().getDouble(280);
  }

  /** Sets the secondary start.
      @param val The secondary start.
   */
  public void setYstart(double val) {
    getByteBuffer().putDouble(280, val);
  }

  /** Gets the secondary delta.
      @return The secondary delta.
   */
  public double getYdelta() {
    return getByteBuffer().getDouble(288);
  }

  /** Sets the secondary delta.
      @param val The secondary delta.
   */
  public void setYdelta(double val) {
    getByteBuffer().putDouble(288, val);
  }

  /** Gets the secondary units.
      @return The secondary units.
   */
  public int getYunits() {
    return getByteBuffer().getInt(296);
  }

  /** Sets the secondary units.
      @param val The secondary units.
   */
  public void setYunits(int val) {
    getByteBuffer().putInt(296, val);
  }

  /** Gets the avl dr# 5349 TMS buffer id.
      @return The avl dr# 5349 TMS buffer id.
   */
  public int getBid() {
    return getByteBuffer().getInt(300);
  }

  /** Sets the avl dr# 5349 TMS buffer id.
      @param val The avl dr# 5349 TMS buffer id.
   */
  public void setBid(int val) {
    getByteBuffer().putInt(300, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public String getFill2() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 256; i++) {
      char letter = (char)getByteBuffer().get((0)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public void setFill2(String val) {
    for (int i = 0; i < 256; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((0)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((0)+i, (byte)' ');
      }
    }
  }

  /** Gets the abscissa start.
      @return The abscissa start.
   */
  public double getRstart() {
    return getByteBuffer().getDouble(256);
  }

  /** Sets the abscissa start.
      @param val The abscissa start.
   */
  public void setRstart(double val) {
    getByteBuffer().putDouble(256, val);
  }

  /** Gets the abscissa delta.
      @return The abscissa delta.
   */
  public double getRdelta() {
    return getByteBuffer().getDouble(264);
  }

  /** Sets the abscissa delta.
      @param val The abscissa delta.
   */
  public void setRdelta(double val) {
    getByteBuffer().putDouble(264, val);
  }

  /** Gets the abscissa units.
      @return The abscissa units.
   */
  public int getRunits() {
    return getByteBuffer().getInt(272);
  }

  /** Sets the abscissa units.
      @param val The abscissa units.
   */
  public void setRunits(int val) {
    getByteBuffer().putInt(272, val);
  }

  /** Gets the # subrecords per record.
      @return The # subrecords per record.
   */
  public int getSubrecords() {
    return getByteBuffer().getInt(276);
  }

  /** Sets the # subrecords per record.
      @param val The # subrecords per record.
   */
  public void setSubrecords(int val) {
    getByteBuffer().putInt(276, val);
  }

  /** Gets the abscissa 2 start.
      @return The abscissa 2 start.
   */
  public double getR2start() {
    return getByteBuffer().getDouble(280);
  }

  /** Sets the abscissa 2 start.
      @param val The abscissa 2 start.
   */
  public void setR2start(double val) {
    getByteBuffer().putDouble(280, val);
  }

  /** Gets the abscissa 2 delta.
      @return The abscissa 2 delta.
   */
  public double getR2delta() {
    return getByteBuffer().getDouble(288);
  }

  /** Sets the abscissa 2 delta.
      @param val The abscissa 2 delta.
   */
  public void setR2delta(double val) {
    getByteBuffer().putDouble(288, val);
  }

  /** Gets the abscissa 2 units.
      @return The abscissa 2 units.
   */
  public int getR2units() {
    return getByteBuffer().getInt(296);
  }

  /** Sets the abscissa 2 units.
      @param val The abscissa 2 units.
   */
  public void setR2units(int val) {
    getByteBuffer().putInt(296, val);
  }

  /** Gets the record length in bytes.
      @return The record length in bytes.
   */
  public int getRecordLength() {
    return getByteBuffer().getInt(300);
  }

  /** Sets the record length in bytes.
      @param val The record length in bytes.
   */
  public void setRecordLength(int val) {
    getByteBuffer().putInt(300, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public SubrecStruct[] getSubr() {
    SubrecStruct[] val = new SubrecStruct[L_SUBRECORDS];
    for (int i = 0; i < val.length; i++) {
      int offset = i * 8;
      val[i] = new SubrecStruct(getByteBuffer(), (304)+offset);
    }
    return val;
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public String getFill3() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 256; i++) {
      char letter = (char)getByteBuffer().get((0)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public void setFill3(String val) {
    for (int i = 0; i < 256; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((0)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((0)+i, (byte)' ');
      }
    }
  }

  /** Gets the abscissa start.
      @return The abscissa start.
   */
  public double getVrstart() {
    return getByteBuffer().getDouble(256);
  }

  /** Sets the abscissa start.
      @param val The abscissa start.
   */
  public void setVrstart(double val) {
    getByteBuffer().putDouble(256, val);
  }

  /** Gets the abscissa delta.
      @return The abscissa delta.
   */
  public double getVrdelta() {
    return getByteBuffer().getDouble(264);
  }

  /** Sets the abscissa delta.
      @param val The abscissa delta.
   */
  public void setVrdelta(double val) {
    getByteBuffer().putDouble(264, val);
  }

  /** Gets the abscissa units.
      @return The abscissa units.
   */
  public int getVrunits() {
    return getByteBuffer().getInt(272);
  }

  /** Sets the abscissa units.
      @param val The abscissa units.
   */
  public void setVrunits(int val) {
    getByteBuffer().putInt(272, val);
  }

  /** Gets the # records in file.
      @return The # records in file.
   */
  public int getNrecords() {
    return getByteBuffer().getInt(276);
  }

  /** Sets the # records in file.
      @param val The # records in file.
   */
  public void setNrecords(int val) {
    getByteBuffer().putInt(276, val);
  }

  /** Gets the abscissa 2 start.
      @return The abscissa 2 start.
   */
  public double getVr2start() {
    return getByteBuffer().getDouble(280);
  }

  /** Sets the abscissa 2 start.
      @param val The abscissa 2 start.
   */
  public void setVr2start(double val) {
    getByteBuffer().putDouble(280, val);
  }

  /** Gets the abscissa 2 delta.
      @return The abscissa 2 delta.
   */
  public double getVr2delta() {
    return getByteBuffer().getDouble(288);
  }

  /** Sets the abscissa 2 delta.
      @param val The abscissa 2 delta.
   */
  public void setVr2delta(double val) {
    getByteBuffer().putDouble(288, val);
  }

  /** Gets the abscissa 2 units.
      @return The abscissa 2 units.
   */
  public int getVr2units() {
    return getByteBuffer().getInt(296);
  }

  /** Sets the abscissa 2 units.
      @param val The abscissa 2 units.
   */
  public void setVr2units(int val) {
    getByteBuffer().putInt(296, val);
  }

  /** Gets the record length in bytes.
      @return The record length in bytes.
   */
  public int getVrecordLength() {
    return getByteBuffer().getInt(300);
  }

  /** Sets the record length in bytes.
      @param val The record length in bytes.
   */
  public void setVrecordLength(int val) {
    getByteBuffer().putInt(300, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public String getFill4() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 256; i++) {
      char letter = (char)getByteBuffer().get((0)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public void setFill4(String val) {
    for (int i = 0; i < 256; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((0)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((0)+i, (byte)' ');
      }
    }
  }

  /** Gets the abscissa start.
      @return The abscissa start.
   */
  public double getTstart() {
    return getByteBuffer().getDouble(256);
  }

  /** Sets the abscissa start.
      @param val The abscissa start.
   */
  public void setTstart(double val) {
    getByteBuffer().putDouble(256, val);
  }

  /** Gets the abscissa delta.
      @return The abscissa delta.
   */
  public double getTdelta() {
    return getByteBuffer().getDouble(264);
  }

  /** Sets the abscissa delta.
      @param val The abscissa delta.
   */
  public void setTdelta(double val) {
    getByteBuffer().putDouble(264, val);
  }

  /** Gets the abscissa units.
      @return The abscissa units.
   */
  public int getTunits() {
    return getByteBuffer().getInt(272);
  }

  /** Sets the abscissa units.
      @param val The abscissa units.
   */
  public void setTunits(int val) {
    getByteBuffer().putInt(272, val);
  }

  /** Gets the # components per record.
      @return The # components per record.
   */
  public int getComponents() {
    return getByteBuffer().getInt(276);
  }

  /** Sets the # components per record.
      @param val The # components per record.
   */
  public void setComponents(int val) {
    getByteBuffer().putInt(276, val);
  }

  /** Gets the abscissa 2 start.
      @return The abscissa 2 start.
   */
  public double getT2start() {
    return getByteBuffer().getDouble(280);
  }

  /** Sets the abscissa 2 start.
      @param val The abscissa 2 start.
   */
  public void setT2start(double val) {
    getByteBuffer().putDouble(280, val);
  }

  /** Gets the abscissa 2 delta.
      @return The abscissa 2 delta.
   */
  public double getT2delta() {
    return getByteBuffer().getDouble(288);
  }

  /** Sets the abscissa 2 delta.
      @param val The abscissa 2 delta.
   */
  public void setT2delta(double val) {
    getByteBuffer().putDouble(288, val);
  }

  /** Gets the abscissa 2 units.
      @return The abscissa 2 units.
   */
  public int getT2units() {
    return getByteBuffer().getInt(296);
  }

  /** Sets the abscissa 2 units.
      @param val The abscissa 2 units.
   */
  public void setT2units(int val) {
    getByteBuffer().putInt(296, val);
  }

  /** Gets the record length in bytes.
      @return The record length in bytes.
   */
  public int getRecordLen() {
    return getByteBuffer().getInt(300);
  }

  /** Sets the record length in bytes.
      @param val The record length in bytes.
   */
  public void setRecordLen(int val) {
    getByteBuffer().putInt(300, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public CompStruct[] getComp() {
    CompStruct[] val = new CompStruct[L_COMPONENTS];
    for (int i = 0; i < val.length; i++) {
      int offset = i * 8;
      val[i] = new CompStruct(getByteBuffer(), (304)+offset);
    }
    return val;
  }

  /** gets the systems modelling frame info.
      @return The systems modelling frame info (an array of size L_QUADWORDS).
   */
  public double[] getQuadwords() {
    double[] val = new double[L_QUADWORDS];
    for (int i = 0; i < val.length; i++) {
      int off = i * 8;
      val[i] = getByteBuffer().getDouble(((8*L_COMPONENTS)+304)+off);
    }
    return val;
  }
  /** Gets the systems modelling frame info at the specified index.
      @return The systems modelling frame info at the specified index.
   */
  public double getQuadwordsAt(int index) {
    int off = index * 8;
    double val = getByteBuffer().getDouble(((8*L_COMPONENTS)+304)+off);
    return val;
  }
  /** Sets the systems modelling frame info.
      @param val The systems modelling frame info (must be an array of size L_QUADWORDS).
   */
  public void setQuadwords(double[] val) {
    if (val.length != L_QUADWORDS) {
      throw new IllegalArgumentException("setQuadwords: expected array of"
        + "length L_QUADWORDS, given array of length "+val.length+".");
    }
    for (int i = 0; i < val.length; i++) {
      int off = i * 8;
      getByteBuffer().putDouble(((8*L_COMPONENTS)+304)+off, val[i]);
    }
  }
  /** Sets the systems modelling frame info at the specified index.
      @param val The systems modelling frame info at the specified index.
   */
  public void setQuadwordsAt(int index, double val) {
    if (index >= L_QUADWORDS) {
      throw new IllegalArgumentException("setQuadwords: index ["+index+"] is out of range ["+L_QUADWORDS+"]");
    }
    int off = index * 8;
    getByteBuffer().putDouble(((8*L_COMPONENTS)+304)+off, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public String getFill5() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 416; i++) {
      char letter = (char)getByteBuffer().get((0)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public void setFill5(String val) {
    for (int i = 0; i < 416; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((0)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((0)+i, (byte)' ');
      }
    }
  }

  /** Gets the coordinate reference frame.
      @return The coordinate reference frame.
   */
  public String getFrameOfRef() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 8; i++) {
      char letter = (char)getByteBuffer().get((416)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the coordinate reference frame.
      @param val The coordinate reference frame.
   */
  public void setFrameOfRef(String val) {
    for (int i = 0; i < 8; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((416)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((416)+i, (byte)' ');
      }
    }
  }

  /** Gets the altitude (meters) for topocent.
      @return The altitude (meters) for topocent.
   */
  public double getAltitude() {
    return getByteBuffer().getDouble(424);
  }

  /** Sets the altitude (meters) for topocent.
      @param val The altitude (meters) for topocent.
   */
  public void setAltitude(double val) {
    getByteBuffer().putDouble(424, val);
  }

  /** Gets the latitude (deg) for topocentric.
      @return The latitude (deg) for topocentric.
   */
  public double getLatitude() {
    return getByteBuffer().getDouble(432);
  }

  /** Sets the latitude (deg) for topocentric.
      @param val The latitude (deg) for topocentric.
   */
  public void setLatitude(double val) {
    getByteBuffer().putDouble(432, val);
  }

  /** Gets the latitude (deg) for topocentric.
      @return The latitude (deg) for topocentric.
   */
  public double getLongitude() {
    return getByteBuffer().getDouble(440);
  }

  /** Sets the latitude (deg) for topocentric.
      @param val The latitude (deg) for topocentric.
   */
  public void setLongitude(double val) {
    getByteBuffer().putDouble(440, val);
  }

  /** Gets the azimuth (deg) for topocentric.
      @return The azimuth (deg) for topocentric.
   */
  public double getAzimuth() {
    return getByteBuffer().getDouble(448);
  }

  /** Sets the azimuth (deg) for topocentric.
      @param val The azimuth (deg) for topocentric.
   */
  public void setAzimuth(double val) {
    getByteBuffer().putDouble(448, val);
  }

  /** Gets the elevation (deg) for topocentric.
      @return The elevation (deg) for topocentric.
   */
  public double getElevation() {
    return getByteBuffer().getDouble(456);
  }

  /** Sets the elevation (deg) for topocentric.
      @param val The elevation (deg) for topocentric.
   */
  public void setElevation(double val) {
    getByteBuffer().putDouble(456, val);
  }

  /** Gets the roll (deg) for topocentric.
      @return The roll (deg) for topocentric.
   */
  public double getRoll() {
    return getByteBuffer().getDouble(464);
  }

  /** Sets the roll (deg) for topocentric.
      @param val The roll (deg) for topocentric.
   */
  public void setRoll(double val) {
    getByteBuffer().putDouble(464, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public double getNotused1() {
    return getByteBuffer().getDouble(472);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public void setNotused1(double val) {
    getByteBuffer().putDouble(472, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public double getNotused2() {
    return getByteBuffer().getDouble(480);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public void setNotused2(double val) {
    getByteBuffer().putDouble(480, val);
  }

  /** Gets the year of epoch for ECI.
      @return The year of epoch for ECI.
   */
  public double getEpochYear() {
    return getByteBuffer().getDouble(488);
  }

  /** Sets the year of epoch for ECI.
      @param val The year of epoch for ECI.
   */
  public void setEpochYear(double val) {
    getByteBuffer().putDouble(488, val);
  }

  /** Gets the seconds of epoch for ECI.
      @return The seconds of epoch for ECI.
   */
  public double getEpochSeconds() {
    return getByteBuffer().getDouble(496);
  }

  /** Sets the seconds of epoch for ECI.
      @param val The seconds of epoch for ECI.
   */
  public void setEpochSeconds(double val) {
    getByteBuffer().putDouble(496, val);
  }

  /** Gets the GW angle (rad) at epoch f ECI.
      @return The GW angle (rad) at epoch f ECI.
   */
  public double getHourAngle() {
    return getByteBuffer().getDouble(504);
  }

  /** Sets the GW angle (rad) at epoch f ECI.
      @param val The GW angle (rad) at epoch f ECI.
   */
  public void setHourAngle(double val) {
    getByteBuffer().putDouble(504, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public String getFill6() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 416; i++) {
      char letter = (char)getByteBuffer().get((0)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public void setFill6(String val) {
    for (int i = 0; i < 416; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((0)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((0)+i, (byte)' ');
      }
    }
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public String getQuads() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 96; i++) {
      char letter = (char)getByteBuffer().get((416)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public void setQuads(String val) {
    for (int i = 0; i < 96; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((416)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((416)+i, (byte)' ');
      }
    }
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public String getFill7() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 416; i++) {
      char letter = (char)getByteBuffer().get((0)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public void setFill7(String val) {
    for (int i = 0; i < 416; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((0)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((0)+i, (byte)' ');
      }
    }
  }

  /** gets the unknown.
      @return The unknown (an array of size L_QUADWORDS).
   */
  public double[] getQuad() {
    double[] val = new double[L_QUADWORDS];
    for (int i = 0; i < val.length; i++) {
      int off = i * 8;
      val[i] = getByteBuffer().getDouble((416)+off);
    }
    return val;
  }
  /** Gets the unknown at the specified index.
      @return The unknown at the specified index.
   */
  public double getQuadAt(int index) {
    int off = index * 8;
    double val = getByteBuffer().getDouble((416)+off);
    return val;
  }
  /** Sets the unknown.
      @param val The unknown (must be an array of size L_QUADWORDS).
   */
  public void setQuad(double[] val) {
    if (val.length != L_QUADWORDS) {
      throw new IllegalArgumentException("setQuad: expected array of"
        + "length L_QUADWORDS, given array of length "+val.length+".");
    }
    for (int i = 0; i < val.length; i++) {
      int off = i * 8;
      getByteBuffer().putDouble((416)+off, val[i]);
    }
  }
  /** Sets the unknown at the specified index.
      @param val The unknown at the specified index.
   */
  public void setQuadAt(int index, double val) {
    if (index >= L_QUADWORDS) {
      throw new IllegalArgumentException("setQuad: index ["+index+"] is out of range ["+L_QUADWORDS+"]");
    }
    int off = index * 8;
    getByteBuffer().putDouble((416)+off, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public String getInternals() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 1024; i++) {
      char letter = (char)getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public void setInternals(String val) {
    for (int i = 0; i < 1024; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+i, (byte)' ');
      }
    }
  }

  /** Gets the file name to/from M$ALLOCATE.
      @return The file name to/from M$ALLOCATE.
   */
  public String getFileName() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 80; i++) {
      char letter = (char)getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the file name to/from M$ALLOCATE.
      @param val The file name to/from M$ALLOCATE.
   */
  public void setFileName(String val) {
    for (int i = 0; i < 80; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+i, (byte)letter);
        }
      } else {
        getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+i, (byte)' ');
      }
    }
  }

  /** Gets the file name for &#46;DET file.
      @return The file name for &#46;DET file.
   */
  public String getDetachName() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 80; i++) {
      char letter = (char)getByteBuffer().get(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+80)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the file name for &#46;DET file.
      @param val The file name for &#46;DET file.
   */
  public void setDetachName(String val) {
    for (int i = 0; i < 80; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+80)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+80)+i, (byte)' ');
      }
    }
  }

  /** Gets the string of allowable type codes.
      @return The string of allowable type codes.
   */
  public String getTypeAllow() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 40; i++) {
      char letter = (char)getByteBuffer().get(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+160)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the string of allowable type codes.
      @param val The string of allowable type codes.
   */
  public void setTypeAllow(String val) {
    for (int i = 0; i < 40; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+160)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+160)+i, (byte)' ');
      }
    }
  }

  /** Gets the string of allow format codes.
      @return The string of allow format codes.
   */
  public String getFormatAllow() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 40; i++) {
      char letter = (char)getByteBuffer().get(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+200)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the string of allow format codes.
      @param val The string of allow format codes.
   */
  public void setFormatAllow(String val) {
    for (int i = 0; i < 40; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+200)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+200)+i, (byte)' ');
      }
    }
  }

  /** Gets the qualifier string.
      @return The qualifier string.
   */
  public String getQualifier() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 120; i++) {
      char letter = (char)getByteBuffer().get(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+240)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the qualifier string.
      @param val The qualifier string.
   */
  public void setQualifier(String val) {
    for (int i = 0; i < 120; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+240)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+240)+i, (byte)' ');
      }
    }
  }

  /** Gets the filename result label.
      @return The filename result label.
   */
  public String getLabel() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 20; i++) {
      char letter = (char)getByteBuffer().get(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+360)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the filename result label.
      @param val The filename result label.
   */
  public void setLabel(String val) {
    for (int i = 0; i < 20; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+360)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+360)+i, (byte)' ');
      }
    }
  }

  /** Gets the file record type.
      @return The file record type.
   */
  public String getRtype() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 12; i++) {
      char letter = (char)getByteBuffer().get(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+380)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the file record type.
      @param val The file record type.
   */
  public void setRtype(String val) {
    for (int i = 0; i < 12; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+380)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+380)+i, (byte)' ');
      }
    }
  }

  /** Gets the switch string.
      @return The switch string.
   */
  public String getSwitch() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 8; i++) {
      char letter = (char)getByteBuffer().get(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+392)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the switch string.
      @param val The switch string.
   */
  public void setSwitch(String val) {
    for (int i = 0; i < 8; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+392)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+392)+i, (byte)' ');
      }
    }
  }

  /** Gets the filename extension field.
      @return The filename extension field.
   */
  public String getExtension() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 4; i++) {
      char letter = (char)getByteBuffer().get(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+400)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the filename extension field.
      @param val The filename extension field.
   */
  public void setExtension(String val) {
    for (int i = 0; i < 4; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+400)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+400)+i, (byte)' ');
      }
    }
  }

  /** Gets the qualifier string length.
      @return The qualifier string length.
   */
  public int getQualifierlen() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+404);
  }

  /** Sets the qualifier string length.
      @param val The qualifier string length.
   */
  public void setQualifierlen(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+404, val);
  }

  /** Gets the file logical unit.
      @return The file logical unit.
   */
  public int getFileLu() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+408);
  }

  /** Sets the file logical unit.
      @param val The file logical unit.
   */
  public void setFileLu(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+408, val);
  }

  /** Gets the file logical unit.
      @return The file logical unit.
   */
  public int getHeadLu() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+412);
  }

  /** Sets the file logical unit.
      @param val The file logical unit.
   */
  public void setHeadLu(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+412, val);
  }

  /** Gets the file existence flag.
      @return The file existence flag.
   */
  public boolean getExist() {
    return (getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+416) != 0);
  }

  /** Sets the file existence flag.
      @param val The file existence flag.
   */
  public void setExist(boolean val) {
    int num = (val)? 1: 0;
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+416, (int)num);
  }

  /** Gets the file open flag.
      @return The file open flag.
   */
  public boolean getOpen() {
    return (getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+420) != 0);
  }

  /** Sets the file open flag.
      @param val The file open flag.
   */
  public void setOpen(boolean val) {
    int num = (val)? 1: 0;
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+420, (int)num);
  }

  /** Gets the open for output/input.
      @return The open for output/input.
   */
  public boolean getOutput() {
    return (getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+424) != 0);
  }

  /** Sets the open for output/input.
      @param val The open for output/input.
   */
  public void setOutput(boolean val) {
    int num = (val)? 1: 0;
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+424, (int)num);
  }

  /** Gets the type code class (type/1000).
      @return The type code class (type/1000).
   */
  public int getTypeClass() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+428);
  }

  /** Sets the type code class (type/1000).
      @param val The type code class (type/1000).
   */
  public void setTypeClass(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+428, val);
  }

  /** Gets the DP bytes per element.
      @return The DP bytes per element.
   */
  public double getDbpe() {
    return getByteBuffer().getDouble((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+432);
  }

  /** Sets the DP bytes per element.
      @param val The DP bytes per element.
   */
  public void setDbpe(double val) {
    getByteBuffer().putDouble((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+432, val);
  }

  /** Gets the file size in log elements.
      @return The file size in log elements.
   */
  public double getSize() {
    return getByteBuffer().getDouble((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+440);
  }

  /** Sets the file size in log elements.
      @param val The file size in log elements.
   */
  public void setSize(double val) {
    getByteBuffer().putDouble((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+440, val);
  }

  /** Gets the file read offset in log elem.
      @return The file read offset in log elem.
   */
  public double getOffset() {
    return getByteBuffer().getDouble((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+448);
  }

  /** Sets the file read offset in log elem.
      @param val The file read offset in log elem.
   */
  public void setOffset(double val) {
    getByteBuffer().putDouble((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+448, val);
  }

  /** Gets the byte offset of saved.
      @return The byte offset of saved.
   */
  public double getSaveOffset() {
    return getByteBuffer().getDouble((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+456);
  }

  /** Sets the byte offset of saved.
      @param val The byte offset of saved.
   */
  public void setSaveOffset(double val) {
    getByteBuffer().putDouble((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+456, val);
  }

  /** Gets the data read first byte.
      @return The data read first byte.
   */
  public double getFirstByte() {
    return getByteBuffer().getDouble((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+464);
  }

  /** Sets the data read first byte.
      @param val The data read first byte.
   */
  public void setFirstByte(double val) {
    getByteBuffer().putDouble((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+464, val);
  }

  /** Gets the data write last byte.
      @return The data write last byte.
   */
  public double getLastByte() {
    return getByteBuffer().getDouble((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+472);
  }

  /** Sets the data write last byte.
      @param val The data write last byte.
   */
  public void setLastByte(double val) {
    getByteBuffer().putDouble((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+472, val);
  }

  /** Gets the bytes per scalar.
      @return The bytes per scalar.
   */
  public int getBps() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+480);
  }

  /** Sets the bytes per scalar.
      @param val The bytes per scalar.
   */
  public void setBps(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+480, val);
  }

  /** Gets the scalars per atom.
      @return The scalars per atom.
   */
  public int getSpa() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+484);
  }

  /** Sets the scalars per atom.
      @param val The scalars per atom.
   */
  public void setSpa(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+484, val);
  }

  /** Gets the bytes per atom.
      @return The bytes per atom.
   */
  public int getBpa() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+488);
  }

  /** Sets the bytes per atom.
      @param val The bytes per atom.
   */
  public void setBpa(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+488, val);
  }

  /** Gets the bytes per element.
      @return The bytes per element.
   */
  public int getBpe() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+492);
  }

  /** Sets the bytes per element.
      @param val The bytes per element.
   */
  public void setBpe(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+492, val);
  }

  /** Gets the atoms per element.
      @return The atoms per element.
   */
  public int getApe() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+496);
  }

  /** Sets the atoms per element.
      @param val The atoms per element.
   */
  public void setApe(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+496, val);
  }

  /** Gets the # elements in saved.
      @return The # elements in saved.
   */
  public int getSaveSize() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+500);
  }

  /** Sets the # elements in saved.
      @param val The # elements in saved.
   */
  public void setSaveSize(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+500, val);
  }

  /** Gets the save buffer location (GRABX).
      @return The save buffer location (GRABX).
   */
  public int getSavebufLoc() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+504);
  }

  /** Sets the save buffer location (GRABX).
      @param val The save buffer location (GRABX).
   */
  public void setSavebufLoc(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+504, val);
  }

  /** Gets the save buffer size in bytes.
      @return The save buffer size in bytes.
   */
  public int getSavebufLen() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+508);
  }

  /** Sets the save buffer size in bytes.
      @param val The save buffer size in bytes.
   */
  public void setSavebufLen(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+508, val);
  }

  /** Gets the transfer length.
      @return The transfer length.
   */
  public int getXferLen() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+512);
  }

  /** Sets the transfer length.
      @param val The transfer length.
   */
  public void setXferLen(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+512, val);
  }

  /** Gets the consume length.
      @return The consume length.
   */
  public int getConsLen() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+516);
  }

  /** Sets the consume length.
      @param val The consume length.
   */
  public void setConsLen(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+516, val);
  }

  /** Gets the scratch format.
      @return The scratch format.
   */
  public String getScrFormat() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < 2; i++) {
      char letter = (char)getByteBuffer().get(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+520)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the scratch format.
      @param val The scratch format.
   */
  public void setScrFormat(String val) {
    for (int i = 0; i < 2; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+520)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+520)+i, (byte)' ');
      }
    }
  }

  /** Gets the buffer format mode.
      @return The buffer format mode.
   */
  public char getBufMode() {
    return (char)getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+522);
  }

  /** Sets the buffer format mode.
      @param val The buffer format mode.
   */
  public void setBufMode(char val) {
    if (val > 0x7f) {
      throw new IllegalArgumentException("Expected ASCII character given '"+val+"'.");
    }
    getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+522, (byte)val);
  }

  /** Gets the buffer format type.
      @return The buffer format type.
   */
  public char getBufType() {
    return (char)getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+523);
  }

  /** Sets the buffer format type.
      @param val The buffer format type.
   */
  public void setBufType(char val) {
    if (val > 0x7f) {
      throw new IllegalArgumentException("Expected ASCII character given '"+val+"'.");
    }
    getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+523, (byte)val);
  }

  /** Gets the open for read only ?.
      @return The open for read only ?.
   */
  public boolean getReadonly() {
    return (getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+524) != 0);
  }

  /** Sets the open for read only ?.
      @param val The open for read only ?.
   */
  public void setReadonly(boolean val) {
    int num = (val)? 1: 0;
    getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+524, (byte)num);
  }

  /** Gets the open for over write ?.
      @return The open for over write ?.
   */
  public boolean getOverwrite() {
    return (getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+525) != 0);
  }

  /** Sets the open for over write ?.
      @param val The open for over write ?.
   */
  public void setOverwrite(boolean val) {
    int num = (val)? 1: 0;
    getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+525, (byte)num);
  }

  /** Gets the open contiguous disk file ?.
      @return The open contiguous disk file ?.
   */
  public boolean getContiguous() {
    return (getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+526) != 0);
  }

  /** Sets the open contiguous disk file ?.
      @param val The open contiguous disk file ?.
   */
  public void setContiguous(boolean val) {
    int num = (val)? 1: 0;
    getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+526, (byte)num);
  }

  /** Gets the keep output flushed to disk ?.
      @return The keep output flushed to disk ?.
   */
  public boolean getFlush() {
    return (getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+527) != 0);
  }

  /** Sets the keep output flushed to disk ?.
      @param val The keep output flushed to disk ?.
   */
  public void setFlush(boolean val) {
    int num = (val)? 1: 0;
    getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+527, (byte)num);
  }

  /** Gets the pipe outlet number.
      @return The pipe outlet number.
   */
  public int getOutlet() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+528);
  }

  /** Sets the pipe outlet number.
      @param val The pipe outlet number.
   */
  public void setOutlet(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+528, val);
  }

  /** Gets the disk address of file data.
      @return The disk address of file data.
   */
  public int getDiskBlk() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+532);
  }

  /** Sets the disk address of file data.
      @param val The disk address of file data.
   */
  public void setDiskBlk(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+532, val);
  }

  /** Gets the disk address of file header.
      @return The disk address of file header.
   */
  public int getDiskBlkHdr() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+536);
  }

  /** Sets the disk address of file header.
      @param val The disk address of file header.
   */
  public void setDiskBlkHdr(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+536, val);
  }

  /** Gets the disk allocation of data.
      @return The disk allocation of data.
   */
  public int getDiskBlkAlloc() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+540);
  }

  /** Sets the disk allocation of data.
      @param val The disk allocation of data.
   */
  public void setDiskBlkAlloc(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+540, val);
  }

  /** Gets the disk addr data in bytes.
      @return The disk addr data in bytes.
   */
  public int getDiskAddress() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+544);
  }

  /** Sets the disk addr data in bytes.
      @param val The disk addr data in bytes.
   */
  public void setDiskAddress(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+544, val);
  }

  /** Gets the ext header mem location.
      @return The ext header mem location.
   */
  public int getExtLoc() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+548);
  }

  /** Sets the ext header mem location.
      @param val The ext header mem location.
   */
  public void setExtLoc(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+548, val);
  }

  /** Gets the ext header mem allocated.
      @return The ext header mem allocated.
   */
  public int getExtAlloc() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+552);
  }

  /** Sets the ext header mem allocated.
      @param val The ext header mem allocated.
   */
  public void setExtAlloc(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+552, val);
  }

  /** Gets the ext header scope start.
      @return The ext header scope start.
   */
  public int getExtScopeStart() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+556);
  }

  /** Sets the ext header scope start.
      @param val The ext header scope start.
   */
  public void setExtScopeStart(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+556, val);
  }

  /** Gets the ext header scope end.
      @return The ext header scope end.
   */
  public int getExtScopeEnd() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+560);
  }

  /** Sets the ext header scope end.
      @param val The ext header scope end.
   */
  public void setExtScopeEnd(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+560, val);
  }

  /** Gets the ext next.
      @return The ext next.
   */
  public int getExtNext() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+564);
  }

  /** Sets the ext next.
      @param val The ext next.
   */
  public void setExtNext(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+564, val);
  }

  /** Gets the bits in save_bits byte.
      @return The bits in save_bits byte.
   */
  public short getLastBits() {
    return getByteBuffer().getShort((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+568);
  }

  /** Sets the bits in save_bits byte.
      @param val The bits in save_bits byte.
   */
  public void setLastBits(short val) {
    getByteBuffer().putShort((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+568, val);
  }

  /** Gets the holds packed offset byte.
      @return The holds packed offset byte.
   */
  public byte getSaveBits() {
    return getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+570);
  }

  /** Sets the holds packed offset byte.
      @param val The holds packed offset byte.
   */
  public void setSaveBits(byte val) {
    getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+570, val);
  }

  /** Gets the aux disk.
      @return The aux disk.
   */
  public byte getAux() {
    return getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+571);
  }

  /** Sets the aux disk.
      @param val The aux disk.
   */
  public void setAux(byte val) {
    getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+571, val);
  }

  /** Gets the location of pipe header.
      @return The location of pipe header.
   */
  public int getLph() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+572);
  }

  /** Sets the location of pipe header.
      @param val The location of pipe header.
   */
  public void setLph(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+572, val);
  }

  /** Gets the DS disk block size.
      @return The DS disk block size.
   */
  public int getBlk() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+576);
  }

  /** Sets the DS disk block size.
      @param val The DS disk block size.
   */
  public void setBlk(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+576, val);
  }

  /** Gets the DS status flag.
      @return The DS status flag.
   */
  public int getStatus() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+580);
  }

  /** Sets the DS status flag.
      @param val The DS status flag.
   */
  public void setStatus(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+580, val);
  }

  /** Gets the DS IO mode.
      @return The DS IO mode.
   */
  public byte getMode() {
    return getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+584);
  }

  /** Sets the DS IO mode.
      @param val The DS IO mode.
   */
  public void setMode(byte val) {
    getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+584, val);
  }

  /** Gets the DS engine #.
      @return The DS engine #.
   */
  public byte getEngine() {
    return getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+585);
  }

  /** Sets the DS engine #.
      @param val The DS engine #.
   */
  public void setEngine(byte val) {
    getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+585, val);
  }

  /** Gets the DS active.
      @return The DS active.
   */
  public byte getActive() {
    return getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+586);
  }

  /** Sets the DS active.
      @param val The DS active.
   */
  public void setActive(byte val) {
    getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+586, val);
  }

  /** Gets the DS filler.
      @return The DS filler.
   */
  public byte getDsfill() {
    return getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+587);
  }

  /** Sets the DS filler.
      @param val The DS filler.
   */
  public void setDsfill(byte val) {
    getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+587, val);
  }

  /** Gets the T6 subrecords mem location.
      @return The T6 subrecords mem location.
   */
  public int getT6subrLoc() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+588);
  }

  /** Sets the T6 subrecords mem location.
      @param val The T6 subrecords mem location.
   */
  public void setT6subrLoc(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+588, val);
  }

  /** Gets the T6 subrecords mem allocated.
      @return The T6 subrecords mem allocated.
   */
  public int getT6subrAlloc() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+592);
  }

  /** Sets the T6 subrecords mem allocated.
      @param val The T6 subrecords mem allocated.
   */
  public void setT6subrAlloc(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+592, val);
  }

  /** Gets the force 8 byte alignment.
      @return The force 8 byte alignment.
   */
  public int getFiller() {
    return getByteBuffer().getInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+596);
  }

  /** Sets the force 8 byte alignment.
      @param val The force 8 byte alignment.
   */
  public void setFiller(int val) {
    getByteBuffer().putInt((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+596, val);
  }

  /** Gets the size = 8 bytes.
      @return The size = 8 bytes.
   */
  public PkthdStruct getPkthd() {
    return new PkthdStruct(getByteBuffer(), (Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+600);
  }

  /** Gets the size = L_pkt_struct_size.
      @return The size = L_pkt_struct_size.
   */
  public PktStruct getPkt() {
    return new PktStruct(getByteBuffer(), (Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+608);
  }

  /** Gets the block # of data in header buf.
      @return The block # of data in header buf.
   */
  public long getBufferBlock() {
    return getByteBuffer().getLong((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+(8*L_MAX_PKT_REG)+728);
  }

  /** Sets the block # of data in header buf.
      @param val The block # of data in header buf.
   */
  public void setBufferBlock(long val) {
    getByteBuffer().putLong((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+(8*L_MAX_PKT_REG)+728, val);
  }

  /** gets the fill internal header to 1024.
      @return The fill internal header to 1024 (an array of size 32).
   */
  public byte[] getIhdrfill() {
    byte[] val = new byte[32];
    for (int i = 0; i < val.length; i++) {
      int off = i * 1;
      val[i] = getByteBuffer().get(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+(8*L_MAX_PKT_REG)+736)+off);
    }
    return val;
  }
  /** Gets the fill internal header to 1024 at the specified index.
      @return The fill internal header to 1024 at the specified index.
   */
  public byte getIhdrfillAt(int index) {
    int off = index * 1;
    byte val = getByteBuffer().get(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+(8*L_MAX_PKT_REG)+736)+off);
    return val;
  }
  /** Sets the fill internal header to 1024.
      @param val The fill internal header to 1024 (must be an array of size 32).
   */
  public void setIhdrfill(byte[] val) {
    if (val.length != 32) {
      throw new IllegalArgumentException("setIhdrfill: expected array of"
        + "length 32, given array of length "+val.length+".");
    }
    for (int i = 0; i < val.length; i++) {
      int off = i * 1;
      getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+(8*L_MAX_PKT_REG)+736)+off, val[i]);
    }
  }
  /** Sets the fill internal header to 1024 at the specified index.
      @param val The fill internal header to 1024 at the specified index.
   */
  public void setIhdrfillAt(int index, byte val) {
    if (index >= 32) {
      throw new IllegalArgumentException("setIhdrfill: index ["+index+"] is out of range ["+32+"]");
    }
    int off = index * 1;
    getByteBuffer().put(((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+(8*L_MAX_PKT_REG)+736)+off, val);
  }

  /** gets the primitive data buffer.
      @return The primitive data buffer (an array of size 512).
   */
  public byte[] getBuffer() {
    byte[] val = new byte[512];
    for (int i = 0; i < val.length; i++) {
      int off = i * 1;
      val[i] = getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416)), ((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+1024)), ((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+(8*L_MAX_PKT_REG)+768))))+off);
    }
    return val;
  }
  /** Gets the primitive data buffer at the specified index.
      @return The primitive data buffer at the specified index.
   */
  public byte getBufferAt(int index) {
    int off = index * 1;
    byte val = getByteBuffer().get((Math.max(512, Math.max(Math.max(Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416)), ((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+1024)), ((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+(8*L_MAX_PKT_REG)+768))))+off);
    return val;
  }
  /** Sets the primitive data buffer.
      @param val The primitive data buffer (must be an array of size 512).
   */
  public void setBuffer(byte[] val) {
    if (val.length != 512) {
      throw new IllegalArgumentException("setBuffer: expected array of"
        + "length 512, given array of length "+val.length+".");
    }
    for (int i = 0; i < val.length; i++) {
      int off = i * 1;
      getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416)), ((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+1024)), ((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+(8*L_MAX_PKT_REG)+768))))+off, val[i]);
    }
  }
  /** Sets the primitive data buffer at the specified index.
      @param val The primitive data buffer at the specified index.
   */
  public void setBufferAt(int index, byte val) {
    if (index >= 512) {
      throw new IllegalArgumentException("setBuffer: index ["+index+"] is out of range ["+512+"]");
    }
    int off = index * 1;
    getByteBuffer().put((Math.max(512, Math.max(Math.max(Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416)), ((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+1024)), ((Math.max(512, Math.max(Math.max(Math.max(((8*L_OUTLETS)+L_KEYWORDS+100), ((8*L_SUBRECORDS)+304)), ((8*L_COMPONENTS)+(8*L_QUADWORDS)+304)), ((8*L_QUADWORDS)+416))))+(8*L_MAX_PKT_REG)+768))))+off, val);
  }

  /** Dumps the data in the buffer to a String. This method is for
      debugging purposes only its syntax may change in the future
      without notice.
      
      @return A string listing the current data in the buffer.
   */
  public String dumpData() {
    StringBuilder sb = new StringBuilder();
    sb.append("getMain              = ").append(getMain()             ).append('\n');
    sb.append("getVersion           = ").append(getVersion()          ).append('\n');
    sb.append("getHeadRep           = ").append(getHeadRep()          ).append('\n');
    sb.append("getDataRep           = ").append(getDataRep()          ).append('\n');
    sb.append("getDetached          = ").append(getDetached()         ).append('\n');
    sb.append("getProtected         = ").append(getProtected()        ).append('\n');
    sb.append("getPipe              = ").append(getPipe()             ).append('\n');
    sb.append("getExtStart          = ").append(getExtStart()         ).append('\n');
    sb.append("getExtSize           = ").append(getExtSize()          ).append('\n');
    sb.append("getDataStart         = ").append(getDataStart()        ).append('\n');
    sb.append("getDataSize          = ").append(getDataSize()         ).append('\n');
    sb.append("getType              = ").append(getType()             ).append('\n');
    sb.append("getFormat            = ").append(getFormat()           ).append('\n');
    sb.append("getFlagmask          = ").append(getFlagmask()         ).append('\n');
    sb.append("getTimecode          = ").append(getTimecode()         ).append('\n');
    sb.append("getInlet             = ").append(getInlet()            ).append('\n');
    sb.append("getOutlets           = ").append(getOutlets()          ).append('\n');
    sb.append("getOutmask           = ").append(getOutmask()          ).append('\n');
    sb.append("getPipeloc           = ").append(getPipeloc()          ).append('\n');
    sb.append("getPipesize          = ").append(getPipesize()         ).append('\n');
    sb.append("getInByte            = ").append(getInByte()           ).append('\n');
    sb.append("getOutByte           = ").append(getOutByte()          ).append('\n');
    sb.append("getOutBytes          = ").append(getOutBytes()         ).append('\n');
    sb.append("getKeylength         = ").append(getKeylength()        ).append('\n');
    sb.append("getKeywords          = ").append(getKeywords()         ).append('\n');
    sb.append("getFill1             = ").append(getFill1()            ).append('\n');
    sb.append("getXstart            = ").append(getXstart()           ).append('\n');
    sb.append("getXdelta            = ").append(getXdelta()           ).append('\n');
    sb.append("getXunits            = ").append(getXunits()           ).append('\n');
    sb.append("getSubsize           = ").append(getSubsize()          ).append('\n');
    sb.append("getYstart            = ").append(getYstart()           ).append('\n');
    sb.append("getYdelta            = ").append(getYdelta()           ).append('\n');
    sb.append("getYunits            = ").append(getYunits()           ).append('\n');
    sb.append("getBid               = ").append(getBid()              ).append('\n');
    sb.append("getFill2             = ").append(getFill2()            ).append('\n');
    sb.append("getRstart            = ").append(getRstart()           ).append('\n');
    sb.append("getRdelta            = ").append(getRdelta()           ).append('\n');
    sb.append("getRunits            = ").append(getRunits()           ).append('\n');
    sb.append("getSubrecords        = ").append(getSubrecords()       ).append('\n');
    sb.append("getR2start           = ").append(getR2start()          ).append('\n');
    sb.append("getR2delta           = ").append(getR2delta()          ).append('\n');
    sb.append("getR2units           = ").append(getR2units()          ).append('\n');
    sb.append("getRecordLength      = ").append(getRecordLength()     ).append('\n');
    sb.append("getSubr              = ").append(getSubr()             ).append('\n');
    sb.append("getFill3             = ").append(getFill3()            ).append('\n');
    sb.append("getVrstart           = ").append(getVrstart()          ).append('\n');
    sb.append("getVrdelta           = ").append(getVrdelta()          ).append('\n');
    sb.append("getVrunits           = ").append(getVrunits()          ).append('\n');
    sb.append("getNrecords          = ").append(getNrecords()         ).append('\n');
    sb.append("getVr2start          = ").append(getVr2start()         ).append('\n');
    sb.append("getVr2delta          = ").append(getVr2delta()         ).append('\n');
    sb.append("getVr2units          = ").append(getVr2units()         ).append('\n');
    sb.append("getVrecordLength     = ").append(getVrecordLength()    ).append('\n');
    sb.append("getFill4             = ").append(getFill4()            ).append('\n');
    sb.append("getTstart            = ").append(getTstart()           ).append('\n');
    sb.append("getTdelta            = ").append(getTdelta()           ).append('\n');
    sb.append("getTunits            = ").append(getTunits()           ).append('\n');
    sb.append("getComponents        = ").append(getComponents()       ).append('\n');
    sb.append("getT2start           = ").append(getT2start()          ).append('\n');
    sb.append("getT2delta           = ").append(getT2delta()          ).append('\n');
    sb.append("getT2units           = ").append(getT2units()          ).append('\n');
    sb.append("getRecordLen         = ").append(getRecordLen()        ).append('\n');
    sb.append("getComp              = ").append(getComp()             ).append('\n');
    sb.append("getQuadwords         = ").append(getQuadwords()        ).append('\n');
    sb.append("getFill5             = ").append(getFill5()            ).append('\n');
    sb.append("getFrameOfRef        = ").append(getFrameOfRef()       ).append('\n');
    sb.append("getAltitude          = ").append(getAltitude()         ).append('\n');
    sb.append("getLatitude          = ").append(getLatitude()         ).append('\n');
    sb.append("getLongitude         = ").append(getLongitude()        ).append('\n');
    sb.append("getAzimuth           = ").append(getAzimuth()          ).append('\n');
    sb.append("getElevation         = ").append(getElevation()        ).append('\n');
    sb.append("getRoll              = ").append(getRoll()             ).append('\n');
    sb.append("getNotused1          = ").append(getNotused1()         ).append('\n');
    sb.append("getNotused2          = ").append(getNotused2()         ).append('\n');
    sb.append("getEpochYear         = ").append(getEpochYear()        ).append('\n');
    sb.append("getEpochSeconds      = ").append(getEpochSeconds()     ).append('\n');
    sb.append("getHourAngle         = ").append(getHourAngle()        ).append('\n');
    sb.append("getFill6             = ").append(getFill6()            ).append('\n');
    sb.append("getQuads             = ").append(getQuads()            ).append('\n');
    sb.append("getFill7             = ").append(getFill7()            ).append('\n');
    sb.append("getQuad              = ").append(getQuad()             ).append('\n');
    sb.append("getInternals         = ").append(getInternals()        ).append('\n');
    sb.append("getFileName          = ").append(getFileName()         ).append('\n');
    sb.append("getDetachName        = ").append(getDetachName()       ).append('\n');
    sb.append("getTypeAllow         = ").append(getTypeAllow()        ).append('\n');
    sb.append("getFormatAllow       = ").append(getFormatAllow()      ).append('\n');
    sb.append("getQualifier         = ").append(getQualifier()        ).append('\n');
    sb.append("getLabel             = ").append(getLabel()            ).append('\n');
    sb.append("getRtype             = ").append(getRtype()            ).append('\n');
    sb.append("getSwitch            = ").append(getSwitch()           ).append('\n');
    sb.append("getExtension         = ").append(getExtension()        ).append('\n');
    sb.append("getQualifierlen      = ").append(getQualifierlen()     ).append('\n');
    sb.append("getFileLu            = ").append(getFileLu()           ).append('\n');
    sb.append("getHeadLu            = ").append(getHeadLu()           ).append('\n');
    sb.append("getExist             = ").append(getExist()            ).append('\n');
    sb.append("getOpen              = ").append(getOpen()             ).append('\n');
    sb.append("getOutput            = ").append(getOutput()           ).append('\n');
    sb.append("getTypeClass         = ").append(getTypeClass()        ).append('\n');
    sb.append("getDbpe              = ").append(getDbpe()             ).append('\n');
    sb.append("getSize              = ").append(getSize()             ).append('\n');
    sb.append("getOffset            = ").append(getOffset()           ).append('\n');
    sb.append("getSaveOffset        = ").append(getSaveOffset()       ).append('\n');
    sb.append("getFirstByte         = ").append(getFirstByte()        ).append('\n');
    sb.append("getLastByte          = ").append(getLastByte()         ).append('\n');
    sb.append("getBps               = ").append(getBps()              ).append('\n');
    sb.append("getSpa               = ").append(getSpa()              ).append('\n');
    sb.append("getBpa               = ").append(getBpa()              ).append('\n');
    sb.append("getBpe               = ").append(getBpe()              ).append('\n');
    sb.append("getApe               = ").append(getApe()              ).append('\n');
    sb.append("getSaveSize          = ").append(getSaveSize()         ).append('\n');
    sb.append("getSavebufLoc        = ").append(getSavebufLoc()       ).append('\n');
    sb.append("getSavebufLen        = ").append(getSavebufLen()       ).append('\n');
    sb.append("getXferLen           = ").append(getXferLen()          ).append('\n');
    sb.append("getConsLen           = ").append(getConsLen()          ).append('\n');
    sb.append("getScrFormat         = ").append(getScrFormat()        ).append('\n');
    sb.append("getBufMode           = ").append(getBufMode()          ).append('\n');
    sb.append("getBufType           = ").append(getBufType()          ).append('\n');
    sb.append("getReadonly          = ").append(getReadonly()         ).append('\n');
    sb.append("getOverwrite         = ").append(getOverwrite()        ).append('\n');
    sb.append("getContiguous        = ").append(getContiguous()       ).append('\n');
    sb.append("getFlush             = ").append(getFlush()            ).append('\n');
    sb.append("getOutlet            = ").append(getOutlet()           ).append('\n');
    sb.append("getDiskBlk           = ").append(getDiskBlk()          ).append('\n');
    sb.append("getDiskBlkHdr        = ").append(getDiskBlkHdr()       ).append('\n');
    sb.append("getDiskBlkAlloc      = ").append(getDiskBlkAlloc()     ).append('\n');
    sb.append("getDiskAddress       = ").append(getDiskAddress()      ).append('\n');
    sb.append("getExtLoc            = ").append(getExtLoc()           ).append('\n');
    sb.append("getExtAlloc          = ").append(getExtAlloc()         ).append('\n');
    sb.append("getExtScopeStart     = ").append(getExtScopeStart()    ).append('\n');
    sb.append("getExtScopeEnd       = ").append(getExtScopeEnd()      ).append('\n');
    sb.append("getExtNext           = ").append(getExtNext()          ).append('\n');
    sb.append("getLastBits          = ").append(getLastBits()         ).append('\n');
    sb.append("getSaveBits          = ").append(getSaveBits()         ).append('\n');
    sb.append("getAux               = ").append(getAux()              ).append('\n');
    sb.append("getLph               = ").append(getLph()              ).append('\n');
    sb.append("getBlk               = ").append(getBlk()              ).append('\n');
    sb.append("getStatus            = ").append(getStatus()           ).append('\n');
    sb.append("getMode              = ").append(getMode()             ).append('\n');
    sb.append("getEngine            = ").append(getEngine()           ).append('\n');
    sb.append("getActive            = ").append(getActive()           ).append('\n');
    sb.append("getDsfill            = ").append(getDsfill()           ).append('\n');
    sb.append("getT6subrLoc         = ").append(getT6subrLoc()        ).append('\n');
    sb.append("getT6subrAlloc       = ").append(getT6subrAlloc()      ).append('\n');
    sb.append("getFiller            = ").append(getFiller()           ).append('\n');
    sb.append("getPkthd             = ").append(getPkthd()            ).append('\n');
    sb.append("getPkt               = ").append(getPkt()              ).append('\n');
    sb.append("getBufferBlock       = ").append(getBufferBlock()      ).append('\n');
    sb.append("getIhdrfill          = ").append(getIhdrfill()         ).append('\n');
    sb.append("getBuffer            = ").append(getBuffer()           ).append('\n');
    return sb.toString();
  }
  /** Defines the HPtr structure. */
  public static class HPtr {
    /** The byte buffer. */
    private final ByteBuffer byteBuffer;
    
    /** The offset index. */
    private final int offset;
    
    /** Creates a new instance.
        @param byteBuffer The byte buffer.
        @param offset     The offset index.
     */
    private HPtr(ByteBuffer byteBuffer, int offset) {
      this.byteBuffer = byteBuffer;
      this.offset     = offset;
    }
    /** Gets the byte buffer.
        @return The byte buffer.
     */
    private ByteBuffer getByteBuffer() {
      return byteBuffer;
    }

    /** Gets the unknown.
        @return The unknown.
     */
    public int getP() {
      return getByteBuffer().getInt((this.offset + (0)));
    }
  
    /** Sets the unknown.
        @param val The unknown.
     */
    public void setP(int val) {
      getByteBuffer().putInt((this.offset + (0)), val);
    }
  
    /** Gets the unknown.
        @return The unknown.
     */
    public int getFill() {
      return getByteBuffer().getInt((this.offset + (4)));
    }
  
    /** Sets the unknown.
        @param val The unknown.
     */
    public void setFill(int val) {
      getByteBuffer().putInt((this.offset + (4)), val);
    }
  
    /** Summarizes the record.
        @return A string listing the current data in the record.
     */
    public String toString() {
      StringBuilder sb = new StringBuilder();
      sb.append("HPtr: {");
      sb.append(" getP = ").append(getP());  
      sb.append(" getFill = ").append(getFill());  
      sb.append(" }");
      return sb.toString();
    }
  }

  /** Defines the PkthdStruct structure. */
  public static class PkthdStruct {
    /** The byte buffer. */
    private final ByteBuffer byteBuffer;
    
    /** The offset index. */
    private final int offset;
    
    /** Creates a new instance.
        @param byteBuffer The byte buffer.
        @param offset     The offset index.
     */
    private PkthdStruct(ByteBuffer byteBuffer, int offset) {
      this.byteBuffer = byteBuffer;
      this.offset     = offset;
    }
    /** Gets the byte buffer.
        @return The byte buffer.
     */
    private ByteBuffer getByteBuffer() {
      return byteBuffer;
    }

    /** Gets the Packet category.
        @return The Packet category.
     */
    public int getCateg() {
      return getByteBuffer().getInt((this.offset + (0)));
    }
  
    /** Sets the Packet category.
        @param val The Packet category.
     */
    public void setCateg(int val) {
      getByteBuffer().putInt((this.offset + (0)), val);
    }
  
    /** Gets the Packet length.
        @return The Packet length.
     */
    public int getLen() {
      return getByteBuffer().getInt((this.offset + (4)));
    }
  
    /** Sets the Packet length.
        @param val The Packet length.
     */
    public void setLen(int val) {
      getByteBuffer().putInt((this.offset + (4)), val);
    }
  
    /** Summarizes the record.
        @return A string listing the current data in the record.
     */
    public String toString() {
      StringBuilder sb = new StringBuilder();
      sb.append("PkthdStruct: {");
      sb.append(" getCateg = ").append(getCateg());  
      sb.append(" getLen = ").append(getLen());  
      sb.append(" }");
      return sb.toString();
    }
  }

  /** Defines the PktStruct structure. */
  public static class PktStruct {
    /** The byte buffer. */
    private final ByteBuffer byteBuffer;
    
    /** The offset index. */
    private final int offset;
    
    /** Creates a new instance.
        @param byteBuffer The byte buffer.
        @param offset     The offset index.
     */
    private PktStruct(ByteBuffer byteBuffer, int offset) {
      this.byteBuffer = byteBuffer;
      this.offset     = offset;
    }
    /** Gets the byte buffer.
        @return The byte buffer.
     */
    private ByteBuffer getByteBuffer() {
      return byteBuffer;
    }

    /** Gets the Flag for packet data.
        @return The Flag for packet data.
     */
    public boolean getPacketized() {
      return (getByteBuffer().getInt((this.offset + (0))) != 0);
    }
  
    /** Sets the Flag for packet data.
        @param val The Flag for packet data.
     */
    public void setPacketized(boolean val) {
      int num = (val)? 1: 0;
      getByteBuffer().putInt((this.offset + (0)), (int)num);
    }
  
    /** Gets the Packet handling flags.
        @return The Packet handling flags.
     */
    public int getFlags() {
      return getByteBuffer().getInt((this.offset + (4)));
    }
  
    /** Sets the Packet handling flags.
        @param val The Packet handling flags.
     */
    public void setFlags(int val) {
      getByteBuffer().putInt((this.offset + (4)), val);
    }
  
    /** Gets the Pointer to packet buffer.
        @return The Pointer to packet buffer.
     */
    public HPtr getBufPtr() {
      return new HPtr(getByteBuffer(), (this.offset + (8)));
    }
  
    /** Gets the flag new to send.
        @return The flag new to send.
     */
    public boolean getSendNewPkt() {
      return (getByteBuffer().getInt((this.offset + (16))) != 0);
    }
  
    /** Sets the flag new to send.
        @param val The flag new to send.
     */
    public void setSendNewPkt(boolean val) {
      int num = (val)? 1: 0;
      getByteBuffer().putInt((this.offset + (16)), (int)num);
    }
  
    /** Gets the flag to look for new pkt.
        @return The flag to look for new pkt.
     */
    public boolean getGetNewPkt() {
      return (getByteBuffer().getInt((this.offset + (20))) != 0);
    }
  
    /** Sets the flag to look for new pkt.
        @param val The flag to look for new pkt.
     */
    public void setGetNewPkt(boolean val) {
      int num = (val)? 1: 0;
      getByteBuffer().putInt((this.offset + (20)), (int)num);
    }
  
    /** Gets the New meta-data pkt has arrived.
        @return The New meta-data pkt has arrived.
     */
    public boolean getRcvdNewPkt() {
      return (getByteBuffer().getInt((this.offset + (24))) != 0);
    }
  
    /** Sets the New meta-data pkt has arrived.
        @param val The New meta-data pkt has arrived.
     */
    public void setRcvdNewPkt(boolean val) {
      int num = (val)? 1: 0;
      getByteBuffer().putInt((this.offset + (24)), (int)num);
    }
  
    /** Gets the Elements remaining in data pkt.
        @return The Elements remaining in data pkt.
     */
    public int getElmRem() {
      return getByteBuffer().getInt((this.offset + (28)));
    }
  
    /** Sets the Elements remaining in data pkt.
        @param val The Elements remaining in data pkt.
     */
    public void setElmRem(int val) {
      getByteBuffer().putInt((this.offset + (28)), val);
    }
  
    /** Gets the bytes read/written of non-Midas data.
        @return The bytes read/written of non-Midas data.
     */
    public int getByteCount() {
      return getByteBuffer().getInt((this.offset + (32)));
    }
  
    /** Sets the bytes read/written of non-Midas data.
        @param val The bytes read/written of non-Midas data.
     */
    public void setByteCount(int val) {
      getByteBuffer().putInt((this.offset + (32)), val);
    }
  
    /** Gets the number of HOUTs registered.
        @return The number of HOUTs registered.
     */
    public int getRegCount() {
      return getByteBuffer().getInt((this.offset + (36)));
    }
  
    /** Sets the number of HOUTs registered.
        @param val The number of HOUTs registered.
     */
    public void setRegCount(int val) {
      getByteBuffer().putInt((this.offset + (36)), val);
    }
  
    /** Gets the Flag that HCB modified in last GRAB.
        @return The Flag that HCB modified in last GRAB.
     */
    public boolean getHcbmod() {
      return (getByteBuffer().getInt((this.offset + (40))) != 0);
    }
  
    /** Sets the Flag that HCB modified in last GRAB.
        @param val The Flag that HCB modified in last GRAB.
     */
    public void setHcbmod(boolean val) {
      int num = (val)? 1: 0;
      getByteBuffer().putInt((this.offset + (40)), (int)num);
    }
  
    /** Gets the HCB changed since start of file.
        @return The HCB changed since start of file.
     */
    public boolean getHcbchg() {
      return (getByteBuffer().getInt((this.offset + (44))) != 0);
    }
  
    /** Sets the HCB changed since start of file.
        @param val The HCB changed since start of file.
     */
    public void setHcbchg(boolean val) {
      int num = (val)? 1: 0;
      getByteBuffer().putInt((this.offset + (44)), (int)num);
    }
  
    /** Gets the Offset in to file in bytes.
        @return The Offset in to file in bytes.
     */
    public double getByteOffset() {
      return getByteBuffer().getDouble((this.offset + (48)));
    }
  
    /** Sets the Offset in to file in bytes.
        @param val The Offset in to file in bytes.
     */
    public void setByteOffset(double val) {
      getByteBuffer().putDouble((this.offset + (48)), val);
    }
  
    /** Gets the Save hcb&#46;offset.
        @return The Save hcb&#46;offset.
     */
    public double getHcbOffsetSave() {
      return getByteBuffer().getDouble((this.offset + (56)));
    }
  
    /** Sets the Save hcb&#46;offset.
        @param val The Save hcb&#46;offset.
     */
    public void setHcbOffsetSave(double val) {
      getByteBuffer().putDouble((this.offset + (56)), val);
    }
  
    /** Gets the Absolute Logical Element offset.
        @return The Absolute Logical Element offset.
     */
    public double getAbsElmOffset() {
      return getByteBuffer().getDouble((this.offset + (64)));
    }
  
    /** Sets the Absolute Logical Element offset.
        @param val The Absolute Logical Element offset.
     */
    public void setAbsElmOffset(double val) {
      getByteBuffer().putDouble((this.offset + (64)), val);
    }
  
    /** Gets the Abs&#46; Logical element to seek to.
        @return The Abs&#46; Logical element to seek to.
     */
    public double getAbsElmSeek() {
      return getByteBuffer().getDouble((this.offset + (72)));
    }
  
    /** Sets the Abs&#46; Logical element to seek to.
        @param val The Abs&#46; Logical element to seek to.
     */
    public void setAbsElmSeek(double val) {
      getByteBuffer().putDouble((this.offset + (72)), val);
    }
  
    /** Gets the First element in file.
        @return The First element in file.
     */
    public double getFirstElm() {
      return getByteBuffer().getDouble((this.offset + (80)));
    }
  
    /** Sets the First element in file.
        @param val The First element in file.
     */
    public void setFirstElm(double val) {
      getByteBuffer().putDouble((this.offset + (80)), val);
    }
  
    /** Gets the Last element in file.
        @return The Last element in file.
     */
    public double getLastElm() {
      return getByteBuffer().getDouble((this.offset + (88)));
    }
  
    /** Sets the Last element in file.
        @param val The Last element in file.
     */
    public void setLastElm(double val) {
      getByteBuffer().putDouble((this.offset + (88)), val);
    }
  
    /** Gets the Pointers to reg'd HOUTs.
        @return The Pointers to reg'd HOUTs.
     */
    public HPtr[] getRegOutPtr() {
      HPtr[] val = new HPtr[L_MAX_PKT_REG];
      for (int i = 0; i < val.length; i++) {
        int offset = i * 8;
        val[i] = new HPtr(getByteBuffer(), ((this.offset + (96)))+offset);
      }
      return val;
    }
  
    /** Gets the Bridge exception compare type.
        @return The Bridge exception compare type.
     */
    public String getBrdgXcmp() {
      StringBuilder str = new StringBuilder();
      StringBuilder pad = null; // Trailing spaces
      
      for (int i = 0; i < 4; i++) {
        char letter = (char)getByteBuffer().get(((this.offset + ((8*L_MAX_PKT_REG)+96)))+i);
        
        if (i == 0) {
          str.append(letter);
        } else if (letter == ' ') {
          if (pad == null) {
            pad = new StringBuilder(" ");
          } else {
            pad.append(letter);
          }
        } else {
          if (pad != null) {
            str.append(pad);
            pad = null;
          }
          str.append(letter);
        }
      }
      return str.toString();
    }
  
    /** Sets the Bridge exception compare type.
        @param val The Bridge exception compare type.
     */
    public void setBrdgXcmp(String val) {
      for (int i = 0; i < 4; i++) {
        if (i < val.length()) {
          char letter = val.charAt(i);
          if (letter > 0x7f) {
            throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
          } else {
              getByteBuffer().put(((this.offset + ((8*L_MAX_PKT_REG)+96)))+i, (byte)letter);
          }
        } else {
          getByteBuffer().put(((this.offset + ((8*L_MAX_PKT_REG)+96)))+i, (byte)' ');
        }
      }
    }
  
    /** Gets the Bridge exception value 1.
        @return The Bridge exception value 1.
     */
    public int getBrdgXv1() {
      return getByteBuffer().getInt((this.offset + ((8*L_MAX_PKT_REG)+100)));
    }
  
    /** Sets the Bridge exception value 1.
        @param val The Bridge exception value 1.
     */
    public void setBrdgXv1(int val) {
      getByteBuffer().putInt((this.offset + ((8*L_MAX_PKT_REG)+100)), val);
    }
  
    /** Gets the Bridge exception value 2.
        @return The Bridge exception value 2.
     */
    public int getBrdgXv2() {
      return getByteBuffer().getInt((this.offset + ((8*L_MAX_PKT_REG)+104)));
    }
  
    /** Sets the Bridge exception value 2.
        @param val The Bridge exception value 2.
     */
    public void setBrdgXv2(int val) {
      getByteBuffer().putInt((this.offset + ((8*L_MAX_PKT_REG)+104)), val);
    }
  
    /** Gets the Prop&#46; exception compare type.
        @return The Prop&#46; exception compare type.
     */
    public String getPropXcmp() {
      StringBuilder str = new StringBuilder();
      StringBuilder pad = null; // Trailing spaces
      
      for (int i = 0; i < 4; i++) {
        char letter = (char)getByteBuffer().get(((this.offset + ((8*L_MAX_PKT_REG)+108)))+i);
        
        if (i == 0) {
          str.append(letter);
        } else if (letter == ' ') {
          if (pad == null) {
            pad = new StringBuilder(" ");
          } else {
            pad.append(letter);
          }
        } else {
          if (pad != null) {
            str.append(pad);
            pad = null;
          }
          str.append(letter);
        }
      }
      return str.toString();
    }
  
    /** Sets the Prop&#46; exception compare type.
        @param val The Prop&#46; exception compare type.
     */
    public void setPropXcmp(String val) {
      for (int i = 0; i < 4; i++) {
        if (i < val.length()) {
          char letter = val.charAt(i);
          if (letter > 0x7f) {
            throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
          } else {
              getByteBuffer().put(((this.offset + ((8*L_MAX_PKT_REG)+108)))+i, (byte)letter);
          }
        } else {
          getByteBuffer().put(((this.offset + ((8*L_MAX_PKT_REG)+108)))+i, (byte)' ');
        }
      }
    }
  
    /** Gets the Prop&#46; exception value 1.
        @return The Prop&#46; exception value 1.
     */
    public int getPropXv1() {
      return getByteBuffer().getInt((this.offset + ((8*L_MAX_PKT_REG)+112)));
    }
  
    /** Sets the Prop&#46; exception value 1.
        @param val The Prop&#46; exception value 1.
     */
    public void setPropXv1(int val) {
      getByteBuffer().putInt((this.offset + ((8*L_MAX_PKT_REG)+112)), val);
    }
  
    /** Gets the Prop&#46; exception value 2.
        @return The Prop&#46; exception value 2.
     */
    public int getPropXv2() {
      return getByteBuffer().getInt((this.offset + ((8*L_MAX_PKT_REG)+116)));
    }
  
    /** Sets the Prop&#46; exception value 2.
        @param val The Prop&#46; exception value 2.
     */
    public void setPropXv2(int val) {
      getByteBuffer().putInt((this.offset + ((8*L_MAX_PKT_REG)+116)), val);
    }
  
    /** Summarizes the record.
        @return A string listing the current data in the record.
     */
    public String toString() {
      StringBuilder sb = new StringBuilder();
      sb.append("PktStruct: {");
      sb.append(" getPacketized = ").append(getPacketized());  
      sb.append(" getFlags = ").append(getFlags());  
      sb.append(" getBufPtr = ").append(getBufPtr());  
      sb.append(" getSendNewPkt = ").append(getSendNewPkt());  
      sb.append(" getGetNewPkt = ").append(getGetNewPkt());  
      sb.append(" getRcvdNewPkt = ").append(getRcvdNewPkt());  
      sb.append(" getElmRem = ").append(getElmRem());  
      sb.append(" getByteCount = ").append(getByteCount());  
      sb.append(" getRegCount = ").append(getRegCount());  
      sb.append(" getHcbmod = ").append(getHcbmod());  
      sb.append(" getHcbchg = ").append(getHcbchg());  
      sb.append(" getByteOffset = ").append(getByteOffset());  
      sb.append(" getHcbOffsetSave = ").append(getHcbOffsetSave());  
      sb.append(" getAbsElmOffset = ").append(getAbsElmOffset());  
      sb.append(" getAbsElmSeek = ").append(getAbsElmSeek());  
      sb.append(" getFirstElm = ").append(getFirstElm());  
      sb.append(" getLastElm = ").append(getLastElm());  
      sb.append(" getRegOutPtr = ").append(getRegOutPtr());  
      sb.append(" getBrdgXcmp = ").append(getBrdgXcmp());  
      sb.append(" getBrdgXv1 = ").append(getBrdgXv1());  
      sb.append(" getBrdgXv2 = ").append(getBrdgXv2());  
      sb.append(" getPropXcmp = ").append(getPropXcmp());  
      sb.append(" getPropXv1 = ").append(getPropXv1());  
      sb.append(" getPropXv2 = ").append(getPropXv2());  
      sb.append(" }");
      return sb.toString();
    }
  }

  /** Defines the SubrecStruct structure. */
  public static class SubrecStruct {
    /** The byte buffer. */
    private final ByteBuffer byteBuffer;
    
    /** The offset index. */
    private final int offset;
    
    /** Creates a new instance.
        @param byteBuffer The byte buffer.
        @param offset     The offset index.
     */
    private SubrecStruct(ByteBuffer byteBuffer, int offset) {
      this.byteBuffer = byteBuffer;
      this.offset     = offset;
    }
    /** Gets the byte buffer.
        @return The byte buffer.
     */
    private ByteBuffer getByteBuffer() {
      return byteBuffer;
    }

    /** Gets the unknown.
        @return The unknown.
     */
    public String getName() {
      StringBuilder str = new StringBuilder();
      StringBuilder pad = null; // Trailing spaces
      
      for (int i = 0; i < 4; i++) {
        char letter = (char)getByteBuffer().get(((this.offset + (0)))+i);
        
        if (i == 0) {
          str.append(letter);
        } else if (letter == ' ') {
          if (pad == null) {
            pad = new StringBuilder(" ");
          } else {
            pad.append(letter);
          }
        } else {
          if (pad != null) {
            str.append(pad);
            pad = null;
          }
          str.append(letter);
        }
      }
      return str.toString();
    }
  
    /** Sets the unknown.
        @param val The unknown.
     */
    public void setName(String val) {
      for (int i = 0; i < 4; i++) {
        if (i < val.length()) {
          char letter = val.charAt(i);
          if (letter > 0x7f) {
            throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
          } else {
              getByteBuffer().put(((this.offset + (0)))+i, (byte)letter);
          }
        } else {
          getByteBuffer().put(((this.offset + (0)))+i, (byte)' ');
        }
      }
    }
  
    /** Gets the unknown.
        @return The unknown.
     */
    public String getFormat() {
      StringBuilder str = new StringBuilder();
      StringBuilder pad = null; // Trailing spaces
      
      for (int i = 0; i < 2; i++) {
        char letter = (char)getByteBuffer().get(((this.offset + (4)))+i);
        
        if (i == 0) {
          str.append(letter);
        } else if (letter == ' ') {
          if (pad == null) {
            pad = new StringBuilder(" ");
          } else {
            pad.append(letter);
          }
        } else {
          if (pad != null) {
            str.append(pad);
            pad = null;
          }
          str.append(letter);
        }
      }
      return str.toString();
    }
  
    /** Sets the unknown.
        @param val The unknown.
     */
    public void setFormat(String val) {
      for (int i = 0; i < 2; i++) {
        if (i < val.length()) {
          char letter = val.charAt(i);
          if (letter > 0x7f) {
            throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
          } else {
              getByteBuffer().put(((this.offset + (4)))+i, (byte)letter);
          }
        } else {
          getByteBuffer().put(((this.offset + (4)))+i, (byte)' ');
        }
      }
    }
  
    /** Gets the unknown.
        @return The unknown.
     */
    public short getOffset() {
      return getByteBuffer().getShort((this.offset + (6)));
    }
  
    /** Sets the unknown.
        @param val The unknown.
     */
    public void setOffset(short val) {
      getByteBuffer().putShort((this.offset + (6)), val);
    }
  
    /** Summarizes the record.
        @return A string listing the current data in the record.
     */
    public String toString() {
      StringBuilder sb = new StringBuilder();
      sb.append("SubrecStruct: {");
      sb.append(" getName = ").append(getName());  
      sb.append(" getFormat = ").append(getFormat());  
      sb.append(" getOffset = ").append(getOffset());  
      sb.append(" }");
      return sb.toString();
    }
  }

  /** Defines the CompStruct structure. */
  public static class CompStruct {
    /** The byte buffer. */
    private final ByteBuffer byteBuffer;
    
    /** The offset index. */
    private final int offset;
    
    /** Creates a new instance.
        @param byteBuffer The byte buffer.
        @param offset     The offset index.
     */
    private CompStruct(ByteBuffer byteBuffer, int offset) {
      this.byteBuffer = byteBuffer;
      this.offset     = offset;
    }
    /** Gets the byte buffer.
        @return The byte buffer.
     */
    private ByteBuffer getByteBuffer() {
      return byteBuffer;
    }

    /** Gets the unknown.
        @return The unknown.
     */
    public String getName() {
      StringBuilder str = new StringBuilder();
      StringBuilder pad = null; // Trailing spaces
      
      for (int i = 0; i < 4; i++) {
        char letter = (char)getByteBuffer().get(((this.offset + (0)))+i);
        
        if (i == 0) {
          str.append(letter);
        } else if (letter == ' ') {
          if (pad == null) {
            pad = new StringBuilder(" ");
          } else {
            pad.append(letter);
          }
        } else {
          if (pad != null) {
            str.append(pad);
            pad = null;
          }
          str.append(letter);
        }
      }
      return str.toString();
    }
  
    /** Sets the unknown.
        @param val The unknown.
     */
    public void setName(String val) {
      for (int i = 0; i < 4; i++) {
        if (i < val.length()) {
          char letter = val.charAt(i);
          if (letter > 0x7f) {
            throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
          } else {
              getByteBuffer().put(((this.offset + (0)))+i, (byte)letter);
          }
        } else {
          getByteBuffer().put(((this.offset + (0)))+i, (byte)' ');
        }
      }
    }
  
    /** Gets the unknown.
        @return The unknown.
     */
    public String getFormat() {
      StringBuilder str = new StringBuilder();
      StringBuilder pad = null; // Trailing spaces
      
      for (int i = 0; i < 2; i++) {
        char letter = (char)getByteBuffer().get(((this.offset + (4)))+i);
        
        if (i == 0) {
          str.append(letter);
        } else if (letter == ' ') {
          if (pad == null) {
            pad = new StringBuilder(" ");
          } else {
            pad.append(letter);
          }
        } else {
          if (pad != null) {
            str.append(pad);
            pad = null;
          }
          str.append(letter);
        }
      }
      return str.toString();
    }
  
    /** Sets the unknown.
        @param val The unknown.
     */
    public void setFormat(String val) {
      for (int i = 0; i < 2; i++) {
        if (i < val.length()) {
          char letter = val.charAt(i);
          if (letter > 0x7f) {
            throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
          } else {
              getByteBuffer().put(((this.offset + (4)))+i, (byte)letter);
          }
        } else {
          getByteBuffer().put(((this.offset + (4)))+i, (byte)' ');
        }
      }
    }
  
    /** Gets the unknown.
        @return The unknown.
     */
    public byte getType() {
      return getByteBuffer().get((this.offset + (6)));
    }
  
    /** Sets the unknown.
        @param val The unknown.
     */
    public void setType(byte val) {
      getByteBuffer().put((this.offset + (6)), val);
    }
  
    /** Gets the unknown.
        @return The unknown.
     */
    public byte getUnits() {
      return getByteBuffer().get((this.offset + (7)));
    }
  
    /** Sets the unknown.
        @param val The unknown.
     */
    public void setUnits(byte val) {
      getByteBuffer().put((this.offset + (7)), val);
    }
  
    /** Summarizes the record.
        @return A string listing the current data in the record.
     */
    public String toString() {
      StringBuilder sb = new StringBuilder();
      sb.append("CompStruct: {");
      sb.append(" getName = ").append(getName());  
      sb.append(" getFormat = ").append(getFormat());  
      sb.append(" getType = ").append(getType());  
      sb.append(" getUnits = ").append(getUnits());  
      sb.append(" }");
      return sb.toString();
    }
  }

  //   </editor-fold>
  // </BBMakeGenCode>//GEN-END:BBMakeGenCode
}

