// <BBMakeDefs>
// <MessageStruct size="16">
//     0, byte                , getType                , setType                , "message type"
//     ~, AsciiChar           , getFormat              , setFormat              , "message format (V,I,E)"
//     ~, short               , getIdata               , setIdata               , "message data"
//     ~, int                 , getLdata               , setLdata               , "message data"
//     ~, double              , getDdata               , setDdata               , "message data"
// </MessageStruct>
// <EngineStruct size="56">
//     0, FortranString(19)   , getNode                , setNode                , "node name"
//     ~, AsciiChar           , getFp                  , setFp                  , "float prec def"
//     ~, FortranString(4)    , getOs                  , setOs                  , "Oper Sys type"
//     ~, FortranString(4)    , getRep                 , setRep                 , "data representation"
//     ~, int                 , getTl                  , setTl                  , "def transfer length"
//     ~, int                 , getPs                  , setPs                  , "def pipe size"
//     ~, int                 , getFb                  , setFb                  , "def file buffer size"
//     ~, int                 , getSocket              , setSocket              , "socket ID code"
//     ~, int                 , getSdin                , setSdin                , "in descript"
//     ~, int                 , getSdout               , setSdout               , "out descript"
//     ~, int                 , getState               , setState               , "engine status"
// </EngineStruct>
// <MAIN>
//     0, int                 , getDsmessState         , setDsmessState         , "DS message state"
//     ~, int                 , getDsmessIn            , setDsmessIn            , "DS message in"
//     ~, int                 , getDsmessOut           , setDsmessOut           , "DS message out"
//     ~, int                 , getDsmessLock          , setDsmessLock          , "DS message lock"
//     ~, MessageStruct[L_DSMESS], getDsmess           , setDsmess              , "message buffer"
//     ~, int                 , getHistoryb            , setHistoryb            , "hist buf ID ping/pong"
//     ~, int[2]              , getNhistory            , setNhistory            , "# commands in hist buf"
//     ~, short[2*L_HISTORYS] , getHIndex              , setHIndex              , "command start index"
//     ~, FortranString(L_HISTORY_CHARS*2), getHString , setHString             , "history buf string"
//     ~, int                 , getNmessage            , setNmessage            , "queue length"
//     ~, int                 , getNreaders            , setNreaders            , "max number readers"
//     ~, int                 , getNpipe               , setNpipe               , "# pipes"
//     ~, int                 , getMpipe               , setMpipe               , "max # pipes"
//     ~, int                 , getPheadOff            , setPheadOff            , ""
//     ~, int                 , getNwidget             , setNwidget             , "# control widgets"
//     ~, int                 , getWparmOff            , setWparmOff            , ""
//     ~, int                 , getWparmUsed           , setWparmUsed           , ""
//     ~, short[L_WBANKS]     , getWBank               , setWBank               , "widget bank offsets"
//     ~, int                 , getDsAlloc             , setDsAlloc             , ""
//     ~, int                 , getDsUsed              , setDsUsed              , ""
//     ~, int                 , getDsPtr               , setDsPtr               , ""
//     ~, int                 , getDsFlag              , setDsFlag              , ""
//     ~, EngineStruct[L_ENGINES+1], getEngine         , setEngine              , "DS engines structs"
//     ~, int                 , getResultLock          , setResultLock          , "result writer's lock"
//     ~, int                 , getDsintLock           , setDsintLock           , ""
//     ~, int                 , getDsintSize           , setDsintSize           , ""
//     ~, int                 , getDsintStatus         , setDsintStatus         , ""
//     ~, short               , getDsintState          , setDsintState          , ""
//     ~, short               , getDsintEngine         , setDsintEngine         , ""
//     ~, byte[L_DSINTBUF]    , getDsintbuf            , setDsintbuf            , ""
// </MAIN>
// </BBMakeDefs>
package nxm.sys.libxm;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import nxm.sys.lib.Shell;


/** A class that wraps the native MTABLES structure for Mt; this is an automatically generated class. DO NOT EDIT!!! */
class Mt {
  /** Loads the JNI library. */
  static {
    Shell.loadLibrary(Mt.class.getName());
  }
  
  /** The byte buffer to use. */
  private static ByteBuffer byteBuffer;
  
  /** Creates a new instance. */
  private Mt() { }
  
  /** Gets the byte buffer.
      @return The byte buffer.
   */
  public static ByteBuffer getByteBuffer() {
    if (byteBuffer == null) {
      byteBuffer = getByteBuffer0();
      byteBuffer.order(ByteOrder.nativeOrder());
    }
    return byteBuffer;
  }
  
  /** Gets the byte buffer. This should only be called by getByteBuffer().<br>
      <br>
      WARNING: The byte buffer returned by this method will need to have its
               byte order set using byteBuffer.order(ByteOrder.nativeOrder())
               before it can be accessed.
               
      @return The byte buffer.
   */
  private static native ByteBuffer getByteBuffer0();
  
  /** max entries in history buffer */
  public static final int L_HISTORYS = 32;
  
  /** max number of control widgets banks */
  public static final int L_WBANKS = 16;
  
  /** max number of datastream messages */
  public static final int L_DSMESS = 256;
  
  /** length of DS interrupt buffer */
  public static final int L_DSINTBUF = 512;
  
  /** max number of datastream engines */
  public static final int L_ENGINES = 15;
  
  /** max number of ids on message queue */
  public static final int L_MESSAGE_IDS = 4096;
  
  /** size of history buffer */
  public static final int L_HISTORY_CHARS = 512;
  
  /** unknown */
  public static final int L_MESSAGE_HDR = 2*8+8*4+L_MESSAGE_IDS*4;
  
  /** unknown */
  public static final Mt MT = new Mt();
  
  /** unknown */
  public static final int L_MIDAS_TABLES = 6800;
  
  // <BBMakeGenCode>//GEN-BEGIN:BBMakeGenCode
  /* This next section of code generated by BBDEF2JAVA in CONVERT.
     DO NOT EDIT THIS CODE, it will be re-written every time
     BBDEF2JAVA is run and any changes will be lost.
   */
  //   <editor-fold defaultstate="collapsed" desc=" Generated Code ">
  /** Gets the DS message state.
      @return The DS message state.
   */
  public static int getDsmessState() {
    return getByteBuffer().getInt(0);
  }

  /** Sets the DS message state.
      @param val The DS message state.
   */
  public static void setDsmessState(int val) {
    getByteBuffer().putInt(0, val);
  }

  /** Gets the DS message in.
      @return The DS message in.
   */
  public static int getDsmessIn() {
    return getByteBuffer().getInt(4);
  }

  /** Sets the DS message in.
      @param val The DS message in.
   */
  public static void setDsmessIn(int val) {
    getByteBuffer().putInt(4, val);
  }

  /** Gets the DS message out.
      @return The DS message out.
   */
  public static int getDsmessOut() {
    return getByteBuffer().getInt(8);
  }

  /** Sets the DS message out.
      @param val The DS message out.
   */
  public static void setDsmessOut(int val) {
    getByteBuffer().putInt(8, val);
  }

  /** Gets the DS message lock.
      @return The DS message lock.
   */
  public static int getDsmessLock() {
    return getByteBuffer().getInt(12);
  }

  /** Sets the DS message lock.
      @param val The DS message lock.
   */
  public static void setDsmessLock(int val) {
    getByteBuffer().putInt(12, val);
  }

  /** Gets the message buffer.
      @return The message buffer.
   */
  public static MessageStruct[] getDsmess() {
    MessageStruct[] val = new MessageStruct[L_DSMESS];
    for (int i = 0; i < val.length; i++) {
      int offset = i * 16;
      val[i] = new MessageStruct(getByteBuffer(), (16)+offset);
    }
    return val;
  }

  /** Gets the hist buf ID ping/pong.
      @return The hist buf ID ping/pong.
   */
  public static int getHistoryb() {
    return getByteBuffer().getInt((16*L_DSMESS)+16);
  }

  /** Sets the hist buf ID ping/pong.
      @param val The hist buf ID ping/pong.
   */
  public static void setHistoryb(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+16, val);
  }

  /** gets the # commands in hist buf.
      @return The # commands in hist buf (an array of size 2).
   */
  public static int[] getNhistory() {
    int[] val = new int[2];
    for (int i = 0; i < val.length; i++) {
      int off = i * 4;
      val[i] = getByteBuffer().getInt(((16*L_DSMESS)+20)+off);
    }
    return val;
  }
  /** Gets the # commands in hist buf at the specified index.
      @return The # commands in hist buf at the specified index.
   */
  public static int getNhistoryAt(int index) {
    int off = index * 4;
    int val = getByteBuffer().getInt(((16*L_DSMESS)+20)+off);
    return val;
  }
  /** Sets the # commands in hist buf.
      @param val The # commands in hist buf (must be an array of size 2).
   */
  public static void setNhistory(int[] val) {
    if (val.length != 2) {
      throw new IllegalArgumentException("setNhistory: expected array of"
        + "length 2, given array of length "+val.length+".");
    }
    for (int i = 0; i < val.length; i++) {
      int off = i * 4;
      getByteBuffer().putInt(((16*L_DSMESS)+20)+off, val[i]);
    }
  }
  /** Sets the # commands in hist buf at the specified index.
      @param val The # commands in hist buf at the specified index.
   */
  public static void setNhistoryAt(int index, int val) {
    if (index >= 2) {
      throw new IllegalArgumentException("setNhistory: index ["+index+"] is out of range ["+2+"]");
    }
    int off = index * 4;
    getByteBuffer().putInt(((16*L_DSMESS)+20)+off, val);
  }

  /** gets the command start index.
      @return The command start index (an array of size 2*L_HISTORYS).
   */
  public static short[] getHIndex() {
    short[] val = new short[2*L_HISTORYS];
    for (int i = 0; i < val.length; i++) {
      int off = i * 2;
      val[i] = getByteBuffer().getShort(((16*L_DSMESS)+28)+off);
    }
    return val;
  }
  /** Gets the command start index at the specified index.
      @return The command start index at the specified index.
   */
  public static short getHIndexAt(int index) {
    int off = index * 2;
    short val = getByteBuffer().getShort(((16*L_DSMESS)+28)+off);
    return val;
  }
  /** Sets the command start index.
      @param val The command start index (must be an array of size 2*L_HISTORYS).
   */
  public static void setHIndex(short[] val) {
    if (val.length != 2*L_HISTORYS) {
      throw new IllegalArgumentException("setHIndex: expected array of"
        + "length 2*L_HISTORYS, given array of length "+val.length+".");
    }
    for (int i = 0; i < val.length; i++) {
      int off = i * 2;
      getByteBuffer().putShort(((16*L_DSMESS)+28)+off, val[i]);
    }
  }
  /** Sets the command start index at the specified index.
      @param val The command start index at the specified index.
   */
  public static void setHIndexAt(int index, short val) {
    if (index >= 2*L_HISTORYS) {
      throw new IllegalArgumentException("setHIndex: index ["+index+"] is out of range ["+2*L_HISTORYS+"]");
    }
    int off = index * 2;
    getByteBuffer().putShort(((16*L_DSMESS)+28)+off, val);
  }

  /** Gets the history buf string.
      @return The history buf string.
   */
  public static String getHString() {
    StringBuilder str = new StringBuilder();
    StringBuilder pad = null; // Trailing spaces
    
    for (int i = 0; i < L_HISTORY_CHARS*2; i++) {
      char letter = (char)getByteBuffer().get(((16*L_DSMESS)+(2*(2*L_HISTORYS))+28)+i);
      
      if (i == 0) {
        str.append(letter);
      } else if (letter == ' ') {
        if (pad == null) {
          pad = new StringBuilder(" ");
        } else {
          pad.append(letter);
        }
      } else {
        if (pad != null) {
          str.append(pad);
          pad = null;
        }
        str.append(letter);
      }
    }
    return str.toString();
  }

  /** Sets the history buf string.
      @param val The history buf string.
   */
  public static void setHString(String val) {
    for (int i = 0; i < L_HISTORY_CHARS*2; i++) {
      if (i < val.length()) {
        char letter = val.charAt(i);
        if (letter > 0x7f) {
          throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
        } else {
            getByteBuffer().put(((16*L_DSMESS)+(2*(2*L_HISTORYS))+28)+i, (byte)letter);
        }
      } else {
        getByteBuffer().put(((16*L_DSMESS)+(2*(2*L_HISTORYS))+28)+i, (byte)' ');
      }
    }
  }

  /** Gets the queue length.
      @return The queue length.
   */
  public static int getNmessage() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+28);
  }

  /** Sets the queue length.
      @param val The queue length.
   */
  public static void setNmessage(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+28, val);
  }

  /** Gets the max number readers.
      @return The max number readers.
   */
  public static int getNreaders() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+32);
  }

  /** Sets the max number readers.
      @param val The max number readers.
   */
  public static void setNreaders(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+32, val);
  }

  /** Gets the # pipes.
      @return The # pipes.
   */
  public static int getNpipe() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+36);
  }

  /** Sets the # pipes.
      @param val The # pipes.
   */
  public static void setNpipe(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+36, val);
  }

  /** Gets the max # pipes.
      @return The max # pipes.
   */
  public static int getMpipe() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+40);
  }

  /** Sets the max # pipes.
      @param val The max # pipes.
   */
  public static void setMpipe(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+40, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getPheadOff() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+44);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setPheadOff(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+44, val);
  }

  /** Gets the # control widgets.
      @return The # control widgets.
   */
  public static int getNwidget() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+48);
  }

  /** Sets the # control widgets.
      @param val The # control widgets.
   */
  public static void setNwidget(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+48, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getWparmOff() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+52);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setWparmOff(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+52, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getWparmUsed() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+56);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setWparmUsed(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+56, val);
  }

  /** gets the widget bank offsets.
      @return The widget bank offsets (an array of size L_WBANKS).
   */
  public static short[] getWBank() {
    short[] val = new short[L_WBANKS];
    for (int i = 0; i < val.length; i++) {
      int off = i * 2;
      val[i] = getByteBuffer().getShort(((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+60)+off);
    }
    return val;
  }
  /** Gets the widget bank offsets at the specified index.
      @return The widget bank offsets at the specified index.
   */
  public static short getWBankAt(int index) {
    int off = index * 2;
    short val = getByteBuffer().getShort(((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+60)+off);
    return val;
  }
  /** Sets the widget bank offsets.
      @param val The widget bank offsets (must be an array of size L_WBANKS).
   */
  public static void setWBank(short[] val) {
    if (val.length != L_WBANKS) {
      throw new IllegalArgumentException("setWBank: expected array of"
        + "length L_WBANKS, given array of length "+val.length+".");
    }
    for (int i = 0; i < val.length; i++) {
      int off = i * 2;
      getByteBuffer().putShort(((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+60)+off, val[i]);
    }
  }
  /** Sets the widget bank offsets at the specified index.
      @param val The widget bank offsets at the specified index.
   */
  public static void setWBankAt(int index, short val) {
    if (index >= L_WBANKS) {
      throw new IllegalArgumentException("setWBank: index ["+index+"] is out of range ["+L_WBANKS+"]");
    }
    int off = index * 2;
    getByteBuffer().putShort(((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+60)+off, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getDsAlloc() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+60);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setDsAlloc(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+60, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getDsUsed() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+64);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setDsUsed(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+64, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getDsPtr() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+68);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setDsPtr(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+68, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getDsFlag() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+72);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setDsFlag(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+72, val);
  }

  /** Gets the DS engines structs.
      @return The DS engines structs.
   */
  public static EngineStruct[] getEngine() {
    EngineStruct[] val = new EngineStruct[L_ENGINES+1];
    for (int i = 0; i < val.length; i++) {
      int offset = i * 56;
      val[i] = new EngineStruct(getByteBuffer(), ((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+76)+offset);
    }
    return val;
  }

  /** Gets the result writer's lock.
      @return The result writer's lock.
   */
  public static int getResultLock() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+76);
  }

  /** Sets the result writer's lock.
      @param val The result writer's lock.
   */
  public static void setResultLock(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+76, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getDsintLock() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+80);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setDsintLock(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+80, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getDsintSize() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+84);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setDsintSize(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+84, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static int getDsintStatus() {
    return getByteBuffer().getInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+88);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setDsintStatus(int val) {
    getByteBuffer().putInt((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+88, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static short getDsintState() {
    return getByteBuffer().getShort((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+92);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setDsintState(short val) {
    getByteBuffer().putShort((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+92, val);
  }

  /** Gets the unknown.
      @return The unknown.
   */
  public static short getDsintEngine() {
    return getByteBuffer().getShort((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+94);
  }

  /** Sets the unknown.
      @param val The unknown.
   */
  public static void setDsintEngine(short val) {
    getByteBuffer().putShort((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+94, val);
  }

  /** gets the unknown.
      @return The unknown (an array of size L_DSINTBUF).
   */
  public static byte[] getDsintbuf() {
    byte[] val = new byte[L_DSINTBUF];
    for (int i = 0; i < val.length; i++) {
      int off = i * 1;
      val[i] = getByteBuffer().get(((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+96)+off);
    }
    return val;
  }
  /** Gets the unknown at the specified index.
      @return The unknown at the specified index.
   */
  public static byte getDsintbufAt(int index) {
    int off = index * 1;
    byte val = getByteBuffer().get(((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+96)+off);
    return val;
  }
  /** Sets the unknown.
      @param val The unknown (must be an array of size L_DSINTBUF).
   */
  public static void setDsintbuf(byte[] val) {
    if (val.length != L_DSINTBUF) {
      throw new IllegalArgumentException("setDsintbuf: expected array of"
        + "length L_DSINTBUF, given array of length "+val.length+".");
    }
    for (int i = 0; i < val.length; i++) {
      int off = i * 1;
      getByteBuffer().put(((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+96)+off, val[i]);
    }
  }
  /** Sets the unknown at the specified index.
      @param val The unknown at the specified index.
   */
  public static void setDsintbufAt(int index, byte val) {
    if (index >= L_DSINTBUF) {
      throw new IllegalArgumentException("setDsintbuf: index ["+index+"] is out of range ["+L_DSINTBUF+"]");
    }
    int off = index * 1;
    getByteBuffer().put(((16*L_DSMESS)+(2*(2*L_HISTORYS))+(L_HISTORY_CHARS*2)+(2*L_WBANKS)+(56*(L_ENGINES+1))+96)+off, val);
  }

  /** Dumps the data in the buffer to a String. This method is for
      debugging purposes only its syntax may change in the future
      without notice.
      
      @return A string listing the current data in the buffer.
   */
  public static String dumpData() {
    StringBuilder sb = new StringBuilder();
    sb.append("getDsmessState       = ").append(getDsmessState()      ).append('\n');
    sb.append("getDsmessIn          = ").append(getDsmessIn()         ).append('\n');
    sb.append("getDsmessOut         = ").append(getDsmessOut()        ).append('\n');
    sb.append("getDsmessLock        = ").append(getDsmessLock()       ).append('\n');
    sb.append("getDsmess            = ").append(getDsmess()           ).append('\n');
    sb.append("getHistoryb          = ").append(getHistoryb()         ).append('\n');
    sb.append("getNhistory          = ").append(getNhistory()         ).append('\n');
    sb.append("getHIndex            = ").append(getHIndex()           ).append('\n');
    sb.append("getHString           = ").append(getHString()          ).append('\n');
    sb.append("getNmessage          = ").append(getNmessage()         ).append('\n');
    sb.append("getNreaders          = ").append(getNreaders()         ).append('\n');
    sb.append("getNpipe             = ").append(getNpipe()            ).append('\n');
    sb.append("getMpipe             = ").append(getMpipe()            ).append('\n');
    sb.append("getPheadOff          = ").append(getPheadOff()         ).append('\n');
    sb.append("getNwidget           = ").append(getNwidget()          ).append('\n');
    sb.append("getWparmOff          = ").append(getWparmOff()         ).append('\n');
    sb.append("getWparmUsed         = ").append(getWparmUsed()        ).append('\n');
    sb.append("getWBank             = ").append(getWBank()            ).append('\n');
    sb.append("getDsAlloc           = ").append(getDsAlloc()          ).append('\n');
    sb.append("getDsUsed            = ").append(getDsUsed()           ).append('\n');
    sb.append("getDsPtr             = ").append(getDsPtr()            ).append('\n');
    sb.append("getDsFlag            = ").append(getDsFlag()           ).append('\n');
    sb.append("getEngine            = ").append(getEngine()           ).append('\n');
    sb.append("getResultLock        = ").append(getResultLock()       ).append('\n');
    sb.append("getDsintLock         = ").append(getDsintLock()        ).append('\n');
    sb.append("getDsintSize         = ").append(getDsintSize()        ).append('\n');
    sb.append("getDsintStatus       = ").append(getDsintStatus()      ).append('\n');
    sb.append("getDsintState        = ").append(getDsintState()       ).append('\n');
    sb.append("getDsintEngine       = ").append(getDsintEngine()      ).append('\n');
    sb.append("getDsintbuf          = ").append(getDsintbuf()         ).append('\n');
    return sb.toString();
  }
  /** Defines the MessageStruct structure. */
  public static class MessageStruct {
    /** The byte buffer. */
    private final ByteBuffer byteBuffer;
    
    /** The offset index. */
    private final int offset;
    
    /** Creates a new instance.
        @param byteBuffer The byte buffer.
        @param offset     The offset index.
     */
    private MessageStruct(ByteBuffer byteBuffer, int offset) {
      this.byteBuffer = byteBuffer;
      this.offset     = offset;
    }
    /** Gets the byte buffer.
        @return The byte buffer.
     */
    private ByteBuffer getByteBuffer() {
      return byteBuffer;
    }

    /** Gets the message type.
        @return The message type.
     */
    public byte getType() {
      return getByteBuffer().get((this.offset + (0)));
    }
  
    /** Sets the message type.
        @param val The message type.
     */
    public void setType(byte val) {
      getByteBuffer().put((this.offset + (0)), val);
    }
  
    /** Gets the message format (V,I,E).
        @return The message format (V,I,E).
     */
    public char getFormat() {
      return (char)getByteBuffer().get((this.offset + (1)));
    }
  
    /** Sets the message format (V,I,E).
        @param val The message format (V,I,E).
     */
    public void setFormat(char val) {
      if (val > 0x7f) {
        throw new IllegalArgumentException("Expected ASCII character given '"+val+"'.");
      }
      getByteBuffer().put((this.offset + (1)), (byte)val);
    }
  
    /** Gets the message data.
        @return The message data.
     */
    public short getIdata() {
      return getByteBuffer().getShort((this.offset + (2)));
    }
  
    /** Sets the message data.
        @param val The message data.
     */
    public void setIdata(short val) {
      getByteBuffer().putShort((this.offset + (2)), val);
    }
  
    /** Gets the message data.
        @return The message data.
     */
    public int getLdata() {
      return getByteBuffer().getInt((this.offset + (4)));
    }
  
    /** Sets the message data.
        @param val The message data.
     */
    public void setLdata(int val) {
      getByteBuffer().putInt((this.offset + (4)), val);
    }
  
    /** Gets the message data.
        @return The message data.
     */
    public double getDdata() {
      return getByteBuffer().getDouble((this.offset + (8)));
    }
  
    /** Sets the message data.
        @param val The message data.
     */
    public void setDdata(double val) {
      getByteBuffer().putDouble((this.offset + (8)), val);
    }
  
    /** Summarizes the record.
        @return A string listing the current data in the record.
     */
    public String toString() {
      StringBuilder sb = new StringBuilder();
      sb.append("MessageStruct: {");
      sb.append(" getType = ").append(getType());  
      sb.append(" getFormat = ").append(getFormat());  
      sb.append(" getIdata = ").append(getIdata());  
      sb.append(" getLdata = ").append(getLdata());  
      sb.append(" getDdata = ").append(getDdata());  
      sb.append(" }");
      return sb.toString();
    }
  }

  /** Defines the EngineStruct structure. */
  public static class EngineStruct {
    /** The byte buffer. */
    private final ByteBuffer byteBuffer;
    
    /** The offset index. */
    private final int offset;
    
    /** Creates a new instance.
        @param byteBuffer The byte buffer.
        @param offset     The offset index.
     */
    private EngineStruct(ByteBuffer byteBuffer, int offset) {
      this.byteBuffer = byteBuffer;
      this.offset     = offset;
    }
    /** Gets the byte buffer.
        @return The byte buffer.
     */
    private ByteBuffer getByteBuffer() {
      return byteBuffer;
    }

    /** Gets the node name.
        @return The node name.
     */
    public String getNode() {
      StringBuilder str = new StringBuilder();
      StringBuilder pad = null; // Trailing spaces
      
      for (int i = 0; i < 19; i++) {
        char letter = (char)getByteBuffer().get(((this.offset + (0)))+i);
        
        if (i == 0) {
          str.append(letter);
        } else if (letter == ' ') {
          if (pad == null) {
            pad = new StringBuilder(" ");
          } else {
            pad.append(letter);
          }
        } else {
          if (pad != null) {
            str.append(pad);
            pad = null;
          }
          str.append(letter);
        }
      }
      return str.toString();
    }
  
    /** Sets the node name.
        @param val The node name.
     */
    public void setNode(String val) {
      for (int i = 0; i < 19; i++) {
        if (i < val.length()) {
          char letter = val.charAt(i);
          if (letter > 0x7f) {
            throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
          } else {
              getByteBuffer().put(((this.offset + (0)))+i, (byte)letter);
          }
        } else {
          getByteBuffer().put(((this.offset + (0)))+i, (byte)' ');
        }
      }
    }
  
    /** Gets the float prec def.
        @return The float prec def.
     */
    public char getFp() {
      return (char)getByteBuffer().get((this.offset + (19)));
    }
  
    /** Sets the float prec def.
        @param val The float prec def.
     */
    public void setFp(char val) {
      if (val > 0x7f) {
        throw new IllegalArgumentException("Expected ASCII character given '"+val+"'.");
      }
      getByteBuffer().put((this.offset + (19)), (byte)val);
    }
  
    /** Gets the Oper Sys type.
        @return The Oper Sys type.
     */
    public String getOs() {
      StringBuilder str = new StringBuilder();
      StringBuilder pad = null; // Trailing spaces
      
      for (int i = 0; i < 4; i++) {
        char letter = (char)getByteBuffer().get(((this.offset + (20)))+i);
        
        if (i == 0) {
          str.append(letter);
        } else if (letter == ' ') {
          if (pad == null) {
            pad = new StringBuilder(" ");
          } else {
            pad.append(letter);
          }
        } else {
          if (pad != null) {
            str.append(pad);
            pad = null;
          }
          str.append(letter);
        }
      }
      return str.toString();
    }
  
    /** Sets the Oper Sys type.
        @param val The Oper Sys type.
     */
    public void setOs(String val) {
      for (int i = 0; i < 4; i++) {
        if (i < val.length()) {
          char letter = val.charAt(i);
          if (letter > 0x7f) {
            throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
          } else {
              getByteBuffer().put(((this.offset + (20)))+i, (byte)letter);
          }
        } else {
          getByteBuffer().put(((this.offset + (20)))+i, (byte)' ');
        }
      }
    }
  
    /** Gets the data representation.
        @return The data representation.
     */
    public String getRep() {
      StringBuilder str = new StringBuilder();
      StringBuilder pad = null; // Trailing spaces
      
      for (int i = 0; i < 4; i++) {
        char letter = (char)getByteBuffer().get(((this.offset + (24)))+i);
        
        if (i == 0) {
          str.append(letter);
        } else if (letter == ' ') {
          if (pad == null) {
            pad = new StringBuilder(" ");
          } else {
            pad.append(letter);
          }
        } else {
          if (pad != null) {
            str.append(pad);
            pad = null;
          }
          str.append(letter);
        }
      }
      return str.toString();
    }
  
    /** Sets the data representation.
        @param val The data representation.
     */
    public void setRep(String val) {
      for (int i = 0; i < 4; i++) {
        if (i < val.length()) {
          char letter = val.charAt(i);
          if (letter > 0x7f) {
            throw new IllegalArgumentException("Expected ASCII character given '"+letter+"'.");
          } else {
              getByteBuffer().put(((this.offset + (24)))+i, (byte)letter);
          }
        } else {
          getByteBuffer().put(((this.offset + (24)))+i, (byte)' ');
        }
      }
    }
  
    /** Gets the def transfer length.
        @return The def transfer length.
     */
    public int getTl() {
      return getByteBuffer().getInt((this.offset + (28)));
    }
  
    /** Sets the def transfer length.
        @param val The def transfer length.
     */
    public void setTl(int val) {
      getByteBuffer().putInt((this.offset + (28)), val);
    }
  
    /** Gets the def pipe size.
        @return The def pipe size.
     */
    public int getPs() {
      return getByteBuffer().getInt((this.offset + (32)));
    }
  
    /** Sets the def pipe size.
        @param val The def pipe size.
     */
    public void setPs(int val) {
      getByteBuffer().putInt((this.offset + (32)), val);
    }
  
    /** Gets the def file buffer size.
        @return The def file buffer size.
     */
    public int getFb() {
      return getByteBuffer().getInt((this.offset + (36)));
    }
  
    /** Sets the def file buffer size.
        @param val The def file buffer size.
     */
    public void setFb(int val) {
      getByteBuffer().putInt((this.offset + (36)), val);
    }
  
    /** Gets the socket ID code.
        @return The socket ID code.
     */
    public int getSocket() {
      return getByteBuffer().getInt((this.offset + (40)));
    }
  
    /** Sets the socket ID code.
        @param val The socket ID code.
     */
    public void setSocket(int val) {
      getByteBuffer().putInt((this.offset + (40)), val);
    }
  
    /** Gets the in descript.
        @return The in descript.
     */
    public int getSdin() {
      return getByteBuffer().getInt((this.offset + (44)));
    }
  
    /** Sets the in descript.
        @param val The in descript.
     */
    public void setSdin(int val) {
      getByteBuffer().putInt((this.offset + (44)), val);
    }
  
    /** Gets the out descript.
        @return The out descript.
     */
    public int getSdout() {
      return getByteBuffer().getInt((this.offset + (48)));
    }
  
    /** Sets the out descript.
        @param val The out descript.
     */
    public void setSdout(int val) {
      getByteBuffer().putInt((this.offset + (48)), val);
    }
  
    /** Gets the engine status.
        @return The engine status.
     */
    public int getState() {
      return getByteBuffer().getInt((this.offset + (52)));
    }
  
    /** Sets the engine status.
        @param val The engine status.
     */
    public void setState(int val) {
      getByteBuffer().putInt((this.offset + (52)), val);
    }
  
    /** Summarizes the record.
        @return A string listing the current data in the record.
     */
    public String toString() {
      StringBuilder sb = new StringBuilder();
      sb.append("EngineStruct: {");
      sb.append(" getNode = ").append(getNode());  
      sb.append(" getFp = ").append(getFp());  
      sb.append(" getOs = ").append(getOs());  
      sb.append(" getRep = ").append(getRep());  
      sb.append(" getTl = ").append(getTl());  
      sb.append(" getPs = ").append(getPs());  
      sb.append(" getFb = ").append(getFb());  
      sb.append(" getSocket = ").append(getSocket());  
      sb.append(" getSdin = ").append(getSdin());  
      sb.append(" getSdout = ").append(getSdout());  
      sb.append(" getState = ").append(getState());  
      sb.append(" }");
      return sb.toString();
    }
  }

  //   </editor-fold>
  // </BBMakeGenCode>//GEN-END:BBMakeGenCode
}

