package nxm.sys.prim;

import nxm.sys.lib.*;
import nxm.sys.libg.*;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
  A class to view an object in a graphical window

  @author Jeff Schoen
  @version $Id: view.java,v 1.4 2008/07/19 22:19:21 jgs Exp $
*/
public class view extends GPrimitive implements ActionListener {

  MWText MWT;

  private static final int EXIT_RETURN=0x1, EXIT_MENU=0x2,
          EXIT_MESSAGE=0x4, EXIT_WINDOW=0x8, EXIT_ALL=0xF, EXIT_AUTO=0x10;
  private static final String exitList = "RETURN,MENU,MESSAGE,WINDOW,AUTO";
  boolean exiting;
  int exit;

  public int open () {

    Object obj = MA.getO("IN");
    if (obj == null) M.error("No object specified");

    int nlines = 100;
    int fontsz = MA.getL("/FONTSZ",12);
    int flags  = MJText.TEXT | MJText.BACKL | MJText.COLOR;
    exit = (M.pipeMode==Midas.PINIT)? 0 : EXIT_ALL;
    exit = MA.getOptionMask("/EXIT",exitList,exit);

    // The text window
    MWT = new MWText("View",nlines,20,60,fontsz,flags,this);
    MWT.mtext.addActionListener (this);
    MW = (MWindow) MWT;
    MW.open();
    MW.addTo(this);

    if (obj instanceof Table) {
      addTable(0,(Table)obj);
    }
    else {
      addLine(0,obj.toString());
    }
    return NORMAL;
  }

  public int process () {
    if (exiting) return FINISH;
    return NORMAL;
  }

  public int processMessage (Message msg) {
    int status = NORMAL;
         if (msg.name.equals("EXIT")) exiting = (exit&EXIT_MESSAGE)!=0;
    else if (msg.name.equals("RESIZE")) MW.resize(0);
    else if (msg.name.equals("WINDOW")) {
      String action = (String)msg.data;
      if (action.equals("CLOSING")) exiting = (exit&EXIT_WINDOW)!=0;
    }
    else status = MW.processMessage(msg);
    return status;
  }

  public int close () {
    MW.close();
    return NORMAL;
  }


  public void actionPerformed (ActionEvent ae) {
    String action = ae.getActionCommand();
    if (action.equals("BUTTON")) {
    }
    else {
    }
    System.out.println("Action "+action);
  }

  private void addTable (int indent, Table tab) {
    Table.Iterator ti = tab.iterator();
    for (;ti.getNext();) {
      if (ti.value instanceof Table) {
        addLine(indent,ti.key+" = Table");
        addTable(indent+2,(Table)ti.value);
      } else {
        addLine(indent,ti.key+"="+ti.value);
      }
    }
  }

  private void addLine (int indent, String line) {
    for (;indent>0; indent-=2) line = "  "+line;
    MWT.mtext.add(line);
  }

}
