!******************************************************************************!
! @version: $Id: optstart.mm,v 1.2 2012/06/27 17:54:26 ntn Exp $
!******************************************************************************!
startmacro

if reg.shell.isOneShot then
  ! since 3.1.3: Running under one-shot mode, so skip the info messages below,
  !              since they are meant for normal interactive mode
  stop
endif

set nextopt reg.shell.isNeXtOpt      ! TBD - Fix this when mode added to ENV.???

if nextopt then
  say "INFO: >>>> Building with NeXtOpt is enabled:"
  set fortOptions "ifc, ifort, pfc, pgf77"
else
  say "INFO: >>>> Building with XBC is enabled:"
  set fortOptions "ifc, ifort, pgf77"
endif

invoke fortcompiler nxm.sys.lib.Build.getFortranCompiler()
invoke xmarch nxm.sys.lib.Build.getXmArchType()

say "INFO: >>>>"
say "INFO: >>>> Using Fortran Compiler:            ^fortcompiler (Options: ^{fortOptions})"
say "INFO: >>>> Using X-Midas Architecture Option: ^xmarch (Options: 32BIT, 64BIT, CLASSIC)"
say "INFO: >>>>"
say "INFO: >>>> Change fflags.compiler and/or fflags.xmarch in nxm/sys/cfg/build.props to override."
say "INFO: >>>>"

endmacro
