C-----------------------------------------------------------------------
C   Description: Fortran include parameters
C
C   Authors:     RDH
C
C   Revisions:
C
C   DATE         AUTHOR          DESCRIPTION
C   -----------  --------------  ---------------------------------------
C   05/21/00     rdh         	baseline
C
C-----------------------------------------------------------------------

C /* Constants, macros, and flags */
	integer*4 FFT_RADIX_MIN, FFT_RADIX_MAX, FFT_MAX_PLANS
	parameter (FFT_RADIX_MIN = 2)
	parameter (FFT_RADIX_MAX = 8)
	parameter (FFT_MAX_PLANS = 32)

C /* FFT Configuration and Processing Flags */
	integer*4 FFT_FLAGS_NULL
	integer*4 FFT_FLAGS_REAL
	integer*4 FFT_FLAGS_COMPLEX
	integer*4 FFT_FLAGS_FORWARD
	integer*4 FFT_FLAGS_INVERSE
	integer*4 FFT_FLAGS_PACKED
	integer*4 FFT_FLAGS_UNPACKED
	integer*4 FFT_FLAGS_NONYQUIST
	integer*4 FFT_FLAGS_SCALE
	integer*4 FFT_FLAGS_INITPLANS
	integer*4 FFT_FLAGS_FREEPLANS
	integer*4 FFT_FLAGS_VALIDPLAN
	integer*4 FFT_FLAGS_OUTOFMEM 

	parameter (FFT_FLAGS_NULL      = '00000000'X)
	parameter (FFT_FLAGS_REAL      = '00000001'X)
	parameter (FFT_FLAGS_COMPLEX   = '00000002'X)
	parameter (FFT_FLAGS_FORWARD   = '00000008'X)
	parameter (FFT_FLAGS_INVERSE   = '00000010'X)
	parameter (FFT_FLAGS_PACKED    = '00000020'X)
	parameter (FFT_FLAGS_UNPACKED  = '00000040'X)
	parameter (FFT_FLAGS_NONYQUIST = '00000080'X)
	parameter (FFT_FLAGS_SCALE     = '00000100'X)
	parameter (FFT_FLAGS_INITPLANS = '10000000'X)
	parameter (FFT_FLAGS_FREEPLANS = '20000000'X)
	parameter (FFT_FLAGS_VALIDPLAN = '40000000'X)
	parameter (FFT_FLAGS_OUTOFMEM  = '80000000'X)

C /* Define the size (in bytes) of an FFT_Plan then pad a little */
	integer*4 FFT_SIZEOF_PLAN
	parameter (FFT_SIZEOF_PLAN = 512) 
