package nxm.xbc.lib;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Class to wrap an X-Midas environment for use by NeXtMidas.

  @author Jeff Schoen
  @version $Id: XEnvironment.java,v 1.3 2004/11/15 14:15:50 jgs Exp $

*/
public class XEnvironment implements Keyable,DataTypes {

  public XEnvironment () {
  }

  public Object setKey (String name, Object value) {
    byte[] type = new byte[1];
    byte[] buf;

    if (value instanceof String) {
      type[0] = ASCII;
      buf = ((String)value).getBytes();
    } else {
      Data data;
      if (value instanceof Data) data = (Data)value;
      else data = new Data(value);
      type[0] = data.type;
      buf = data.buf;
    }
    XmClient.setEnvironment(name,type,buf,buf.length);
    return value;
  }
  
  public Object getKey (String name) {
    byte[] buf = new byte[256];
    byte[] type = new byte[1];
    int len = XmClient.getEnvironment(name,type,buf,buf.length);
    if (len<0) return null;
    else if (type[0]==ASCII) return new String(buf,0,len);
    else return new Data(buf,0,len,type[0]);
  }

  private static String[] keys = {
    "OSTYPE", "OSNAME", "MACHINE", "HOST", "HOME", "LOGIN", "READID", "WRITEID", "USERID",
    "WAUX", "RAUX", "NRAUX", "NFORM", "SEED", "TOLR", "VERIFY", "DEBUG", "BEEP", "BREAK",
    "PAUSE", "MODE", "COUNT", "STATUS", "MNAME", "SPAWN", "PLOT", "PLOT2", "TOP", "LEFT",
    "HEIGHT", "WIDTH", "NMESSAGE", "NWIDGET", "NPIPE"};
  public String[] getKeys() { return keys; }

  public String toString() {
    return "X-Midas Environment";
  }

}
