package nxm.xbc.lib;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Class to wrap an X-Midas results table for use by NeXtMidas.

  @author Jeff Schoen
  @version $Id: XResults.java,v 1.3 2004/11/15 14:15:50 jgs Exp $

*/
public class XResults implements Keyable,DataTypes {

  public XResults () {
  }

  public Object setKey (String name, Object value) {
    byte[] type = new byte[1];
    byte[] buf;

    if (value instanceof String) {
      type[0] = ASCII;
      buf = ((String)value).getBytes();
    } else {
      Data data;
      if (value instanceof Data) data = (Data)value;
      else data = new Data(value);
      type[0] = data.type;
      buf = data.buf;
    }
    XmClient.setResult(name,type,buf,buf.length);
    return value;
  }
  
  public Object getKey (String name) {
    byte[] buf = new byte[256];
    byte[] type = new byte[1];
    int len = XmClient.getResult(name,type,buf,buf.length);
    if (len<0) return null;
    else if (type[0]==ASCII) return new String(buf,0,len);
    else return new Data(buf,0,len,type[0]);
  }

  public String[] getKeys() {
    int nkeys=0;
    byte[] cbuf = new byte[2048];
    int len = XmClient.getResultNames("*",cbuf,cbuf.length);
    if (len==0) return null;
    String keylist = new String(cbuf,0,len);
    Parser p = new Parser(keylist);
    return p.getArray(0);
  }

  public String toString() {
    return "X-Midas ResultsTable";
  }

}
