/*
  Native entries for the X-Midas client

  @author Jeff Schoen
  @version $Id: XmClient.c,v 1.1 2005/04/20 14:42:39 jgs Exp $
*/

#include "cdefs.h"
#include "native.h"
#include "nxm_xbc_lib_XmClient.h"

JNIEXPORT jint JNICALL Java_nxm_xbc_lib_XmClient_getCommand (JNIEnv *env, jclass clazz, 
  jobject jbuf, jint maxlen) {
  jint stat;
  jbyte *cbuf = GetArray(jbuf);
  stat = nm_getcommand (cbuf,maxlen);
  ReleaseArray(jbuf,cbuf);
  return stat;
}

JNIEXPORT void JNICALL Java_nxm_xbc_lib_XmClient_ackCommand (JNIEnv *env, jclass clazz,
  jint mode) {
  nm_ackcommand (mode);
}

JNIEXPORT jint JNICALL Java_nxm_xbc_lib_XmClient_getResultNames (JNIEnv *env, jclass clazz, 
  jstring jfilter, jobject jbuf, jint maxlen) {
  jint stat=0, offset=0, attr=0, len;
  const char *cfilter = GetString(jfilter);
  char ctype[1], cname[40], cvalue[40];
  char *cbuf = GetArray(jbuf);
  while ( m_rfilter (cfilter, cname, 40, ctype, &attr, cvalue, 40, &offset) >= 0) {
    len = strlen(cname);
    if (stat+len+1 >= maxlen) break;
    if (stat>0) { strcat(cbuf,","); stat++; }
    strcat(cbuf,cname); stat += len;
    attr=0;
  } 
  ReleaseString(jfilter,cfilter);
  ReleaseArray(jbuf,cbuf);
  return stat;
}

JNIEXPORT jint JNICALL Java_nxm_xbc_lib_XmClient_getResult (JNIEnv *env, jclass clazz, 
  jstring jname, jobject jtype, jobject jbuf, jint len) {
  jint stat; char attr;
  const char *cname = GetString(jname);
  jbyte *cbuf = GetArray(jbuf);
  jbyte *ctype = GetArray(jtype);
  stat = (jint)m_resget (cname, ctype, &attr, cbuf, len);
  ReleaseString(jname,cname);
  ReleaseArray(jtype,ctype);
  ReleaseArray(jbuf,cbuf);
  return stat;
}

JNIEXPORT jint JNICALL Java_nxm_xbc_lib_XmClient_setResult (JNIEnv *env, jclass clazz, 
  jstring jname, jobject jtype, jobject jbuf, jint len) {
  jint stat; char attr=0;
  const char *cname = GetString(jname);
  jbyte *cbuf = GetArray(jbuf);
  jbyte *ctype = GetArray(jtype);
  stat = (jint)m_resput (cname, ctype, attr, cbuf, len, 0, 0);
  ReleaseString(jname,cname);
  ReleaseArray(jtype,ctype);
  ReleaseArray(jbuf,cbuf);
  return stat;
}

JNIEXPORT jint JNICALL Java_nxm_xbc_lib_XmClient_getEnvironment (JNIEnv *env, jclass clazz, 
  jstring jname, jobject jtype, jobject jbuf, jint len) {
  jint stat; char attr;
  const char *cname = GetString(jname);
  jbyte *cbuf = GetArray(jbuf);
  jbyte *ctype = GetArray(jtype);
  stat = (jint)nm_getenv (cname, ctype, cbuf, len);
  ReleaseString(jname,cname);
  ReleaseArray(jtype,ctype);
  ReleaseArray(jbuf,cbuf);
  return stat;
}

JNIEXPORT jint JNICALL Java_nxm_xbc_lib_XmClient_setEnvironment (JNIEnv *env, jclass clazz, 
  jstring jname, jobject jtype, jobject jbuf, jint len) {
  jint stat; char attr=0;
  const char *cname = GetString(jname);
  jbyte *cbuf = GetArray(jbuf);
  jbyte *ctype = GetArray(jtype);
  stat = (jint)nm_setenv (cname, ctype, cbuf, len);
  ReleaseString(jname,cname);
  ReleaseArray(jtype,ctype);
  ReleaseArray(jbuf,cbuf);
  return stat;
}

